SystemOrganization addCategory: #SqueakSVN!
SystemOrganization addCategory: #'SqueakSVN-AcceptanceTests'!
SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Base-Test'!
SystemOrganization addCategory: #'SqueakSVN-Requests'!
SystemOrganization addCategory: #'SqueakSVN-Requests-Test'!
SystemOrganization addCategory: #'SqueakSVN-Serializing'!
SystemOrganization addCategory: #'SqueakSVN-Serializing-Test'!
SystemOrganization addCategory: #'SqueakSVN-TestBase'!
SystemOrganization addCategory: #'SqueakSVN-TestBase-Test'!
SystemOrganization addCategory: #'SqueakSVN-TestCategory'!
SystemOrganization addCategory: #'SqueakSVN-OBSystemBrowser'!
SystemOrganization addCategory: #'SqueakSVN-UITests'!
SystemOrganization addCategory: #'SqueakSVN-Tools'!
SystemOrganization addCategory: #'SqueakSVN-Tools-Nodes'!
SystemOrganization addCategory: #'SqueakSVN-Commands'!
SystemOrganization addCategory: #'SqueakSVN-Environment'!
SystemOrganization addCategory: #'SqueakSVN-Environment-Test'!

Morph subclass: #SVNObservingMorph
	instanceVariableNames: 'process ppro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNObservingMorph methodsFor: 'menus' stamp: 'rkrk 3/16/2008 06:57'!
changeColor

	| mgr ratio |
	mgr := SVNTestDirectoryManager getInstance.
	(mgr basicTestDirectories size = 0 or: [mgr svnAwareTestDirectories size = 0])
		ifTrue: [^ Color blue].
	ratio := mgr numberOfCleanBasicTestDirectories < mgr numberOfCleanSvnAwareTestDirectories
		ifTrue: [mgr numberOfCleanBasicTestDirectories / mgr basicTestDirectories size]
		ifFalse: [mgr numberOfCleanSvnAwareTestDirectories / mgr svnAwareTestDirectories size].
	self color: (Color r: 1 - ratio g: ratio b: 0).! !

!SVNObservingMorph methodsFor: 'as yet unclassified' stamp: 'rkrk 3/16/2008 03:47'!
correctPosition

	self position: self world position x @ (self world height - self height).! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:01'!
handlesMouseDown: evt

	^ true! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:02'!
mouseDown: evt

	SVNTestDirectoryManager reCreate! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rt 3/20/2008 16:07'!
start

	process := [
		[self
			correctPosition;
			changeColor.
		(Delay forSeconds: 5) wait] repeat
	] forkAt: Processor userBackgroundPriority.! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rkrk 3/16/2008 04:03'!
stop

	process terminate.! !

OBReadOnlyDefinition subclass: #OBSVNBlameDefinition
	instanceVariableNames: 'blame blameArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNBlameDefinition methodsFor: 'accessing' stamp: 'cop 3/6/2008 13:28'!
blame
	^blame! !

!OBSVNBlameDefinition methodsFor: 'accessing' stamp: 'cop 4/3/2008 13:24'!
blameArray
	^blameArray! !

!OBSVNBlameDefinition methodsFor: 'initialize-release' stamp: 'cop 3/6/2008 12:58'!
initialize
	super initialize.
	blame := false.! !

!OBSVNBlameDefinition methodsFor: 'callbacks' stamp: 'cop 4/3/2008 13:23'!
setBlameArray: anArray
	blameArray := anArray.
	blame := true.! !

OBDefinitionPanel subclass: #OBSVNDefinitionPanel
	instanceVariableNames: 'codeTabPanel morph contentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNDefinitionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 17:16'!
buildOn: aBuilder
	morph ifNil: [morph := aBuilder panelArea: self with: []].
	^morph! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:08'!
changeToTable
	( (contentMorph isKindOf: OBPluggableTextMorph) or: [contentMorph isKindOf: OBPluggableTextMorphWithShout])
		ifTrue: [ self removeDependent: contentMorph.
				 ^self exchangeContentWith: self createTableMorph. ]! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:32'!
changeToText
	( contentMorph isKindOf: PluggableMultiColumnListMorph )
		ifTrue: [ | tempMorph |
				 tempMorph := self createTextMorph.
				 self exchangeContentWith: tempMorph.
				 self addDependent: tempMorph.
				 tempMorph refreshWorld ]! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'rkrk 4/10/2008 14:51'!
createContentMorph

	^ self createTextMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'rkrk 4/10/2008 14:51'!
createTableMorph

	| tableMorph |
	tableMorph := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: nil
				changeSelected: nil.
	tableMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^tableMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'cop 4/7/2008 15:35'!
createTextMorph
	| textMorph |
	textMorph := self textMorphClass 
				on: self
				text: #text
				accept: #accept:notifying:
				readSelection: #selection
				menu: #menu:shifted:. 
	textMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^textMorph! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 4/7/2008 17:22'!
definition
	^definition! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 11:29'!
definitionChanged: ann
	definition := ann definition.
	self handleDefinition.
	self changed: #text! !

!OBSVNDefinitionPanel methodsFor: 'as yet unclassified' stamp: 'cop 4/8/2008 12:18'!
exchangeContentWith: aMorph
    morph removeMorph: contentMorph. 
    aMorph vResizing: #spaceFill. 
    aMorph hResizing: #spaceFill.
    contentMorph := aMorph. 
    morph addMorphBack: contentMorph.
    contentMorph changed.! !

!OBSVNDefinitionPanel methodsFor: 'model access' stamp: 'cop 4/8/2008 11:43'!
getListSize
	^0! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:10'!
handleDefinition
	(self definition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^ self changeToText ]
				ifTrue: [^ self changeToTable ]! !

!OBSVNDefinitionPanel methodsFor: 'testing' stamp: 'rkrk 4/10/2008 14:51'!
hasReferencePanel

    ^ browser class hasReferencePanel! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/8/2008 11:22'!
list
	(self definition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^Array new ]
				ifTrue: [^self definition blameArray ]! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 12:15'!
selectionChanged: ann
	self changeToText.
	super selectionChanged: ann.! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 4/8/2008 12:10'!
setContentMorph: aMorph
    contentMorph := aMorph! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 12:15'!
subscribe
	self announcer 
		observe: OBDefinitionChanged 
		send: #definitionChanged:
		to: self.
	self announcer 
		observe: OBSelectionChanged 
		send: #selectionChanged:
		to: self! !

!OBSVNDefinitionPanel methodsFor: 'configuration' stamp: 'cop 4/8/2008 12:09'!
textMorphClass
	| shoutInstalled |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	^shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 04:24'!
belongsToCurrentSvnProject

	^ false! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:51'!
commentsOfUsedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 11:54'!
currentSvnProject

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment currentProject.! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:22'!
hasSvnElementOfKind: aClass

	^ self svnElement notNil and: [self svnElement isKindOf: aClass]! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:53'!
metaclassesOfUsedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 03:58'!
svnElement

	^ nil! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 03:42'!
svnEnvironment

	"Ugly solution. Somehow nodes have to know their svnEnvironment.
	In the momenr there is a filter added to all OBMetaNodes which are build in
	a OBSVNSystemBrowser."
	| environmentFilter |
	environmentFilter := self metaNode filters
		detect: [:ea | ea isKindOf: SVNOBEnvironmentFilter]
		ifNone: [^ nil].
	^ environmentFilter svnEnvironment.! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:51'!
usedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!String methodsFor: '*SqueakSVN' stamp: 'rkrk 3/26/2008 15:48'!
forSvnPrimitive

	^ {(self , (Character value: 0) asString) convertToSystemString} asOrderedCollection.! !

!String methodsFor: '*SqueakSVN' stamp: 'test 3/26/2008 00:07'!
pathForSvn

	| modifiedPath returnPath |
	self flag: #TODO.
	modifiedPath := self collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]].
	(modifiedPath endsWith: '/')
		ifFalse: [returnPath := modifiedPath]
		ifTrue: 	[returnPath := modifiedPath copyFrom: 1 to: modifiedPath size - 1].
	((returnPath at: 4) = $/) ifFalse: [^returnPath].
	^ (returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

OBCmdMultiView subclass: #OBSVNCmdMultiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNCmdMultiView methodsFor: 'execution' stamp: 'cop 4/7/2008 16:09'!
execute
	|viewType labels |
	labels := #(Source Bytecode Decompile PrettyPrint).
	(target isKindOf: OBMethodNode) ifTrue:
		[labels := labels, #(#Blame).].
	viewType := OBChoiceRequest labels: labels.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 4/7/2008 17:36'!
setBlameArrayInDefinitionPanelForBlame: anArray

	(requestor announce: OBAboutToChange) isVetoed
		ifFalse: [requestor
				announce: (OBSVNBlameDefinition new setBlameArray: anArray;
							 yourself)]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 4/7/2008 18:44'!
toggleBlame
	| method aSVNMethod |
	method := target theClass lookupSelector: target selector.
	method ifNil: [^ nil ].
	SVNProject allInstances isEmpty ifTrue: [^nil].
	aSVNMethod := (SVNProject allInstances last allVersionedMethods like: (SVNMethod forExistingMethod: method)).
	aSVNMethod ifNil: [^nil].
	self setBlameArrayInDefinitionPanelForBlame: (SVNBlameStyler createArrayFromBlameLines: aSVNMethod blame).! !

OBMetagraphBuilder subclass: #OBSVNMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:21'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBSVNStatusIconClassFilter new! !

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 4/12/2008 22:01'!
populateMetaclassNode

     super populateMetaclassNode.
	(self metaclassMetaNode)
		addFilter: OBSVNStatusIconClassFilter new.! !

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:19'!
populateMethodNode

	self methodMetaNode 
		ancestrySelector: #isDescendantOfMethod:; "What's that? 'Needed??"
		addFilter: OBSVNStatusIconMethodFilter new! !

!Class methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 05:38'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnClassFor: self) notNil! !

!OBMorphBuilder methodsFor: '*SqueakSVN' stamp: 'cop 4/8/2008 17:21'!
panelArea: aDefinitionPanel with: aBlock 
	| morph definitionMorph textMorph |
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself. 
			
	definitionMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;	
		minWidth: 300;	
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.     

	textMorph := aDefinitionPanel createContentMorph.		
     aDefinitionPanel setContentMorph: textMorph.		
	definitionMorph addMorphBack: textMorph.	
	morph addMorphBack: definitionMorph.
			
	current ifNotNil: [current addMorphBack: morph].
	self current: morph do: aBlock.
     ^definitionMorph! !

!OBMorphBuilder methodsFor: '*SqueakSVN' stamp: 'rkrk 4/7/2008 22:33'!
svnPane: aColumn with: aBlock 
	| pane divider |
	pane := OBPane new.
	pane
		model: aColumn;
		height: Preferences standardCodeFont height * 3.2;
		vResizing: #rigid;
		hResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self listMorphForColumn: aColumn).
	"current ifNotNil: [current pushPane: pane]."
"	self halt."
	current ifNotNil: 
		[current addMorphBack: pane.
			self current: pane do: aBlock.
			divider := (BorderedSubpaneDividerMorph horizontal)
				color: aColumn browser defaultBackgroundColor duller;
				styleWith: OBMorphBuilder new.
			current addMorphBack: divider].
	^ pane! !

!MethodReference methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 22:33'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnMethodForMethodRef: self) notNil! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: 'sut hasTouchedFileSystem hasModifiedSVNDummy directoryManager slash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClassTest subclass: #PoolDictionariesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
nameOfPoolDictionary
	^ 'TestStoringAndRestoringOfPoolDictionariesClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:17'!
nameOfTestClass
	^ 'PoolDictionariesTestClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
setUp
	
	super setUp.
	
	self willTouchFileSystem.
	self willNeedRepositoryAndWorkingCopy.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	Smalltalk at: (self nameOfPoolDictionary asSymbol) put: (Dictionary new).
	
	Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: self nameOfPoolDictionary
		category: self class category asString.! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/17/2008 15:12'!
tearDown

	super tearDown.
	
	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 21:02'!
testStoringAndRestoringOfPoolDictionaries

	| svnProject |
	svnProject := SVNProject checkoutProject: 'TestPro' fromURL: self repositoryURLPath inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	
	svnProject addClass: (Smalltalk classNamed: self nameOfTestClass).
	svnProject commit.

	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	self deny: (Smalltalk classNamed: self nameOfTestClass) notNil.
	
	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	
	"restore"
	(SVNCommandLineClient new) executeViaOSProcessSynchronously: 'svn revert -R ', svnProject directory path.
	svnProject restoreFrom: (svnProject directory) read.
	svnProject load.
	
	"check"
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) notNil.
	self assert: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	self assert: (Smalltalk at: self nameOfTestClass asSymbol) poolDictionaryNames = (OrderedCollection with: self nameOfPoolDictionary asSymbol).! !

!SVNClassTest methodsFor: 'assertion' stamp: 'rkrk 4/1/2008 18:14'!
assertDirectoryEntriesEstablishedIn: svnClass

	| rootDir |
	self flag: #TODO. "Mapping details"
	rootDir := svnClass directory.
	rootDir theName = svnClass theName.
	
	self assert: (rootDir directoryExists: 'class').
	self assert: (rootDir directoryExists: 'instance').
	"class details"
	self assert: (rootDir fileExists: 'category').
	self assert: (rootDir fileExists: 'classInstanceVariables').
	self assert: (rootDir fileExists: 'classVariables').
	self assert: (rootDir fileExists: 'comment').
	self assert: (rootDir fileExists: 'instanceVariables').
	self assert: (rootDir fileExists: 'poolDictionaries').
	self assert: (rootDir fileExists: 'superclass').! !

!SVNClassTest methodsFor: 'assertion' stamp: 'rt 3/10/2008 13:18'!
assertSVNClass: aSVNClass hasStateFromSystemClass: aClass 
	| instanceMethodSelectors expectedMethodSelectors classMethodSelectors expectedclassMethodSelectors |
	self assert: aSVNClass theName = aClass name.
	self assert: aSVNClass superclassName = aClass superclass name.
	self assert: aSVNClass instanceVariables = aClass instVarNames.
	self assert: aSVNClass classVariables = aClass classVarNames.
	self assert: aSVNClass classInstanceVariables = aClass class instVarNames.
	self assert: aSVNClass comment = aClass comment.
	self assert: aSVNClass category = aClass category.
	self flag: #TODO.
	"Implementation details about the file mapping
	are spread here"
	instanceMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass not])
				collect: [:each | each theName].
	expectedMethodSelectors := aClass methodDict
				collect: [:each | each selector asString].
	self assert: instanceMethodSelectors asSet = expectedMethodSelectors asSet.
	classMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass])
				collect: [:each | each theName].
	expectedclassMethodSelectors := aClass class methodDict
				collect: [:each | each selector asString].
	self assert: classMethodSelectors asSet = expectedclassMethodSelectors asSet! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 4/15/2008 00:35'!
configureSVNClass: svnClass forLoadingClassNamed: aString 
	
	self assert: (Smalltalk hasClassNamed: aString) not.
	svnClass
		theName: aString asString;
		superclassName: 'Object';
		instanceVariables: #('a');
		classVariables: #('A');
		classInstanceVariables: #('b');
		poolDictionaries: #();
		comment: '';
		category: self class category.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 18:31'!
testAddMethod

	"setup"
	| className svnMethod1 svnMethod2 |
	sut := SVNClass new.
	className := 'PleaseDoNotExist'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: className.
	sut establishSvnFilesAndDirectories.
	svnMethod1 := SVNMethod new
		theName: 'blabla';
		nameOfClass: className;
		establishSvnFilesAndDirectories;
		yourself.
	svnMethod2 := SVNMethod new
		theName: 'blabla';
		nameOfClass: className , ' class';
		establishSvnFilesAndDirectories;
		yourself.
	"exercise"
	sut
		addMethod: svnMethod1;
		addMethod: svnMethod2.
	"assert"
	self assert: (sut versionedMethods includes: svnMethod1).
	self assert: (sut versionedMethods includes: svnMethod2).
	self assert: ('*' , className , '*' match: svnMethod1 file basePath).
	self assert: ('*instance*' match: svnMethod1 file basePath).
	self assert: ('*class*' match: svnMethod2 file basePath).! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 4/2/2008 17:39'!
testAllClassMethodsExists

	| expectedFileNames class directoryOfMethods actualFileNames |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	self defaultSVNDirectory addSubdirectory: sut directory.
	sut store.
	self flag: #TODO. "Mapping implementation is spread here..."
	directoryOfMethods := (sut directory getSubDirectoryNamed: 'class').
	"expected"
	expectedFileNames := (class class methodDict collect: [:each | each selector asString]) asSet.
	"assert"
	actualFileNames := directoryOfMethods files collect: [:each | each theName].
	self assert: expectedFileNames asSet = actualFileNames asSet.! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 4/2/2008 17:40'!
testAllInstanceMethodsExists

	| expectedFileNames class classDirectory directoryOfMethods actualFileNames |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	self defaultSVNDirectory addSubdirectory: sut directory.
	sut store.
	classDirectory := sut directory.
	self flag: #TODO.
	"Mapping implementation is spread here..."
	directoryOfMethods := classDirectory getSubDirectoryNamed: 'instance'.
	self assert: directoryOfMethods notNil.
	expectedFileNames := (class methodDict
				collect: [:each | each selector asString]) asSet.
	actualFileNames := directoryOfMethods files
				collect: [:each | each theName].
	self assert: expectedFileNames = actualFileNames asSet! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 18:06'!
testCreatingForExistingClassInitializesSVNClassCorrectly

	| class |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.
	self assertDirectoryEntriesEstablishedIn: sut
		! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 4/2/2008 17:41'!
testCreatingForSerializedClassInitializesSVNClassCorrectly

	| class classFilesCreator |
	class := self svnDummy.
	classFilesCreator := SVNClass forExistingClass: class.
	self defaultSVNDirectory addSubdirectory: classFilesCreator directory.
	classFilesCreator store.
	sut := SVNClass restoreFrom: classFilesCreator directory..
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 01:32'!
testDeleteClass

	| svnClass class |
	"This test makes no sense!! svnClass theClass = Smalltalk classNamed: bla!!!!!!"
	class := Object
				subclass: #OnlyForThisTest
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self class category asString.
				
	svnClass := SVNClass forExistingClass: class.
	class removeFromSystem.
	
	self assert: (svnClass theClass isNil).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:08'!
testEqual

	| class sut1 sut2 |
	class := self svnDummy.
	sut1 := SVNClass forExistingClass: class.
	sut2 := SVNClass forExistingClass: class.
	self assert: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rt 3/8/2008 22:45'!
testGetSVNMethodsFromClass

	| class expectedInstanceMethods expectedClassMethods |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	expectedInstanceMethods := class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	expectedClassMethods := class class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	self assert: sut versionedMethods = (expectedInstanceMethods union: expectedClassMethods) asSet.
	"self assert: sut methods = expectedInstanceMethods asSet.
	self assert: sut classMethods = expectedClassMethods asSet."! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 4/1/2008 01:35'!
testLoadClass
	
	| className |
	sut := SVNClass new.
	className := 'SVNDummy99'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: className.
	[sut load.
	self assert: (Smalltalk hasClassNamed: className).
	self flag: #TODO. "Test for the correct initialization of
	variables and comment	of the created class!!"
	] ensure: [Smalltalk
				at: className asSymbol
				ifPresent: [:class | class removeFromSystemUnlogged]].! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 3/4/2008 06:52'!
testLoadExistingClassAndRestoreDeletedMethod
	
	| class methodSelector |
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNClass forExistingClass: class.
	sut notifyAboutSystemModifications: false.
	class removeSelector: methodSelector.
	sut load.
	self assert: (self svnDummy selectors includes: methodSelector).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rt 3/25/2008 19:07'!
testLoadingAExistingClassWithoutAMethodShouldRemoveTheMethod

	| class methodSelector |
	self flag: #TODO. "why ? a class with unversioned methods should not lose all methods."
	self willModifySVNDummy.
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNClass forExistingClass: class.
	self assert: (class selectors includes: methodSelector).
	sut removeSVNMethod: (SVNMethod forExistingMethod: class >> methodSelector).
	sut load.
	self deny: (class selectors includes: methodSelector).
	self restoreSVNDummy.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:08'!
testNotEqual

	| sut1 sut2 |
	sut1 := SVNClass forExistingClass: self svnDummy.
	sut2 := SVNClass forExistingClass: self class.
	self deny: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:55'!
testRemoveClassFromVersioningControl

	| svnProject svnClass |
	self flag: #TODO.
	self willTouchFileSystem.
	svnProject := SVNProject named: 'TestPro'.
	svnProject directory: (self defaultSVNDirectory createSubDirectoryNamed: svnProject theName).
	svnClass := SVNClass forExistingClass: self svnDummy.
	svnProject addSVNClass: svnClass.
	
	svnProject removeClass: self svnDummy.
	
	self deny: (svnProject versionedClasses includes: svnClass).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 03:49'!
testRemoveMethod

	| svnMethod class |
	self willModifySVNDummy.
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	svnMethod := sut versionedMethods
		detect: [:ea | ea theName = 'm2']
		ifNone: [self assert: false].
	sut removeSVNMethod: svnMethod.
	self deny: (sut versionedMethods includes: svnMethod).! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 4/1/2008 01:36'!
testWriteClassDetails

	! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 4/2/2008 17:41'!
testWriteCommentFile

	| expectedFileName createdFile |
	sut := SVNClass forExistingClass: self svnDummy.
	self defaultSVNDirectory addSubdirectory: sut directory.
	sut store.
	expectedFileName := sut nameForCommentFile.
	self assert: (sut directory fileExists: expectedFileName).
	createdFile := sut directory getFileNamed: expectedFileName.
	self assert: self svnDummy comment = createdFile content.! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: 'fileToAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/13/2008 22:07'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:01'!
tearDown
	super tearDown.
	"self halt."! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 3/20/2008 13:57'!
testCleanupDirectory

	| workingDir |
	workingDir := FileDirectory on: self workingCopyPath , self slash , '.svn'.
	(workingDir fileNamed: 'lock') close.
	self assert: (workingDir fileExists: 'lock').
	
	sut svnCleanupDirectory: self workingCopyPath.
	
	self deny: (workingDir fileExists: 'lock').! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 4/3/2008 16:00'!
testCountOfCommitLogs

	| path file |
	path := self workingCopyPath.
	self assert: 1 = (sut svnGetCountOfCommitLogsFrom: path).
	
	file := path, self slash, 'fileToAdd'.
	self createFile: file.
	sut svnAdd: file.
	sut svnCommit: {file}.
	
	self assert: 2 = (sut svnGetCountOfCommitLogsFrom: path).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 4/3/2008 16:01'!
testCountOfCommitLogsIfTargetIsUnversioned

	| file |
	file := self workingCopyPath , self slash , 'aFile'.
	self createFile: file.
	self assert: 0 = (sut svnGetCountOfCommitLogsFrom: file).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:30'!
testGetHeadRevision

	self assert: (sut svnGetHeadRevision: self workingCopyPath) = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:18'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 02:08'!
testSvnAddPropertyWithValueTo

	| path fstream propertyPath propertiesContents |
	path := self workingCopyPath , self slash , fileToAdd.
	propertyPath := FileDirectory on: self workingCopyPath , self slash ,'.svn', self slash, 'props'.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	
	fstream := propertyPath readOnlyFileNamed: 'testFile.svn-work'.
	propertiesContents := fstream contents.
	fstream close.
	
	self assert: (propertiesContents includesSubString: 'propertyName').
	self assert: (propertiesContents includesSubString: 'value').
	! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:41'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: {workingCopyPath , self slash , fileToAdd}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnCheckoutRevisionByNumber

	"create new revisions"
	| firstFileName pathToFirstFile secondFileName pathToSecondFile workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	firstFileName := 'fileForFirstRevision'.
	pathToFirstFile := workingCopyPath , self slash , firstFileName.
	self createFile: pathToFirstFile.
	self assertThatFiles: {firstFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToFirstFile.
	sut svnCommit: {pathToFirstFile}.
	
	secondFileName := 'fileForSecondRevision'.
	pathToSecondFile := workingCopyPath , self slash , secondFileName.
	self createFile: pathToSecondFile.
	self assertThatFiles: {secondFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.
	
	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	self assert: (workingcopyDirectory fileExists: firstFileName).
	self deny: (workingcopyDirectory fileExists: secondFileName).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:30'!
testSvnCommit

	| path startRevision endRevision |
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: {path , self slash , fileToAdd}.

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'pe 3/19/2008 13:31'!
testSvnCommitWithMessageAndRevsionNumber
	| path commitLog message message1 stream |
	message := 'this is a log message'.
	message1 := 'this is another logMessage'.

	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	
	"Commit the file, than change its contents and commit it a second time"
	sut svnCommit: {  (path , self slash , fileToAdd)}
		withMessage: message.
	stream := FileStream fileNamed: path , self slash , fileToAdd.
	stream
		nextPutAll: '123';
		close.
	sut svnCommit: {  (path , self slash , fileToAdd)}
		withMessage: message1.
	
	"self halt."
	 
	"read the CommitLogs from the repository and assert them"
	commitLog := ((sut svnGetCommitLogFrom: path , self slash , fileToAdd) at:1) comment.
	self assert: ((sut svnGetCommitLogFrom: path , self slash , fileToAdd) at:1) revision = 1.
	self assert: commitLog = message.
	commitLog := ((sut svnGetCommitLogFrom: path , self slash , fileToAdd) at:2) comment.
	self assert: ((sut svnGetCommitLogFrom: path , self slash , fileToAdd) at:2) revision = 2.
	self assert: commitLog = message1.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:34'!
testSvnDeleteFromWorkingCopyWithCommittedItems

	| file dir |
	file := self workingCopyPath , self slash , 'file'.
	dir := self workingCopyPath , self slash , 'dir'.
	
	self createFile: file.
	(FileDirectory on: dir) assureExistence.
	
	sut svnAdd: file.
	sut svnAdd: dir.
	sut svnCommit: {file. dir}.
	
	sut svnDeleteTargetsFromWorkingCopy: {file. dir}.
	
	self assert: (FileDirectory new directoryExists: dir).
	self deny: (FileDirectory new fileExists: file).
	
	sut svnCommit: {dir. file}.
	
	self deny:
			((FileDirectory new fileExists: file) or:
			[(FileDirectory new directoryExists: dir)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnDeleteFromWorkingCopyWithUncommittedItems

	| file1 file2 dir1 dir2 workingCopyPathTemplate |
	workingCopyPathTemplate := self workingCopyPath , self slash.
	file1 := workingCopyPathTemplate , 'file1'.
	file2 := workingCopyPathTemplate , 'file2'.
	dir1 := workingCopyPathTemplate , 'dir1'.
	dir2 := workingCopyPathTemplate , 'dir2'.
	
	self createFile: file1.
	self createFile: file2.
	(FileDirectory on: dir1) assureExistence.
	(FileDirectory on: dir2) assureExistence.
	
	sut svnAdd: file2.
	sut svnAdd: dir2.
	
	sut svnDeleteTargetsFromWorkingCopy: {file1. file2. dir1. dir2}.
	
	self deny:
			((FileDirectory new fileExists: file1) or:
			[(FileDirectory new fileExists: file2)] or:
			[(FileDirectory new directoryExists: dir1)] or:
			[(FileDirectory new directoryExists: dir2)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 3/27/2008 17:40'!
testSvnGetBlameLinesFor
	
	| pathToFile firstLine secondLine blameLines |	
	"Prepare the lines"
	firstLine := 'A line'.
	secondLine := 'Another line'.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: self workingCopyPath.
	
	"Write something into the testFile"
	self inFile: pathToFile write: firstLine, String cr.
	
	"Add it and commit it"
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.

	"Commit next line"
	self inFile: pathToFile write: firstLine, String cr, secondLine.
	sut svnCommit: {pathToFile}.
	
	"Get blame lines"
	blameLines := sut svnGetBlameLinesFrom: pathToFile.

	"check if succeeded"
	self assert: (blameLines isEmpty not ).
	self assert: ((blameLines at: 1) = '1' ).
	self assert: ((blameLines at: 2) = 'DEFAULTUSER' ).
	self assert: ((blameLines at: 4) = '0' ).
	self assert: ((blameLines at: 5) = firstLine ).
	self assert: ((blameLines at: 6) = '2' ).
	self assert: ((blameLines at: 7) = 'DEFAULTUSER' ).
	self assert: ((blameLines at: 9) = '1' ).
	self assert: ((blameLines at: 10) = secondLine ).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'test 3/20/2008 04:58'!
testSvnGetPropertyFrom

	| path property properties |
	
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.

	properties := sut svnGetPropertiesFrom: path.
	property := properties
		at: 'propertyName'
		ifAbsent: [self assert: false].
	
	self assert: (property = 'value').! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 3/20/2008 11:17'!
testSvnRevert

	| file text |
	file := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: file.
	sut svnCommit: {file}.
	
	FileStream 
		forceNewFileNamed: file
		do: [:stream | stream nextPutAll: 'content'].
	
	sut svnRevertTargets: {file}.
	
	FileStream 
		readOnlyFileNamed: file
		do: [:stream | text := stream contents.].
	
	self deny: text size ~= 0.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:38'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory pathToFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: {workingCopyPath}.
	
	"check if succeeded"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:38'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile pathToFile pathToSecondFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create new revisions"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.
	
	secondFile := 'fileForSecondRevision'.
	pathToSecondFile := self pathTo: secondFile inDir: workingCopyPath.
	self createFile: pathToSecondFile.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.

	"recover the first revision"
	sut 
		svnUpdateTargets: {workingCopyPath}
		toRevisionByNumber: 1.

	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile)! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:06'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopy.
	
	fileToAdd := 'testFile'.
	self createFile: self workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 2/26/2008 13:25'!
testCommandForAddProperty


	| key value path result expected |
	sut := SVNCommandLineClient new.
	key := 'irgendEinKey'.
	value := 'irgendEinValue'.
	path := SmalltalkImage current imagePath.
	result := sut buildCmdPropset: key value: value for: path.
	expected := 'svn propset ' , key , ' ' , value , ' ' , path.
	self assert: result = expected.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:19'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:49'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 4/11/2008 13:10'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnCommit

	| path startRevision endRevision |
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: self workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: self workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/24/2008 23:55'!
setUp

	super setUp.
	sut := SVNClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:04'!
testBackslashToSlash

	| validPath |
	validPath := 'C:\test\test' pathForSvn.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:05'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := 'C:\\test\test' pathForSvn.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:05'!
testRemoveLastSlash

	| path |
	path := 'C:\test\test\' pathForSvn.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNCommitLogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNCommitLogTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 16:18'!
testRevisionAuthorDateString
	
	| commitLogString aCommitLog |
	aCommitLog := SVNCommitLog
		createCommitLogWithRevision: 1 
		author: 'Michi' 
		date: (DateAndTime year: 2008 month: 01 day: 01 hour: 01 minute: 00) 
		comment: 'aComment'.
	
	commitLogString := aCommitLog revisionAuthorDateString.
	
	self assert: '1 - Michi 1 January 2008 1:00 am' = commitLogString! !

SVNTestCase subclass: #SVNCreateNewProjectAndCommitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:08'!
createClassNamed: nameOfClass

	^ Object
		subclass: nameOfClass asSymbol
		instanceVariableNames: 'i1'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM1For: class

	class compile: 'm1' , String cr , '^ ''Heeeee Yaaaahhhhhhh'''.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM2For: class

	class compile: 'm2: argument' , String cr , '^ argument asString'.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/4/2008 02:18'!
nameOfAClass
	^ 'ClassCreatedInSVNAccepatanceTests'! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'running' stamp: 'rkrk 3/4/2008 05:40'!
tearDown

	super tearDown.
	Smalltalk
		at: self nameOfAClass asSymbol
		ifPresent: [:class | class removeFromSystemUnlogged].
	self flag: #TODO.
	self restoreSVNDummy.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:28'!
test01

	| svnProject class workingCopyDir readSVNProject projectName readDirectory |
	self flag: #TODO. "Merge with test02"
	self willNeedRepositoryAndWorkingCopy.
	"Create new project. Create new class. Add it to the project and commit."
	projectName := 'NewProject'.
	svnProject := SVNProject named: projectName.
	class := self createClassNamed: self nameOfAClass.
	self createMethodM1For: class.
	self createMethodM2For: class.
	"self halt."
	workingCopyDir := SVNDirectory on: self workingCopyPath.
	svnProject
		directory: (workingCopyDir createSubDirectoryNamed: projectName);
		addClass: class;
		commit.
	"Read the project"
	readDirectory := SVNDirectory named: projectName basePath: self workingCopyPath.
	readDirectory read.
	readSVNProject := SVNProject restoreFrom: readDirectory.
	
	self assert: readSVNProject = svnProject.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'cop 4/14/2008 11:51'!
test02

	| svnProject newSVNProject svnClass newWorkingCopyDirectory newWorkingCopyPath |
	self willNeedRepositoryAndWorkingCopy.
	"create and modify a SVNProject"
	svnClass := SVNClass
		name: self nameOfAClass
		superclassName: 'Object'
		instanceVariables: {}
		classVariables: Set new
		classInstanceVariables: {}
		poolDictionaries: OrderedCollection new
		comment: ''
		category: 'neu'.
	"define a working copy directory"
	svnProject := SVNProject checkoutProject: 'TestProject' fromURL: self repositoryURLPath inWorkingCopy:  (SVNDirectory on: self workingCopyPath).
	svnProject addSVNClass: svnClass.
	"commit the changes"
	svnProject commit.
	"self halt."
	"delete project and working copy"
	svnProject unload.
	self deny: (Smalltalk hasClassNamed: self nameOfAClass).
	"checkout the project in a new working copy"
	newWorkingCopyPath := self pathForTests , self slash , 'newWorkingCopy'.
	newWorkingCopyDirectory := SVNDirectory on: newWorkingCopyPath.
	newSVNProject := SVNProject
		checkoutProject: 'TestProject' 
		fromURL: self repositoryURLPath
		inWorkingCopy: newWorkingCopyDirectory.
	"load it into the system"
	newSVNProject load.
	"check if the old state is restored"
	self assert: (Smalltalk hasClassNamed: self nameOfAClass).
	self flag: #TODO. "Check if methods are there"! !

SVNTestCase subclass: #SVNCreateProjectDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UITests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rkrk 3/4/2008 02:10'!
fullPath

	^ FileDirectory fullPathForURI: ''! !

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rkrk 4/7/2008 13:12'!
setUp

	super setUp.
	sut := SVNCreateProjectDialog new
		svnProject: (SVNProject named: '');
		yourself.! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:10'!
testWorkingCopyPath

	| path |
	path := self fullPath , 'workingCopy'.
	self assert: (sut setProjectWorkingCopyPath: path).
	self assert: (path = sut projectWorkingCopyPath).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:12'!
testWorkingCopyPathRelative

	| path |
	path := 'workingCopy'.
	self assert: (sut setProjectWorkingCopyPath: path).
	self assert: (sut projectWorkingCopyPath = (self fullPath , path)).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 16:01'!
testWorkingCopyPathWithBackSlash

	| fullpath path |
	path := 'workingCopy' , self slash , 'subdir'.
	
	sut setProjectWorkingCopyPath: path.
	fullpath := self fullPath , path.
	
	self assert: fullpath = sut projectWorkingCopyPath.! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:13'!
testWorkingCopyPathWithSlash

	| path fullpath |
	path := './workingCopy/subdir'.
	
	self assert: (sut setProjectWorkingCopyPath: path).
	fullpath := self fullPath , 'workingCopy' , self slash , 'subdir'.
	
	self assert: fullpath = sut projectWorkingCopyPath.! !

SVNTestCase subclass: #SVNDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNDirectoryTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNDirectory
		named: 'svnDirectoryWhichIsTested'
		basePath: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 3/13/2008 14:31'!
testAddDirectory

	| directoryName |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 3/5/2008 01:33'!
testAddFilesWithPropertiesWhichAreInTheEndEqual

	| filename assoc |
	sut := SVNDirectory
		named: 'svnDir'
		basePath: self pathForTests.
	filename := 'fileName'.
	assoc := 'key' -> 'value'.
	(sut createFileNamed: filename) properties add: assoc.
	(sut createFileNamed: filename) properties add: assoc.

	self assert: sut files size = 1.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 4/1/2008 19:09'!
testAddSubdirectories

	| dir1 dir2 |
	"setup"
	sut := SVNDirectory
		named: 'rootDir'
		basePath: self pathForTests.
	dir1 := SVNDirectory named: 'depth1'.
	dir2 := SVNDirectory named: 'depth2'.
	dir1 addSubdirectory: dir2.
	"exercise"
	sut addSubdirectory: dir1.
	"assert"
	self assert: sut path = dir1 basePath.
	self assert: dir1 path = dir2 basePath.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 4/1/2008 19:04'!
testAddTwoTimesTheSameFile

	| file |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	file := SVNFile named: 'test'.
	sut
		addFile: file;
		addFile: file.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'test 4/2/2008 16:53'!
testAlreadyExistingFileIsReplacedWhenAdded

	"And the state of the existing file is considered"
	| resultFile fileName file1 file2 |
	fileName := 'TheFile'.
	file1 := SVNFile named: fileName.
	file1
		content: 'abc_xyz';
		properties: (Dictionary with: 'a' -> 'b').
	sut addFile: file1.
	file2 := SVNFile named: fileName.
	file2
		content: 'Howdey Hoooo!!';
		properties: (Dictionary with: '123' -> '456').
	sut addFile: file2.
	self assert: sut files size = 1.
	resultFile := sut files anyOne.
	self assert: resultFile = file2.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rt 3/14/2008 15:49'!
testCommitARemovedDirectory

	| fileName |
	"create"

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
				named: 'TestDir'
				basePath: self workingCopyPath.
	fileName := 'iAmAFile'.
	sut
		createFileNamed: fileName;
		store;
		commit.
	
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self
		assertThatFiles: {fileName}
		existsIn: (self workingCopyPath , '2', self slash, sut theName).
	
	"remove"
	sut
		remove;
		commit.
	
	"check"
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self deny: (FileDirectory on: self workingCopyPath , '2', self slash, sut theName) exists.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:39'!
testCreateFile

	| fileName expectedFile resultFile |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'aNewFile'.
	sut createFileNamed: fileName.
	expectedFile := SVNFile  
		named: fileName
		basePath: sut path.
	self assert: sut files size = 1.
	resultFile := sut files anyOne.
	self assert: expectedFile = resultFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:39'!
testCreateSubDirectory

	| subDirectoryName expectedDirectory resultDirectory |
	subDirectoryName := 'subDirectory'.
	sut createSubDirectoryNamed: subDirectoryName.
	expectedDirectory := SVNDirectory 
		named: subDirectoryName
		basePath: sut path.
	self assert: sut subdirectories size = 1.
	resultDirectory := sut subdirectories anyOne.
	self assert: expectedDirectory = resultDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:13'!
testCreateTwoTimesTheSameFile

	| fileName |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	sut
		createFileNamed: fileName;
		createFileNamed: fileName.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:10'!
testCreateTwoTimesTheSameFileWithContent

	| fileName content |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	content := 'abc'.
	sut
		createFileNamed: fileName
		withContent: content.
	sut
		createFileNamed: fileName
		withContent: content.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 00:19'!
testCreateWithOn

	sut := SVNDirectory on: self pathForTests.
	FileDirectory
		splitName: self pathForTests
		to: [:dirPath :localName |
			self assert: sut basePath = dirPath.
			self assert: sut theName = localName].
	! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 05:30'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	sut recursivelyDo: [:svnDirectoryEntry |
		svnDirectoryEntry delete].
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:50'!
testDirectoryExists

	| directoryName |
	directoryName := 'iAmADirectory'.
	sut createSubDirectoryNamed: directoryName.
	self assert: (sut directoryExists: directoryName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 17:08'!
testDontStoreSubdirectoriesMultipleSubdirectoriesWithTheSameName

	| newSubdir1 newSubdir2 subdirFromSut key value |
	newSubdir1 := SVNDirectory named: 'subdir' basePath: sut path.
	sut addSubdirectory: newSubdir1.
	newSubdir2 := SVNDirectory named: 'subdir' basePath: sut path.
	key := 'key'.
	value := 'value'.
	newSubdir2 properties at: key put: value.
	sut addSubdirectory: newSubdir2.
	self assert: sut subdirectories size = 1.
	subdirFromSut := sut subdirectories anyOne.
	self assert: (subdirFromSut properties at: key) = value.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:32'!
testFileExists

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	self assert: (sut fileExists: fileName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:58'!
testFilesMustHaveTheCorrectBasePath01

	| newFile |
	newFile := SVNFile
		named: 'new'
		basePath: 'Not/existing'.
	sut addFile: newFile.
	self assert: newFile basePath = sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:01'!
testGatherPathsOfAllElements

	| dirName fileName expected1 expected2 result |
	dirName := 'dir1'.
	fileName := 'file1'.
	sut
		createSubDirectoryNamed: dirName;
		createFileNamed: fileName.
	expected1 := sut path , self slash , dirName.
	expected2 := sut path , self slash , fileName.
	result := sut recursivelyGatherPathsOfAllElements.
	self assert: result size = 2.
	self assert: (result includes: expected1).
	self assert: (result includes: expected2).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:36'!
testGetFileNamed

	| fileName svnFile |
	fileName := 'iAmAFile'.
	svnFile := sut createFileNamed: fileName.
	self assert: (sut getFileNamed: fileName) = svnFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:53'!
testGetSubDirectoryNamed

	| directoryName svnDirectory |
	directoryName := 'iAmADirectory'.
	svnDirectory := sut createSubDirectoryNamed: directoryName.
	self assert: (sut getSubDirectoryNamed: directoryName) = svnDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:49'!
testReadExistingDirectory

	self
		createDirNamed: sut theName
		in: sut basePath.
	self shouldnt: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 00:54'!
testReadNonExistingDirectory

	sut := SVNDirectory
		named: 'blablabla'
		basePath: 'auf/dem/Mond'.
	self should: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 00:54'!
testRecursiveReadOnlyWithDirectories

	| subDirPath subDirName subSubDirPath subSubDirName expectedSVNSubDirectory |
	self willTouchFileSystem.
	"1st level. Create real directory for the topmost SVNDirectory."
	subDirPath := self createDirNamed: sut theName in: sut basePath.
	"2nd level. Create a directory in the topmost SVNDirectory"
	subDirName := 'subdir'.
	subSubDirPath := self createDirNamed: subDirName in: subDirPath.
	"3rd level. Create a subdirectoy to the directory created just now. "
	subSubDirName := 'subsubdir'.
	self createDirNamed: subSubDirName in: subSubDirPath.
	
	"Now create the equivalent SVNDirectories"
	expectedSVNSubDirectory := SVNDirectory
		named: subDirName
		basePath: subDirPath.
	expectedSVNSubDirectory createSubDirectoryNamed: subSubDirName.
	
	sut read.
	
	self assert: sut subdirectories size = 1.
	self assert: (sut subdirectories includes: expectedSVNSubDirectory).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 02:52'!
testRecursiveReadOnlyWithFiles

	| fileName content pathToFile expectedSvnFile |
	"Create real directory"
	self
		createDirNamed: sut theName
		in: sut basePath.
	"Create a file"
	fileName := 'someFile'.
	content := 'blupfi'.
	pathToFile := self pathTo: fileName inDir: sut path.
	self inFile: pathToFile write: content.
	"Create SVNFile equivalent"
	expectedSvnFile := SVNFile 
		named: fileName
		basePath: sut path
		content: content.
	"exercise"
	sut read.
	self assert: (sut files includes: expectedSvnFile)! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rt 3/14/2008 15:46'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut remove.
	
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 02:52'!
testStoreDirectory

	sut store.
	self
		assertThatDirectories: {sut theName}
		existsIn: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreDirectoryWithFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreLotsOfDirectoriesAndFiles

	| fileName subDirName subDirFileName subSubDirName subSubDirFileName subDir subSubDir |
	self willTouchFileSystem.
	fileName := 'file'.
	subDirName := 'subDir'.
	subDirFileName := 'subDirFileName'.
	subSubDirName := 'subsubDir'.
	subSubDirFileName := 'subSubDirFileName'.

	sut createFileNamed: fileName.
	subDir := sut createSubDirectoryNamed: subDirName.
	subDir createFileNamed: subDirFileName.
	subSubDir := subDir createSubDirectoryNamed: subSubDirName.
	subSubDir createFileNamed: subSubDirFileName.
	
	sut store.
	self assertThatFiles: {fileName. subDirName} existsIn: sut path.
	self assertThatFiles: {subDirFileName. subSubDirName} existsIn: subDir path.
	self assertThatFiles: {subSubDirFileName} existsIn: subSubDir path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/20/2008 03:44'!
testStoreProperties

	| propertyDict result |
	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
		named: 'bla2'
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self svnClientDo: [:svnClient |
		result := svnClient svnGetPropertiesFrom: sut path].
	self debugExpected: propertyDict result: result.
	self assert: propertyDict = result.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:59'!
testSubdirectoriesMustHaveTheCorrectBasePath01

	| newDir |
	newDir := SVNDirectory
		named: 'blupf'
		basePath: 'not/existing/path'.
	sut addSubdirectory: newDir.
	self assert: newDir basePath = sut path.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 4/1/2008 19:04'!
testSvnAddDirectory

	| directoryName |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 4/1/2008 19:04'!
testSvnAddDirectoryWithSubdirectoriesAndFiles

	| directoryName subDirectoryName fileName subDir |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	subDirectoryName := 'SubDirectory'.
	fileName := 'file'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	subDir := sut createSubDirectoryNamed: subDirectoryName.
	subDir createFileNamed: fileName.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.
	self
		assertFile: subDirectoryName
		wasSVNAddedIn: sut path.
	self
		assertFile: fileName
		wasSVNAddedIn: sut path.! !

SVNTestCase subclass: #SVNEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment-Test'!

!SVNEnvironmentTest methodsFor: 'helper' stamp: 'rkrk 4/15/2008 01:18'!
compileMethodNamed: methodSelector	inCategory: aString andClass: aClass
	
	aClass
		compile: methodSelector asString
		classified: aString.! !

!SVNEnvironmentTest methodsFor: 'helper' stamp: 'rkrk 4/14/2008 21:31'!
createEmptySvnProject

	^ (SVNProject named: 'ProjectForEnvironmentTest')
		directory: (SVNDirectory on: 'DirForEnvironmentTest');
		yourself.! !

!SVNEnvironmentTest methodsFor: 'helper' stamp: 'rkrk 4/15/2008 01:33'!
defaultMethodSelector

	^ #methodForNotifyTest! !

!SVNEnvironmentTest methodsFor: 'helper' stamp: 'rkrk 4/14/2008 21:42'!
newSourceForSVNDummyM2

	^ 'm2
	^ 1984 sqrt'! !

!SVNEnvironmentTest methodsFor: 'helper' stamp: 'rkrk 4/15/2008 01:12'!
svnEnvironmentWithProjectAndSvnDummy
	
	| svnProject |
	svnProject := self createEmptySvnProject .
	svnProject addClass: self svnDummy.
	^ SVNEnvironment new
		addSvnProject: svnProject;
		yourself.! !

!SVNEnvironmentTest methodsFor: 'running' stamp: 'rkrk 4/15/2008 01:32'!
tearDown

	super tearDown.
	sut ifNotNil: [sut notifyAboutSystemChanges: false].
	(self svnDummy methodDict anySatisfy: [:ea | ea selector = self defaultMethodSelector])
		ifTrue: [self svnDummy removeSelector: self defaultMethodSelector].! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:15'!
testClassIsIncludedInEvironment

	| svnProject |
	svnProject := self createEmptySvnProject.
	svnProject addClass: self svnDummy.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	self assert: (sut includes: self svnDummy).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:18'!
testCompiledMethodIsIncludedInEvironment

	| svnProject class |
	class := self svnDummy.
	svnProject := self createEmptySvnProject.
	svnProject addClass: class.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	self assert: (sut includes: self svnDummy >> #m2).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:50'!
testFindSvnMethodForCompiledMethod01

	| svnProject class method result |
	"prepare"
	class := self svnDummy.
	svnProject := self createEmptySvnProject.
	svnProject addClass: class.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	"excercise"
	method := class >> #onInstanceAndClassSide.
	result := sut findSvnMethodForMethod: method.
	self assert: result notNil.
	self assert: result theName = method selector asString.
	self deny: result isPartOfMetaclass.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:57'!
testFindSvnMethodForCompiledMethod02

	| svnProject class method result |
	"prepare"
	class := self svnDummy.
	svnProject := self createEmptySvnProject.
	svnProject addClass: class.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	"excercise"
	method := class class >> #onInstanceAndClassSide.
	result := sut findSvnMethodForMethod: method.
	self assert: result notNil.
	self assert: result theName = method selector asString.
	self assert: result isPartOfMetaclass.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:54'!
testFindSvnMethodForCompiledMethod03

	| svnProject class method |
	"prepare"
	class := self svnDummy.
	svnProject := self createEmptySvnProject.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	"excercise"
	method := class class >> #onInstanceAndClassSide. 
	self assert: (sut findSvnMethodForMethod: method) isNil.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/15/2008 01:56'!
testFindSvnMethodInSvnClassWithinEnvironment

	| svnProject class method result |
	"prepare"
	class := self svnDummy.
	svnProject := self createEmptySvnProject.
	svnProject addClass: class.
	sut := SVNEnvironment forSvnProjects: {svnProject}.
	method := SVNMethod forExistingMethod: class >> #m1.
	result := sut findSvnProjectOrSvnClassForSvnMethod: method.
	self assert: result notNil.
	self assert: (result isKindOf: SVNClass).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:15'!
testMethodRefIsIncludedInEvironment

	| svnProject class methodRef |
	class := self svnDummy.
	svnProject := self createEmptySvnProject.
	svnProject addClass: class.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	methodRef := MethodReference class: class selector: #m2.
	self assert: (sut includes: methodRef ).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:32'!
testNoSvnClassForClassNotInProject

	| result svnProject |
	svnProject := self createEmptySvnProject.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	result := sut findSvnClassFor: self svnDummy.
	self assert: result isNil.! !

!SVNEnvironmentTest methodsFor: 'tests - notification' stamp: 'rkrk 4/15/2008 03:34'!
testNotifyMethodModification

	"prepare"
	| svnClass svnMethod numberOfMethodsInClass numberOfMethodsInClassInSvnClass |
	self willModifySVNDummy.

	sut := self svnEnvironmentWithProjectAndSvnDummy.
	sut notifyAboutSystemChanges: true.
	
	"exercise"
	self svnDummy compile: self newSourceForSVNDummyM2.
	
	svnClass := sut findSvnClassFor: self svnDummy.
	svnMethod := svnClass versionedMethods detect: [:ea | ea theName = #m2 asString].
	self assert: svnMethod source = self newSourceForSVNDummyM2.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNEnvironmentTest methodsFor: 'tests - notification' stamp: 'rkrk 4/15/2008 03:35'!
testNotifyMethodProtocolModification

	"prepare"
	| svnMethod numberOfMethodsInClass svnClass numberOfMethodsInClassInSvnClass |
	self willModifySVNDummy.

	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'notifyTest'
		andClass: self svnDummy.
		
	sut := self svnEnvironmentWithProjectAndSvnDummy.
	sut notifyAboutSystemChanges: true.
	
	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'changedMethodCategory'
		andClass: self svnDummy.
		
	"exercise"
	svnMethod := sut findSvnMethodForMethod: (self svnDummy >> self defaultMethodSelector).
	self assert: svnMethod category = 'changedMethodCategory'.
	
	svnClass := sut findSvnClassFor: self svnDummy.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNEnvironmentTest methodsFor: 'tests - notification' stamp: 'rkrk 4/15/2008 03:35'!
testNotifyMethodRemoving

	| method svnClass numberOfMethodsInClass numberOfMethodsInClassInSvnClass |
	self willModifySVNDummy.

	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'notifyTest'
		andClass: self svnDummy.
		
	sut := self svnEnvironmentWithProjectAndSvnDummy.
	sut notifyAboutSystemChanges: true.
	
	method := self svnDummy >> self defaultMethodSelector.
	self assert: (sut includes: method).
	self svnDummy removeSelector: self defaultMethodSelector.
	self deny: (sut includes: method).
	
	svnClass := sut findSvnClassFor: self svnDummy.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/14/2008 22:32'!
testRetrieveSvnClassFromSystemClass

	| result svnProject |
	svnProject := self createEmptySvnProject.
	svnProject addClass: self svnDummy.
	sut := SVNSystemBrowserEnvironment forSvnProjects: {svnProject}.
	result := sut findSvnClassFor: self svnDummy.
	self assert: result = (SVNClass forExistingClass: self svnDummy)! !

SVNTestCase subclass: #SVNFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNFileTest methodsFor: 'assertion' stamp: 'rkrk 3/20/2008 03:40'!
assertThatProperties: propertyDict areAddedTo: svnDirectoryEntry

	| client result |
	client := SVNCApiClient new.
	result := client svnGetPropertiesFrom: svnDirectoryEntry path.
	
	self debugExpected: propertyDict result: result.
	self assert: propertyDict = result.! !

!SVNFileTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNFile
		named: 'SVNFileCreatedDuringTests'
		basePath: self pathForTests.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:50'!
testCommitARemovedFile
	| client fileName |
	"create"
	client := SVNCApiClient new.
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile named: fileName basePath: self workingCopyPath.
	sut store.
	client svnAdd: sut path.
	client svnCommit: {  (sut path)}.
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self assert: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName).
	
	"remove"
	sut remove.
	client svnCommit: {sut path}.
	
	"check"
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self deny: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:50'!
testConvertIllegalFileName01

	| expected separator |
	sut theName: 'selectorwithcolon:'.
	separator := sut class asciiValueSeparator asString.
	expected := 'selectorwithcolon' , separator , $: asciiValue asString , separator.
	self assert: sut filename = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:54'!
testConvertIllegalFileName02

	| expected firstPart separator |
	sut theName: '//'.
	separator := sut class asciiValueSeparator asString.
	firstPart := separator , $/ asciiValue asString , separator.
	expected := firstPart , firstPart.
	self assert: sut filename = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:51'!
testCreateMethodWithAsciiInName

	| separator |
	separator := sut class asciiValueSeparator asString.
	sut := SVNFile
		named: 'm1' , separator , '58' , separator
		basePath: self pathForTests.
	self assert: sut theName = 'm1:'.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:12'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	sut delete.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:14'!
testDeletenonExistingFile

	| fileName |
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self shouldnt: [sut delete] raise: Error.
! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/5/2008 20:22'!
testEqualFilesStoredInSet

	| fileName content file1 file2 assoc set dir |
	self willTouchFileSystem.
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 store.
	dir := self defaultSVNDirectory.
	dir read.
	dir commit.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	set := Set with: file1 with: file2.
	self assert: set size = 1.
	self assert: file1 = file2.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:34'!
testEquals

	| fileName content file1 file2 assoc |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	self assert: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:52'!
testEquals02

	| file1 file2 set |
	file1 := SVNFile readFrom:  '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	file2 := SVNFile readFrom: '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	set := Set with: file1 with: file2.
	self assert: set size = 1.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/4/2008 01:11'!
testReadFileContents

	| fileName content fullPath |
	self willTouchFileSystem.
	fileName := 'someSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self pathForTests.
	self assert: sut content isEmpty.
	content := 'blabla' , String cr , 'blupf blupf'.
	fullPath := self pathTo: fileName inDir: self pathForTests.
	self 
		inFile: fullPath
		write: content.
	sut read.
	self assert: sut content = content! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/20/2008 03:45'!
testReadFileProperties

	| fileName helper expected propertyKey propertyValue result |
	self willNeedRepositoryAndWorkingCopy.
	"create some file and add manually properties to it"
	fileName := 'someSVNFile'.
	helper := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	helper store.	
	propertyKey := 'schluessel'.
	propertyValue := 'wert'.
	self svnClientDo: [:svnClient |
		svnClient svnAddProperty: propertyKey WithValue: propertyValue To: helper path].
	
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut read.
	expected := Dictionary with: propertyKey -> propertyValue.
	result := sut properties.
	self debugExpected: expected result: result.
	self assert: result = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/5/2008 18:52'!
testReadMethodWithIllegalFileName01

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named:  'm1:'
		basePath: self pathForTests.
	svnFile store.
	sut := SVNFile
		named: svnFile theName
		basePath: svnFile basePath.
	sut read.
	self assert: sut = svnFile.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 2/27/2008 01:37'!
testReadNonExistingFile

	| fileName |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self should: [sut read] raise: Error .! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:51'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'aLittleSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut remove.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:20'!
testStoreAndAddFile

	| fileName |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'testSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut store.
	self 
		assertFile: fileName
		wasSVNAddedIn: self workingCopyPath! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:57'!
testStoreAsFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'testSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: self pathForTests.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreContent

	| fileName content |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	content := 'this is content' , String cr , 'much content'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	sut store.
	self
		assertThatFile: fileName
		inPath: self pathForTests
		hasContent: content.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreProperties

	| fileName propertyDict |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self
		assertThatProperties: propertyDict
		areAddedTo: sut.! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/13/2008 15:26'!
testSvnAdd

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNFile
		named: 'FileName'
		basePath: self workingCopyPath.
	sut
		store;
		svnAdd.
	self
		assertFile: sut theName
		wasSVNAddedIn: sut basePath.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:30'!
testUnequal01

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content , ' Blupf'.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:31'!
testUnequal02

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName , ' abc'
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:33'!
testUnequal03

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 properties add: 'key' -> 'value'.
	file2 properties add: 'otherKey' -> 'value'.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/14/2008 04:19'!
testUpdateWithNoLocalChanges

	| contentForRev1 |
	self willNeedRepositoryAndWorkingCopy.
	contentForRev1 := 'abc'.
	sut content: contentForRev1.
	sut
		store;
		commit.
	"self assert: false."! !

SVNTestCase subclass: #SVNInfoRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'mu 4/2/2008 11:34'!
getScheduleForFile: aFile

	^ (SVNInfoRequest target: aFile) execute schedule.! !

!SVNInfoRequestTest methodsFor: 'running' stamp: 'rkrk 3/23/2008 03:24'!
setupAddedFile

	^ (self defaultSVNDirectory createFileNamed: 'fileForSvnInfo')
		store;
		yourself.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 03:33'!
testConvertToDateFromCTimeString

	! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:58'!
testDefaultArrayForPrimitive

	| conditions |
	sut := SVNInfoRequest new.
	self flag: #TODO.
	conditions := {
		[:elem | elem isString and: [elem size > 200]].	"repository root url"
		[:elem | elem =
			(SVNRevision revisionKindDictionary at: #unspecified)]. "current revision kind" 
		[:elem | elem isNil].							"current revision number"
		[:elem | elem isString and: [elem size = (36 + 1)]].	"repository uuid"
		[:elem | elem =
			(SVNRevision revisionKindDictionary at: #unspecified)]."last changed  revision kind"
		[:elem | elem isNil].							"last changed revision number"
		[:elem | elem isString and: [elem size = (25 + 1)]].	"date"
		[:elem | elem isString and: [elem size > 100]].	"author"
		[:elem | elem isString and: [elem size = (8 + 1)]].	"schedule"
	}.
	sut arrayForPrimitive with: conditions do: [:each :condition |
		self assert: (condition value: each)].! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'test 4/2/2008 10:43'!
testExecuteInfoForAddedFile

	| addedFile expectedRevision expectedLastChangedRevision |
	self willNeedRepositoryAndWorkingCopy.
	addedFile := self setupAddedFile.
	sut := SVNInfoRequest target: addedFile.
	sut execute.
	self flag: #TODO. "Make author changable"
	self assert: sut author = ''.
	expectedRevision := SVNRevision unspecified.
	expectedRevision number: 0.
	self assert: sut revision = expectedRevision.
	expectedLastChangedRevision := SVNRevision unspecified.
	expectedLastChangedRevision number: -1.
	self assert: sut lastChangedRevision = expectedLastChangedRevision.
	self assert: sut date = DateAndTime current.
	self assert: sut repositoryRootUrl , '/' = self repositoryURLPath.
	self flag: #TODO. "Manage RepositoryUUID"
	self assert: sut repositoryUUID isString.
	self assert: sut schedule = 'add'.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'mu 4/2/2008 11:57'!
testInfoScheduleForFile

	| addedFile firstSchedule secondSchedule stream thirdSechedule |
	"setup"
	self willNeedRepositoryAndWorkingCopy.
	addedFile := self setupAddedFile.
	
	"execute"
	firstSchedule := self getScheduleForFile: addedFile.
	"self halt."
	addedFile commitWithMessage: 'not relevant'.
	secondSchedule := self getScheduleForFile: addedFile.
	self flag: #TODO. "if a element is modified - return the status modified/replace"
"	stream := FileStream fileNamed: addedFile path.
	stream
		nextPutAll: '123';
		close.
	thirdSechedule := self getScheduleForFile: addedFile."
	
	"assert"
	self assert: firstSchedule = 'add'.
	self assert: secondSchedule = 'normal'.
	"self assert: thirdSechedule = 'replace'"! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 02:28'!
testStringForSvnPrimitive

	| string result stringForPrimitive |
	string := 'blabla'.
	result := string forSvnPrimitive. "Be a collection with one String"
	self assert: result size = 1.
	stringForPrimitive := result first.	
	self assert: stringForPrimitive last = (Character value: 0).! !

SVNTestCase subclass: #SVNLoaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNLoaderTest commentStamp: '<historical>' prior: 0!
A SVNLoaderTest is xxxxxxxxx.

Instance Variables
!

!SVNLoaderTest methodsFor: 'assertions' stamp: 'rt 3/7/2008 22:07'!
classesRecoveredCorrect: aSet

	| element setUnderTest |
	self assert: aSet size = 1.
	element := aSet someElement.
	self assert: element superclassName = 'Object'.
	self assert: element theName = 'TestClass4'.
	
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass3'. 'TestClass5'} asSet.
	self assert: (setUnderTest detect: [:each | each theName = 'TestClass5']) subclasses isEmpty.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass3'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 1.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass2'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass1'. 'TestClass6'} asSet.
	
	setUnderTest do: [:each | self assert: each subclasses isEmpty].
	^true! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 10:52'!
getSVNTestClassFromClass: aClass

	^SVNClass forExistingClass: aClass! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:45'!
getTestClass

	| class |
	class :=(Smalltalk classNamed: self nameOfTestClass asSymbol) ifNil: [Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: '' 
		classVariableNames:''
		poolDictionaries: ''
		category: self class category asString].
	
	class
		compile: 'm1: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm2: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm3: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	^class! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 23:21'!
nameOfTestClass

	^'ClassOfSVNLoaderTest'! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 11:21'!
removeTestClass: name

	| class |
	(class := Smalltalk classNamed: name) ifNotNil: [class removeFromSystem].! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:29'!
setOfDependentClasses
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'SVNMethod')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'SVNClass')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'DoesNotExistingClass').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 15:58'!
setOfDependentClassesWithCycles
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass1').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 21:08'!
setOfDependentClassesWithOutCycles

	^Set with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'TestClass2').! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/8/2008 02:43'!
setUp
	super setUp.
	sut := SVNLoader new! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/7/2008 11:16'!
tearDown

	self removeTestClass: self nameOfTestClass.
	
	super tearDown! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 22:29'!
testClassSorting

	| aSVNClassSet sortedSVNClasses |
	aSVNClassSet := self setOfDependentClassesWithOutCycles.
	sut addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	
	sortedSVNClasses := sut sortSVNClasses: aSVNClassSet consider: (sut requiredClasses intersection: sut classesToLoad).
	
	self assert: (self classesRecoveredCorrect: sortedSVNClasses)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 12:53'!
testDetectDependenciesInSVNClasses

	| resultSet |
	resultSet := sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses..
	self assert: resultSet = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/8/2008 22:39'!
testDetectDependenciesInSVNMethods

	| svnClass resultSet |
	svnClass := self getSVNTestClassFromClass: self getTestClass.
	resultSet := sut 
				addToRequiredClassesAllDependenciesInSVNMethods: (svnClass versionedMethods).
	self assert: resultSet = (Set with: self nameOfTestClass)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 16:08'!
testForCycles

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithCycles.
	self assert: (sut hasCycle: self setOfDependentClassesWithCycles).
	
	sut initialize.
	
	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithOutCycles.
	self deny: (sut hasCycle: self setOfDependentClassesWithOutCycles).! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 15:56'!
testRequirements

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses.
	
	self assert: sut classesToLoad = {'TestClass1'. 'TestClass2'. 'TestClass3'. 'TestClass4'. 'TestClass5'. 'TestClass6'} asSet.
	
	self assert: sut requiredClasses = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet.
	
	self assert: sut unknownRequiredClasses = {'DoesNotExistingClass'} asSet! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMethodTest methodsFor: 'helper' stamp: 'rkrk 4/1/2008 01:58'!
svnFileForMethodReference: methodRef

	| svnFile |
	svnFile := SVNFile 
		named: methodRef methodSymbol asString
		basePath: ''
		content: methodRef source.
	svnFile properties 
		at: 'class' put: methodRef actualClass name asString;
		at: 'category' put: methodRef category;
		at: 'timestamp' put: methodRef timeStamp.
	^ svnFile.! !

!SVNMethodTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:25'!
testEquals

	| methodBlock method1 method2 |
	methodBlock := [SVNMethod forExistingMethod: self svnDummy >> #m1].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 12:44'!
testExtractMetaClass

	| method result svnFile className |
	method := SVNMethod new.
	self flag: #TODO. "Implicitly specified mapping..."
	svnFile := SVNFile
		named: 'm99'
		basePath: '/'.
	className := 'SVNDummy class'.
	svnFile properties
		at: 'class'
		put: className.
	result := method extractClassFrom: svnFile.
	self assert: result = className.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 3/4/2008 03:25'!
testLoadMethodIntoSystem

	| class methodSelector  |
	self willModifySVNDummy.
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	class removeSelector: methodSelector.
	self deny: (class methodDict includesKey: methodSelector).
	sut load.
	self assert: (class methodDict includesKey: methodSelector).! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 4/1/2008 04:33'!
testRestoreFromSVNFile

	
	| methodSelector class methodReference svnFile expectedSVNMethod |
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	methodReference := (class >> methodSelector) methodReference.
	svnFile := self svnFileForMethodReference: methodReference.
	"exercise"
	sut := SVNMethod restoreFrom: svnFile.
	"expected"
	expectedSVNMethod := SVNMethod forExistingMethod: class >> methodSelector.
	"assertion"
	self assert: sut = expectedSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/1/2008 02:04'!
testSVNMethodComesWithCorrectlyInitializedSVNFile

	| methodSelector class methodRef expectedFile resultFile |
	"setup"
	class := self svnDummy. methodSelector := #m1.
	methodRef := (class >> methodSelector) methodReference.
	"exercise"
	sut := SVNMethod forExistingMethod: methodRef compiledMethod.
	"assert"
	expectedFile := self svnFileForMethodReference: methodRef.
	resultFile := sut file.
	self assert: expectedFile = resultFile.! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 17:41'!
testStoreInSVNDirectory
	
	| methodSelector class methodReference expectedSVNFile |
	self willTouchFileSystem.
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	self defaultSVNDirectory addFile: sut file.
	"exercise"
	sut store.
	"expected"
	methodReference := (class >> methodSelector) methodReference.
	expectedSVNFile := self svnFileForMethodReference: methodReference.
	"assertion"
	expectedSVNFile basePath: sut file basePath.
	self assert: sut file notNil.
	self assert: sut file = expectedSVNFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 18:09'!
testStoreThenRestore

	| methodSelector writtenSVNMethod methodFile readSVNMethod |
	self willTouchFileSystem.
	"prepare"
	methodSelector := #m1.
	writtenSVNMethod := SVNMethod forExistingMethod: self svnDummy >> methodSelector.
	self defaultSVNDirectory addFile: writtenSVNMethod file.
	"exercise"
	writtenSVNMethod store.
	"assertion"
	methodFile := writtenSVNMethod file.
	self assert: methodFile notNil.
	readSVNMethod := SVNMethod restoreFrom: methodFile.
	self assert: writtenSVNMethod = readSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 17:44'!
testStoreWithSpecialCharInSVNDirectory

	| methodSelector class expectedFileName separator |
	"prepare"
	methodSelector := #<.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	self defaultSVNDirectory addFile: sut file.
	"exercise"
	sut store.
	"expected"
	separator := SVNDirectoryEntry asciiValueSeparator asString.
	expectedFileName := separator , '60' , separator.
	"assertion"
	self assert: sut file notNil.
	self assert: sut file filename = expectedFileName! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: 'needsTestClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNProjectTest class
	instanceVariableNames: 'sut'!

SVNProjectTest class
	instanceVariableNames: 'sut'!

SVNProjectTest subclass: #SVNProjectExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNProjectExternalTest methodsFor: 'assertions' stamp: 'rkrk 3/6/2008 14:41'!
assertNoSVNFileWithIllegalCharacterIn: aSVNDirectory

	aSVNDirectory files do: [:each |
		self assert: (each filename includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not.].
	aSVNDirectory subdirectories do: [:each | self assertNoSVNFileWithIllegalCharacterIn: each].! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/19/2008 11:15'!
createSimpleDummyClassForSVNProjectTest

	| class |
	class := Object
				subclass: self nameOfClassForTests asSymbol
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self class category asString.
	
	class compile: 'm1: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm2: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm3: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm4: obj' classified: 'neu' withStamp: nil notifying: nil.
	^class! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/13/2008 16:32'!
nameOfClassForTests

	^ 'SimpleDummyClassForSVNProjectTest'! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rkrk 4/1/2008 04:24'!
removeSimpleDummyClassForSVNProjectTest

	Transcript
		show: 'will remove SimpleDummyClassForSVNProjectTest in test:' , testSelector;
		cr;
		show: 'class is there:' , (Smalltalk hasClassNamed: self nameOfClassForTests) asString;
		cr.
	"testSelector = #testCheckoutProperties ifTrue: [self halt]."
	(Smalltalk hasClassNamed: self nameOfClassForTests) ifFalse: [^self].
	Transcript
		show: 'Removing...';
		cr.
	(Smalltalk classNamed: self nameOfClassForTests) removeFromSystemUnlogged.
	Transcript
		show: 'Class successfully removed';
		cr.! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:34'!
setUp

	super setUp.
	
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	self createSimpleDummyClassForSVNProjectTest.! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:35'!
tearDown

	self removeSimpleDummyClassForSVNProjectTest.
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	
	super tearDown.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/20/2008 04:58'!
testCheckoutProperties

	| svnPro destination client |
	self willNeedRepositoryAndWorkingCopy.

	svnPro := SVNProject
 		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
     
	svnPro addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro store.

	destination := self workingCopyPath, self slash, svnPro theName,
				self slash, self nameOfClassForTests.
	client := SVNCommandLineClient new.
	client
		svnAddProperty: 'instanceVariables'
		WithValue: 'instVar1'
		To: destination.

	svnPro projectDirectory read.
	self assert: (svnPro projectDirectory subdirectories size = 1).! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:40'!
testCheckoutSVNDirectories

	| svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.
	svnPro1 commit.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.
	svnPro1 checkout.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:40'!
testCountOfCommitedElements

	| svnPro1 svnPro2 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	
	svnPro2 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	
	svnPro1 commit.
	svnPro1 commit.
	self assert: svnPro1 = svnPro2.

	self assert: svnPro1 projectDirectory subdirectories size = 1.
	self assert: svnPro1 projectDirectory subdirectories size = svnPro2 projectDirectory subdirectories size.
	self assert: svnPro1 projectDirectory subdirectories anyOne files size = svnPro2 projectDirectory subdirectories anyOne files size.
	self assert: svnPro1 projectDirectory subdirectories anyOne subdirectories size = svnPro2 projectDirectory subdirectories anyOne subdirectories size.
	self assert: ((svnPro1
					projectDirectory subdirectories anyOne subdirectories
						detect: [:each | each theName = 'instance']) files size
							= (svnPro2 projectDirectory subdirectories anyOne subdirectories
								detect: [:each | each theName = 'instance']) files size)! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:42'!
testCountOfCommitedElements02

	| svnPro1 svnPro2 projectName |
	self willTouchFileSystem. self flag: #TODO. "No need to write to disk..."
	projectName := 'TestPro'.
	
	svnPro1 := SVNProject named: projectName.
	svnPro1 directory: (SVNDirectory on: self pathForTests , projectName).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 store.
	
	svnPro2 := SVNProject named: projectName.
	svnPro2 directory: (SVNDirectory on: self pathForTests , projectName).
	svnPro2 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro2 store.
	
	svnPro1 store.
	svnPro1 store.
	"self assert: svnPro1 = svnPro2."
	self assert: svnPro1 directory = svnPro2 directory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:48'!
testDeleteAClass

	| projectName svnProject svnClass secondWorkingCopyPath sameProject |
	"Was this test not a bit too complicated?"
	self willNeedRepositoryAndWorkingCopy.
	self flag: #TODO.
	projectName := 'TestPro'.
	svnProject := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath "There was repositoryPath...?"
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	svnClass := SVNClass forExistingClass: self createSimpleDummyClassForSVNProjectTest.
	svnProject
		addSVNClass: svnClass;
		commit;
		removeSVNClass: svnClass;	"exercise"
		commit.
	
	"Is the class really deleted?"
	secondWorkingCopyPath := self workingCopyPath, '2'.

	sameProject := SVNProject
		checkoutProject: projectName
		fromURL: self repositoryURLPath
		inWorkingCopy:  (SVNDirectory on: secondWorkingCopyPath).
	self assert: sameProject versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'test 4/1/2008 13:41'!
testStoringOfInstanceVariables

	| class svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	svnPro1 checkout.
	svnPro1 load.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i1 i2'.
	svnPro1 commit.
	class := nil.
	"self halt."
	svnPro1 checkout.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i3'.
	svnPro1 commit.
	svnPro1 checkout.! !

!SVNProjectTest methodsFor: 'assertion' stamp: 'rkrk 2/25/2008 02:08'!
assertExistanceOfProject: aSVNProject in: pathString

	| dir |
	dir := FileDirectory on: pathString.
	self assert: (dir directoryExists: aSVNProject theName).! !

!SVNProjectTest methodsFor: 'running' stamp: 'rt 3/17/2008 12:43'!
setUp

	super setUp.
	
	self willNeedSimpleTestClass: false! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:07'!
simpleTestClass

	self willNeedSimpleTestClass ifFalse: [
		self deny: (Smalltalk hasClassNamed: self simpleTestClassName).
		needsTestClass := true.
		Object
			subclass: self simpleTestClassName asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: self class category asString].
	^ (Smalltalk classNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:02'!
simpleTestClassName

	^'SimpleTestClass'! !

!SVNProjectTest methodsFor: 'running' stamp: 'rkrk 4/15/2008 02:41'!
tearDown

	super tearDown.
	
	(Smalltalk hasClassNamed: self simpleTestClassName)
		ifTrue:[(Smalltalk classNamed: self simpleTestClassName) removeFromSystemUnlogged]! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:47'!
testAddCategory

	| classesOfCategory result |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	sut addCategory: 'SqueakSVN-TestCategory'.
	classesOfCategory := {
		SVNClass forExistingClass: Class1.
		SVNClass forExistingClass: Class2.
		SVNClass forExistingClass: Class3.} asSet.
	result := sut versionedClasses.
	self assert: result = classesOfCategory asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:48'!
testAddClass

	| aClass methodsOfClass result |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: aClass)).
	methodsOfClass := (aClass methodDict collect: [:ea | SVNMethod forExistingMethod: ea ])
						union: (aClass class methodDict collect: [:ea | SVNMethod forExistingMethod: ea ]).
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:49'!
testAddClassWhenClassAlreadyExist

	| aClass svnClass svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	sut addClass: aClass.
	svnClass := SVNClass forExistingClass: aClass.
	svnMethod := svnClass versionedMethods detect: [:ea | (ea theName = 'm2') and: [ea nameOfClass asSymbol = svnClass theName]].
	svnClass removeSVNMethod: svnMethod.
	sut addSVNClass: svnClass.
	self assert: sut versionedClasses size = 1.
	self assert: (sut versionedClasses someElement versionedMethods noneSatisfy: [:ea | ea theName = 'm2']).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:50'!
testAddMethod

	| aMethod svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aMethod := self svnDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod nameOfClass = aMethod methodReference actualClass name.
	self assert: svnMethod methodSelector = aMethod selector! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/15/2008 02:34'!
testClassDeleted

	self willNeedSimpleTestClass: true.
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addClass: self simpleTestClass.
	self assert: (sut versionedClasses size = 1).
	
	self simpleTestClass removeFromSystem.

	self assert: (sut versionedClasses size = 0).
	self deny: (Smalltalk hasClassNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'mu 3/31/2008 14:42'!
testClassLoading

	| file |
	self willNeedRepositoryAndWorkingCopy.
	self willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'MyPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	sut addClass: self svnDummy.
	
	sut commit.
	sut checkout.
	sut load.
	
	self deny: self svnDummy isNil.
	self deny: self svnDummy class isObsolete.
	self deny: sut versionedClasses size = 0.
	self deny: sut versionedClasses someElement directory isNil.
	file := sut versionedClasses someElement versionedMethods someElement file.
	self assert: ((FileDirectory on: file basePath) fileExists: file filename).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:11'!
testDeleteClass

	self willNeedSimpleTestClass: true.
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	
	sut addClass: self simpleTestClass.
	self assert: (sut versionedClasses size = 1).
	sut deleteClass: self simpleTestClass.
	self deny: (sut versionedClasses size ~= 0).
	self deny: (Smalltalk hasClassNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/15/2008 02:44'!
testDeleteMethod

	| svnEnvironment |
	self willNeedSimpleTestClass: true.
	self simpleTestClass compile: 'm1' classified: 'neu' withStamp: nil notifying: nil.
	
	sut := SVNProject named: 'test'.
	svnEnvironment := SVNEnvironment forSvnProjects: {sut}.
	svnEnvironment notifyAboutSystemChanges: true.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	
	sut addMethod: (self simpleTestClass compiledMethodAt: #m1).
	self assert: (sut versionedMethods size = 1).
	sut deleteMethod: (self simpleTestClass compiledMethodAt: #m1).
	self deny: (sut versionedMethods size ~= 0).
	self deny: (self simpleTestClass selectors includes: #m1)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 18:01'!
testDirectoryEntryWasCorrectlyInitialized

	| nameOfProject expectedDir |
	nameOfProject := 'TestPro'.
	sut := SVNProject named: nameOfProject.
	expectedDir := SVNDirectory on: nameOfProject.
	self assert: sut directory = expectedDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:10'!
testMappingToFileSystem01

	self willTouchFileSystem.
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	sut store.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/15/2008 02:46'!
testMethodDeleted

	| svnEnvironment |
	self willNeedSimpleTestClass: true.
	self simpleTestClass compile: 'm1' classified: 'neu' withStamp: nil notifying: nil.
	
	sut := SVNProject named: 'test'.
	svnEnvironment := SVNEnvironment forSvnProjects: {sut}.
	svnEnvironment notifyAboutSystemChanges: true.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addMethod: (self simpleTestClass compiledMethodAt: #m1).
	self assert: (sut versionedMethods size = 1).
	
	self simpleTestClass removeSelector: #m1.
	
	self assert: (sut versionedMethods size = 0).
	self deny: (self simpleTestClass selectors includes: #m1)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 16:50'!
testProjectDirectoryShouldBeCorrectlyInitialized

	| nameOfProject expectedDir |
	nameOfProject := 'TestPro'.
	sut := SVNProject named: nameOfProject.
	expectedDir := SVNDirectory on: nameOfProject.
	self assert: sut directory = expectedDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:03'!
testRemoveClass

	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addClass: self svnDummy.
	self assert: (sut versionedClasses size = 1).
	sut removeClass: self svnDummy.
	self deny: (sut versionedClasses size ~= 0).
	self assert: (Smalltalk hasClassNamed: self svnDummy name asString)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:52'!
testRemoveMethod

	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').

	sut addMethod: (self svnDummy compiledMethodAt: #m2).
	self assert: (sut versionedMethods size = 1).
	sut removeMethod: (self svnDummy compiledMethodAt: #m2).
	self deny: (sut versionedMethods size ~= 0).
	self assert: (self svnDummy compiledMethodAt: #m2) notNil.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:52'!
testRemoveSVNClass

	| svnClass |	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	svnClass := SVNClass forExistingClass: self svnDummy.
	sut addSVNClass: svnClass.
	self assert: (sut versionedClasses includes: svnClass).
	sut removeSVNClass: svnClass.
	self deny: (sut versionedClasses includes: svnClass).
	self assert: (Smalltalk hasClassNamed: self svnDummy name asString)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:53'!
testRemoveSVNMethod

	| svnMethod |	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	svnMethod := SVNMethod forExistingMethod: (self svnDummy compiledMethodAt: #m2).

	sut addMethod: (self svnDummy compiledMethodAt: #m2).
	self assert: (sut versionedMethods includes: svnMethod).
	sut removeSVNMethod: svnMethod.
	self deny: (sut versionedMethods includes: svnMethod).
	self deny: (sut versionedMethods size ~= 0).
	self assert: (self svnDummy compiledMethodAt: #m2) notNil.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:02'!
testRestore

	| projectName class sut2 |
	self willNeedRepositoryAndWorkingCopy.
	class := self svnDummy.
	projectName := 'SomeSVNProject'.
	sut2 := SVNProject named: projectName.
	sut2 directory: (self defaultSVNDirectory createSubDirectoryNamed: projectName).
	sut2 addClass: class.
	sut2 store.
	
	sut := SVNProject restoreFrom: (sut2 directory).
	self assert: sut theName = projectName.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: class)).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:07'!
testShouldGetProjectDirectoryfromWorkingcopyDirectory

	| projectName expectedProjectDir workingCopyDir |
	projectName := 'SVNProject123'.
	workingCopyDir := self defaultSVNDirectory.
	sut := SVNProject named: projectName.
	sut directory: (workingCopyDir createSubDirectoryNamed: projectName).
	
	workingCopyDir read.
	expectedProjectDir := (workingCopyDir getSubDirectoryNamed: projectName).
	self assert: sut directory = expectedProjectDir.! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 12:50'!
willNeedSimpleTestClass
	
	^ needsTestClass! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:03'!
willNeedSimpleTestClass: bool

	needsTestClass := false.
	bool ifTrue:	[self simpleTestClass].! !

SVNTestCase subclass: #SVNRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNRepositoryTest methodsFor: 'helper' stamp: 'rt 3/30/2008 19:43'!
nameOfTestProject
	^'TestProject'! !

!SVNRepositoryTest methodsFor: 'running' stamp: 'rt 4/9/2008 00:54'!
tearDown

	(self directoryManager currentDirectory notNil and:
		[self directoryManager currentDirectory isSvnAware])
			ifTrue: [(SVNCApiClient new) svnUpdateTargetsToHeadRevision: (Array with: self workingCopyPath)].
	
	^ super tearDown! !

!SVNRepositoryTest methodsFor: 'access tests' stamp: 'rt 4/9/2008 00:51'!
testAccessingUnprotectedRepository

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:55'!
testCheckForNotExistingProject

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self deny: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:57'!
testCreateExistingProject

	self willNeedRepositoryAndWorkingCopy.

	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:21'!
testCreateNotExistingProject

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:19'!
testCreateValidRepository

	sut := SVNRepository on: self urlOfProtectedRepository.
	self assert: sut notNil.! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:19'!
testDoNotCreateUnvalidRepository

	sut := SVNRepository on: 'noValidUrl'.
	self assert: sut isNil.! !

!SVNRepositoryTest methodsFor: 'access tests' stamp: 'rt 4/8/2008 13:14'!
testNoPasswordRequired

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self assert: sut requiresAuthentication not.! !

!SVNRepositoryTest methodsFor: 'access tests' stamp: 'rt 4/8/2008 13:14'!
testWillNeedsAPassword

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self urlOfProtectedRepository.
	self assert: sut requiresAuthentication.! !

!SVNRepositoryTest methodsFor: 'helper' stamp: 'rt 4/9/2008 00:15'!
urlOfProtectedRepository

	^ 'http://squeaksvn.open.collab.net/svn/squeaksvn'! !

SVNTestCase subclass: #SVNRevisionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:36'!
testBase

	sut := SVNRevision base.
	self assert: sut kindSymbol = #base.
	self assert: sut kind = 5.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:52'!
testForSvnPrimitive01

	| expected result |
	sut := SVNRevision head.
	expected := {sut kind. nil} asOrderedCollection.
	result := sut forSvnPrimitive.
	self assert: expected = result.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:52'!
testForSvnPrimitive02

	| expected |
	sut := SVNRevision number: 30.
	expected := {sut kind. 30} asOrderedCollection.
	self assert: expected = sut forSvnPrimitive.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:37'!
testHead

	sut := SVNRevision head.
	self assert: sut kindSymbol = #head.
	self assert: sut kind = 7.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:01'!
testNoNew

	self should: [SVNRevision new] raise: Error.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:09'!
testNumber

	sut := SVNRevision number: 10.
	self shouldnt: [sut number] raise: AssertionFailure.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 02:55'!
testNumberOnlyWhenCorrectlyInitialized

	sut := SVNRevision unspecified.
	self assert: sut number = nil.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:27'!
testSetsShouldBeEqual

	| set1 set2 |
	set1 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self assert: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:34'!
testSetsShouldNotBeEqual01

	| set1 set2 |
	set1 := {SVNRevision head. SVNRevision number: 20. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self deny: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:34'!
testSetsShouldNotBeEqual02

	| set1 set2 |
	set1 := {SVNRevision working. SVNRevision number: 30. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self deny: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:18'!
testShouldBeEqualIfNumberIsEqual

	| sut1 sut2 |
	sut1 := SVNRevision number: 10.
	sut2 := SVNRevision head.
	sut2 number: 10.
	self assert: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:24'!
testShouldBeEqualIfSameKind

	| sut1 sut2 |
	sut1 := SVNRevision head.
	sut2 := SVNRevision head.
	self assert: sut1 = sut2..
	
	sut1 := SVNRevision base.
	sut2 := SVNRevision base.
	self assert: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:23'!
testShouldNotBeEqualIfKindIsUnequal

	| sut1 sut2 |
	sut1 := SVNRevision working.
	sut2 := SVNRevision head.
	self deny: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:23'!
testShouldNotBeEqualIfNumberIsUnequal

	| sut1 sut2 |
	sut1 := SVNRevision head.
	sut1 number: 8.
	sut2 := SVNRevision head.
	sut2 number: 10.
	self deny: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:37'!
testUnspecified

	sut := SVNRevision unspecified.
	self assert: sut kindSymbol = #unspecified.
	self assert: sut kind = 0.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:38'!
testWorking

	sut := SVNRevision working.
	self assert: sut kindSymbol = #working.
	self assert: sut kind = 6.! !

SVNTestCase subclass: #SVNStatusRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNStatusRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/3/2008 23:11'!
testStatusOfAddedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile store.
	sut := SVNStatusRequest target: svnFile.
	sut execute.
	self assert: sut statusKind = #added.! !

!SVNStatusRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/3/2008 23:12'!
testStatusOfCommitedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile
		store;
		commit.
	sut := SVNStatusRequest target: svnFile.
	sut execute.
	self assert: sut statusKind = #normal.! !

!SVNStatusRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/12/2008 14:07'!
testStatusOfItemNotInWorkingcopy

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named: 'fileName123456789'
		basePath: self pathForTests.
	svnFile store.
	sut := SVNStatusRequest target: svnFile.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

!SVNStatusRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/3/2008 23:12'!
testStatusOfModifiedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile
		store;
		commit;
		content: 'abc';
		store.
	sut := SVNStatusRequest target: svnFile.
	sut execute.
	self assert: sut statusKind = #modified.! !

!SVNStatusRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/3/2008 23:09'!
testStatusOfUnversionedItem

	| path svnDir |
	self willNeedRepositoryAndWorkingCopy.
	"Create a directory entry. Cannot use store here
	because store automatically adds the entry to thw WC."
	path := self
		createDirNamed: 'shouldNotBeAdded'
		in: self workingCopyPath.
	svnDir := SVNDirectory on: path.
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

SVNTestCase subclass: #SVNSystemBrowserEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment-Test'!

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 3/15/2008 05:30'!
assertFile: fileName wasSVNAddedIn: path 

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: path , self slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName)! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 20:48'!
assertThatDirectories: dirNames existsIn: path

	dirNames do: [:each |
		self assert: ((FileDirectory on: path) directoryExists: each)] .! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/24/2008 23:48'!
assertThatFile: fileName inPath: pathName hasContent: expectedContent 

	| fullPath actualContent |
	fullPath := self pathTo: fileName inDir: pathName.
	self assert: (FileStream isAFileNamed: fullPath).
	actualContent := (FileStream readOnlyFileNamed: fullPath) contentsOfEntireFile.
	self assert: actualContent = expectedContent! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 4/3/2008 00:45'!
assertThatFiles: fileNames existsIn: path

	| dir |
	dir := FileDirectory on: path.
	self assert: (fileNames allSatisfy: [:ea |
		(dir fileExists: ea) or: [(dir directoryExists: ea)]]).! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/15/2008 00:54'!
cleanupSVNDummy

	self hasModifiedSVNDummy ifFalse: [^ self].
	self flag: #TODO. "Full restore?"
	((self svnDummy methodDict includesKey: #m2)
		and: [(self svnDummy >> #m2) getSource asString = self sourceCodeForSVNDummyM2])
			ifFalse: [self svnDummy compile: self sourceCodeForSVNDummyM2].! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 01:54'!
createDirNamed: newDirName in: existingDir 
	
	(FileDirectory on: existingDir) assureExistenceOfPath: newDirName.
	^ existingDir , FileDirectory slash , newDirName.! !

!SVNTestCase methodsFor: 'debugging' stamp: 'rkrk 3/20/2008 03:42'!
debugExpected: expected result: result

	expected = result ifTrue: [^ self].
	Transcript
		show: 'expected: ';
		show: expected asString;
		cr;
		show: 'result';
		show: result asString;
		cr.
	self halt.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 02:30'!
defaultSVNDirectory
	
	^ SVNDirectory on: self pathForTests! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 4/3/2008 00:46'!
denyThatFiles: fileNames existsIn: path

	| dir |
	dir := FileDirectory on: path.
	self assert: (fileNames noneSatisfy: [:ea |
		(dir fileExists: ea) or: [(dir directoryExists: ea)]]).! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager
	^ directoryManager! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager: anObject
	directoryManager := anObject! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy
	^ hasModifiedSVNDummy! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy: anObject
	hasModifiedSVNDummy := anObject! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 02:53'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.! !

!SVNTestCase methodsFor: 'initialization' stamp: 'rkrk 3/15/2008 04:21'!
initialize

	super initialize.
	self slash: FileDirectory slash.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:53'!
pathForTests

	^ self directoryManager pathForTests.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/24/2008 23:45'!
pathTo: filename inDir: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:54'!
repositoryURLPath

	^ self directoryManager repositoryURLPath! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 4/14/2008 22:41'!
restoreSVNDummy

	"Read a file out of SVNDummy. If you change the class, replace this fileout. You can use
	e.g. printIt: [FileStream readOnlyFileNamed: 'SVNDummy.st' do: [:stream | stream contents]]
	after doing a fileout"
	"do it: [self new restoreSVNDummy]."
	| stream |
	stream :=  ReadWriteStream with:  '''From Squeak3.9.1 of 2 March 2008 [latest update: #7075] on 14 April 2008 at 10:36:05 pm''!!
Object subclass: #SVNDummy
	instanceVariableNames: ''i1 i2''
	classVariableNames: ''C1 C2''
	poolDictionaries: ''''
	category: ''SqueakSVN-Base-Test''!!
!!SVNDummy commentStamp: ''<historical>'' prior: 0!!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!!


!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 3/14/2008 02:25''!!
< other

	^ super < other!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''test 2/23/2008 11:54''!!
m1
	^ 1!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 4/14/2008 22:22''!!
m2
	^ 2!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''cop 2/7/2008 19:50''!!
methodWithSpecialCharacter: aString
	^ aString!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 4/14/2008 22:35''!!
onInstanceAndClassSide

	"Methods with this name are on instance and on class side of SVNDummy."!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

SVNDummy class
	instanceVariableNames: ''IC1 IC2''!!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''cop 2/7/2008 19:50''!!
m3

	^ 3!! !!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''rkrk 4/14/2008 22:35''!!
onInstanceAndClassSide!! !!


!!SVNDummy class methodsFor: ''convenience'' stamp: ''cop 2/7/2008 19:50''!!
sourceCodeForM2
	^ ''m2
	^ 2''!! !!
'.
	stream
		reset;
		fileInAnnouncing: 'Restoring SVNDummy';
		close.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/16/2008 02:57'!
setUp

	"[SVNTestDirectoryManager instance: nil]"
	super setUp.
	self hasModifiedSVNDummy: false.
	self directoryManager: SVNTestDirectoryManager getInstance.
	self directoryManager testDirectories ifEmpty: [
		self directoryManager
			basePath: (FileDirectory default directoryNamed: 'svnTests') pathName;
			createBasicTestDirs: 200 svnAwareTestDirs: 50]! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 04:22'!
slash

	^ slash! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:23'!
slash: string

	slash := string! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:01'!
sourceCodeForSVNDummyM2

	^ 'm2
	^ 2'! !

!SVNTestCase methodsFor: 'svn helper' stamp: 'rkrk 3/4/2008 00:58'!
svnClientDo: aBlock

	aBlock value: SVNCApiClient new.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:58'!
svnDirectoryForWorkingCopy
	
	"equals defaultSVNDirectory when registered for svnAware testDirs"
	^ SVNDirectory on: self workingCopyPath.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:58'!
svnDirectoryForWorkingCopy2
	
	"equals defaultSVNDirectory when registered for svnAware testDirs"
	^ SVNDirectory on: self workingCopyPath2.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:07'!
svnDummy

	"For not retrieving an obsolete class"
	^ Smalltalk classNamed: 'SVNDummy'.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'mu 3/4/2008 11:20'!
svnDummy99

	"For not retrieving an obsolete class"
	^ Smalltalk classNamed: 'SVNDummy99'.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/15/2008 02:45'!
tearDown

	super tearDown.
	self
		"cleanupFileSystem;"
		cleanupSVNDummy.
	self directoryManager unregister.
	
	"Quick fix until old system notfication mechanism is fully abandoned"
	SVNClass allInstances do: [:ea | ea notifyAboutSystemModifications: false].
	SVNProject allInstances do: [:ea | ea notifyAboutSystemModifications: false].
	SVNEnvironment allInstances do: [:ea | ea notifyAboutSystemChanges: false].! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/4/2008 02:29'!
willModifySVNDummy

	self hasModifiedSVNDummy: true.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/3/2008 01:51'!
willNeedRepositoryAndTwoWorkingCopies

	self directoryManager registerForSvnAwareTestDirectoryWithTwoWorkingCopies.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/15/2008 01:56'!
willNeedRepositoryAndWorkingCopy

	self directoryManager registerForSvnAwareTestDirectory.! !

!SVNTestCase methodsFor: 'running' stamp: 'test 3/16/2008 03:02'!
willTouchFileSystem
	
	self flag: #TODO.
	self directoryManager registerForTestDirectory.
	"do nothing? directoryManager already has a new
	current directory because of #unregister"
	"self directoryManager registerForTestDirectory."! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'test 3/15/2008 04:34'!
workingCopyPath

	^ self directoryManager workingCopyPath! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 03:13'!
workingCopyPath2

	^ self directoryManager workingCopyPath2! !

SVNTestCase subclass: #SVNUpdateRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 03:35'!
testDoSimpleUpdate

	| content file |
	self willNeedRepositoryAndWorkingCopy.
	content := 'ABCabcXYZxyz'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self pathForTests
		content: content.
	file
		store;
		commit;
		update;
		read.
	self assert: file content = content.
	! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 00:47'!
testDoSimpleUpdateOfDeletedFile

	| content file |
	self willNeedRepositoryAndWorkingCopy.
	content := 'ABCabcXYZxyz'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self pathForTests
		content: content.
	file
		store;
		commit;
		delete.
	self
		denyThatFiles: {file path}
		existsIn: file basePath.
	self defaultSVNDirectory update.
	self
		assertThatFiles: {file path}
		existsIn: file basePath.
	file read.
	self assert: file content = content.
	! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/7/2008 15:37'!
testDoUpdateWithTwoWCsAndLocalChanges

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent changedContent2 |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"Change first file and update"
	changedContent2 := 'sjk gnalkj bskjjbcsklj nv'.
	fileInFirstWC
		content: changedContent2;
		store;
		update;
		read.
	self flag: #TODO. "Test status. Should be conflicted."
	self assert: fileInFirstWC status isConflicted.
	"self assert: fileInFirstWC content = changedContent2."! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 03:21'!
testDoUpdateWithTwoWCsAndWithoutLocalChanges

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"check if anything is fine"
	fileInFirstWC
		update;
		read.
	self assert: fileInFirstWC content = changedContent.
	self flag: #TODO. "Check status. Should be normal"
	self assert: fileInFirstWC svnInfo schedule = 'normal'.! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 03:33'!
testLocalChangesShouldStayAfterUpdate

	| file originalContent newContent |
	self willNeedRepositoryAndWorkingCopy.
	originalContent := 'ABCabcXYZxyz'.
	newContent := 'Changed content'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self workingCopyPath.
	file
		content: originalContent;
		store;
		commit;
		content: newContent;
		store;
		update;
		read.
	self assert: file content = newContent.! !

TestCase subclass: #SVNTestDirectoryManagerTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNTestDirectoryManagerTest methodsFor: 'default' stamp: 'rkrk 3/15/2008 00:27'!
pathForManager

	^ (FileDirectory default directoryNamed: 'TestManagerTestDir') pathName! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:33'!
setUp
	super setUp.
	"SVNTestDirectoryManager is a singleton. For tests get own copy"
	sut := SVNTestDirectoryManager basicNew initialize.
	sut basePath: self pathForManager.! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:34'!
tearDown
	
	super tearDown.
	sut clear.
	(FileDirectory on: self pathForManager) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:42'!
testAccessingWorkingCopy2WithoutRegisteringShouldFail

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 1.
	sut registerForSvnAwareTestDirectory.
	self should: [sut workingCopyPath2] raise: AssertionFailure.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:58'!
testAfterRegisterAnswerSameDirectory

	| directory |
	sut
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	sut registerForTestDirectory.
	directory := sut currentDirectory.
	self assert: directory notNil.
	self assert: sut pathForTests = directory pathForTests.
	self assert: sut currentDirectory == directory.
	sut unregister.
	self deny: sut currentDirectory == directory.
	"self should: [sut pathForTests] raise: AssertionFailure"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:59'!
testCallingSvnAwareMethods

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 3.
	sut registerForSvnAwareTestDirectory.
	self assert: sut workingCopyPath = sut currentDirectory workingCopyPath.
	self assert: sut repositoryURLPath = sut currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:43'!
testCallingSvnAwareMethodsWithWorkingCopy2

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 1.
	sut registerForSvnAwareTestDirectoryWithTwoWorkingCopies.
	self assert: sut workingCopyPath = sut currentDirectory workingCopyPath.
	self assert: sut workingCopyPath2 = sut currentDirectory workingCopyPath2.
	self assert: sut repositoryURLPath = sut currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:01'!
testCallingSvnAwareMethodsWithoutProperRegisteringShouldFail

	sut
		createBasicTestDirs: 2
		svnAwareTestDirs: 1.
	sut registerForTestDirectory.
	self should: [sut workingCopyPath] raise: AssertionFailure.
	self should: [sut repositoryURLPath] raise: AssertionFailure.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 06:28'!
testCreateAgainShouldUseAlreadyExistingDirectories

	| someElement |
	sut 
		createBasicTestDirs: 3
		svnAwareTestDirs: 0.
	someElement := sut testDirectories anyOne.
	sut 
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	self assert: sut basicTestDirectories size = 5.
	self assert: (sut testDirectories includes: someElement).! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/18/2008 23:49'!
testPercent

	self assert: (sut percent: 30 of: 80) = 24.
	self assert: (sut percent: 10 of: 3) = 1. "Be at least one"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:32'!
testRecreate10Percent

	sut 
		createBasicTestDirs: 10
		svnAwareTestDirs: 0.
	5 timesRepeat: [
		sut registerForTestDirectory.
		sut currentDirectory isDirty: true.
		sut unregister].
	sut reCreatePercent: 10.
	self assert: (sut testDirectories count: [:ea | ea isDirty not]) = 6.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:02'!
testRegisteringMoreOftenThanTheDefaultNumberOfPreparedDirectories

	| numberOfTimesToRegister |
	sut createBasicTestDirs: 5 svnAwareTestDirs: 0.
	numberOfTimesToRegister := sut basicTestDirectories size + 3.
	numberOfTimesToRegister timesRepeat: [
		sut registerForTestDirectory.
		self deny: sut currentDirectory isDirty.
		sut currentDirectory isDirty: true.
		sut unregister].! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'test 3/16/2008 06:16'!
testShouldClearOldDirectories

	| sutFileDirectory |
	sut 
		createBasicTestDirs: 20
		svnAwareTestDirs: 0.
	sutFileDirectory := FileDirectory on: sut basePath.
	self assert: sutFileDirectory entries size = 20.
	sut 
		createBasicTestDirs: 12
		svnAwareTestDirs: 0.
	self assert: sutFileDirectory entries size = 12.! !

TestCase subclass: #SVNTestDirectoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

SVNTestDirectoryTest subclass: #SVNAwareTestDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNAwareTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 20:52'!
setUp
	super setUp.
	sut := SVNAwareTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:24'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:28'!
testCheckConsistency03

	sut 
		create;
		createSecondWorkingCopy.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:11'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut workingCopyDirectory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut repositoryDirectory exists.
	self deny: sut workingCopyDirectory exists.
	self deny: sut directory exists.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:22'!
testCreateDoesNotCreateAutomaticallySecondWorkingCopy

	| directory |
	sut create.
	directory := sut directory.
	self deny: (directory directoryExists: 'workingCopy2').! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:48'!
testCreateInBasepath

	| directory |
	sut create.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self assert: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:34'!
testCreateWorkingCopy2AndBeDirty

	sut
		create;
		createSecondWorkingCopy.
	self assert: (sut directory directoryExists: 'workingCopy2').
	self assert: (sut workingCopyDirectory2 directoryExists: '.svn').
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:56'!
testPathForTestIsWorkingCopyPath

	self assert: sut pathForTests = sut workingCopyPath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:07'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:55'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/15/2008 15:57'!
setUp

	super setUp.
	sut := SVNTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNTestDirectoryTest methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:09'!
somePath

	| localName dir |
	localName := 'forSVNTestDirectoryTest'.
	dir := FileDirectory default.
	dir assureExistenceOfPath: localName.
	^ dir pathName , dir slash , localName.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:25'!
tearDown

	super tearDown.
	self flag: #TODO.
	(FileDirectory on: self somePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut directory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testCreateInBasepath

	sut create.
	self deny: sut isDirty.
	self assert: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:05'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:54'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

TestCase subclass: #SVNUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNUserTest methodsFor: 'as yet unclassified' stamp: 'rt 3/30/2008 21:03'!
testIfEqual

	| sut1 sut2 |
	sut1 := SVNUser user: 'User' password: 'password'.
	sut2 := SVNUser user: 'User' password: 'password'.
	
	self assert: sut1 = sut2.! !

!SVNUserTest methodsFor: 'as yet unclassified' stamp: 'test 4/9/2008 00:10'!
testIfNotEqual

	| sut1 sut2 sut3 |
	sut1 := SVNUser user: 'User' password: 'password'.
	sut2 := SVNUser user: 'User2' password: 'password'.
	sut3 := SVNUser user: 'User' password: 'password2'.

	self deny: sut1 = sut2.
	self deny: sut1 = sut3.
	self deny: sut2 = sut3.! !

!CompiledMethod methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 22:33'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnMethodForMethodRef: self methodReference) notNil! !

Object subclass: #Class1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class1 commentStamp: '<historical>' prior: 0!
A Class1 is xxxxxxxxx.

Instance Variables
!

!Class1 methodsFor: 'as yet unclassified' stamp: 'mu 3/27/2008 18:35'!
nurzumTesten
	^true! !

Object subclass: #Class2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class2 commentStamp: '<historical>' prior: 0!
A Class2 is xxxxxxxxx.

Instance Variables
!

Object subclass: #Class3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class3 commentStamp: '<historical>' prior: 0!
A Class3 is xxxxxxxxx.

Instance Variables
!

!Object methodsFor: '*SqueakSVN' stamp: 'rkrk 3/23/2008 01:54'!
forSvnPrimitive

	self error: 'I should not be passed down to a SVN primitive!!'! !

!Object methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 04:13'!
includedInSvnEnvironment: svnEnvironment

	^ false! !

Object subclass: #SVNBlameStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNBlameStyler class methodsFor: 'functionality' stamp: 'cop 4/7/2008 18:44'!
createArrayFromBlameLines: anOrderedCollection
	^self new createArrayFromBlameLines: anOrderedCollection! !

!SVNBlameStyler class methodsFor: 'functionality' stamp: 'cop 3/18/2008 14:04'!
createTextFromBlameLines: anOrderedCollection
	^self new createTextFromBlameLines: anOrderedCollection! !

!SVNBlameStyler methodsFor: 'functionality' stamp: 'cop 4/8/2008 14:12'!
addTo: aTCol from: aSCol startAt: aIndex
	| index |
	index := aIndex.
	[ aTCol add: (aSCol at: index).
	  index := index + 5. ]
		doWhileTrue: [ index <= aSCol size ].! !

!SVNBlameStyler methodsFor: 'functionality' stamp: 'cop 4/10/2008 11:00'!
createArrayFromBlameLines: anOrderedCollection
	| revisionCollection authorCollection lineCollection codeCollection |
	revisionCollection := OrderedCollection new add: 'Revision'; yourself.
	authorCollection := OrderedCollection new add: 'Author'; yourself.
	lineCollection := OrderedCollection new add: 'Line'; yourself.
	codeCollection := OrderedCollection new add: 'Code'; yourself.

	anOrderedCollection isEmpty ifFalse:
		[self addTo: 	revisionCollection from: anOrderedCollection startAt: 1.
		 self addTo: authorCollection from: anOrderedCollection startAt: 2.
		 self addTo: lineCollection from: anOrderedCollection startAt: 4.
		 self addTo: codeCollection from: anOrderedCollection startAt: 5.].
	
	^Array with: revisionCollection asArray with: authorCollection asArray with: lineCollection asArray with: codeCollection asArray.! !

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient class methodsFor: 'unloading' stamp: 'rkrk 4/10/2008 14:43'!
buttonForUnloading

	"self buttonForUnloading"
	(SimpleButtonMorph newWithLabel: 'Unload SqueakSVNPlugin')
		target: self;
		actWhen: #buttonDown;
		actionSelector: #unloadSqueakSVN;
		openInWorld.! !

!SVNCApiClient class methodsFor: 'unloading' stamp: 'rkrk 4/10/2008 14:00'!
unloadSqueakSVN

	UIManager default inform: 'Unloading SqueakSVNPlugin'.
	SmalltalkImage current unloadModule: 'SqueakSVNPlugin'.! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 12:56'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/11/2008 12:41'!
basicSvnAddProperty: property WithValue:value To: target
 
	<primitive: 'svnAddPropertyWithValueTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 15:43'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath
 
	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 13:45'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	<primitive: 'svnCheckoutRevisionByNumberFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/20/2008 12:18'!
basicSvnCleanupDirectory: directoryPath
	<primitive: 'svnCleanupDirectory' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 3/6/2008 11:04'!
basicSvnCommit: collectionOfPathesToTargets withMessage: aString
 
	<primitive: 'svnCommitWithMessage' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/10/2008 15:59'!
basicSvnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets

	<primitive: 'svnDeleteTargetsFromWorkingCopy' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'cop 3/9/2008 16:47'!
basicSvnGetBlameLinesFrom: target
 
	<primitive: 'svnGetBlameLinesFrom' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 3/18/2008 11:41'!
basicSvnGetCommitLogFrom: target to: headRevisionNumber 
	<primitive: 'svnGetCommitLogFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 4/1/2008 17:31'!
basicSvnGetCommitLogs: count from: targetStringForSvnPrimitive to: revisionNumberOop storeInArray: resultArray
	<primitive: 'svnGetCommitLogsFromToStoreInArray' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 4/1/2008 14:12'!
basicSvnGetCountOfCommitLogsFrom: target to: headRevisionNumber 
	<primitive: 'svnGetCountOfCommitLogsFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnGetHeadRevision: pathToTarget

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 3/20/2008 13:27'!
basicSvnGetPropertiesFrom: target
 
	<primitive: 'svnGetPropertiesFrom' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/19/2008 17:18'!
basicSvnRevertTargets: targets
	<primitive: 'svnRevertTargets' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:18'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber
 
	<primitive: 'svnUpdateTargetsToRevisionByNumber' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets
 
	<primitive: 'svnUpdateTargetsToHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/1/2008 13:16'!
basicSvnGetCountCommitLogFrom: target

	| commitLogArray |
	commitLogArray := (self
		basicSvnGetCountCommitLogFrom: target
		to: (self svnGetHeadRevision: target)).
		
	^commitLogArray! !

!SVNClient methodsFor: 'converting' stamp: 'test 3/26/2008 00:12'!
normalizePath: aString 

	self flag: #TODO. "Find my senders, replace method call an delete me"
	^ aString pathForSvn! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 2/25/2008 11:54'!
svnAdd: aPath 

	^self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'test 3/1/2008 02:36'!
svnAddProperty: property WithValue:value To: target

	| propertyToAdd valueToAdd |
	self flag: #TODO. "Make conversion more clear and consider read also"
	propertyToAdd := property = ''
		ifTrue: ['nil']
		ifFalse: [property].
	valueToAdd := value = ''
		ifTrue: ['nil']
		ifFalse: [value asString].
	^self
		basicSvnAddProperty: propertyToAdd
		WithValue: valueToAdd
		To: (self normalizePath: target).! !

!SVNClient methodsFor: 'accessing' stamp: 'test 3/14/2008 03:55'!
svnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self
		basicSvnCheckoutHeadRevisionFrom: (self normalizePath: repositoryURL)
		to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 14:56'!
svnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath

	self basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 3/20/2008 12:19'!
svnCleanupDirectory: directoryPath 

	^self basicSvnCleanupDirectory: (self normalizePath: directoryPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 18:59'!
svnCommit: aCollection 

	self svnCommit: aCollection withMessage: 'empty commit message'.! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 3/5/2008 15:54'!
svnCommit: aCollection withMessage: aString

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnCommit: commitArray withMessage: aString! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 3/10/2008 16:00'!
svnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets 
	| deleteArray |
	deleteArray := collectionOfPathsToTargets 
				collect: [:each | self normalizePath: each].
	self basicSvnDeleteTargetsFromWorkingCopy: deleteArray! !

!SVNClient methodsFor: 'accessing' stamp: 'cop 3/9/2008 17:04'!
svnGetBlameLinesFrom: target

	^self basicSvnGetBlameLinesFrom: (self normalizePath: target).! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/1/2008 19:45'!
svnGetCommitLogFrom: target

	^ self svnGetCommitLogsFrom: target! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/1/2008 21:10'!
svnGetCommitLogsFrom: target

	| commitLogArray allCommitLogs count |
	count := self svnGetCountOfCommitLogsFrom: target.
	commitLogArray := ( (1 to: 4*count) collect: [:index | String new: 1024] ) asArray.
	
	self
		basicSvnGetCommitLogs: count
		from: (self normalizePath: target)
		to: (self svnGetHeadRevision: target)
		storeInArray: commitLogArray.
	
	allCommitLogs := OrderedCollection new.
	commitLogArray ifEmpty: [^ allCommitLogs].
	1 to: (commitLogArray size) by: 4 do: [:i | 
		(allCommitLogs add:(SVNCommitLog 
				createCommitLogWithRevision: ((commitLogArray at: i) asInteger)
				author: ((commitLogArray at: i+1) asDefaultDecodedString copyUpTo: (Character value: 0))
				date: ((commitLogArray at: i+2) asDefaultDecodedString copyUpTo: (Character value: 0)) 
				comment: ((commitLogArray at: i+3) asDefaultDecodedString copyUpTo: (Character value: 0))))
		].  
	^ allCommitLogs! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/1/2008 20:44'!
svnGetCountOfCommitLogsFrom: target

	^ (self
		basicSvnGetCountOfCommitLogsFrom: (self normalizePath: target)
		to: (self svnGetHeadRevision: target))! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 02:34'!
svnGetHeadRevision: aPath

	^ self basicSvnGetHeadRevision: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 3/20/2008 00:02'!
svnGetPropertiesFrom: target

	| propertyArray popertyDict correctKey correctValue |
	propertyArray := (self basicSvnGetPropertiesFrom: (self normalizePath: target)).
	popertyDict := Dictionary new.
	propertyArray ifNil: [^ popertyDict].
	self flag: #TODO. "Remove the nil things. They are not needed."
	propertyArray pairsDo: [:key :value |
		correctKey := key = 'nil'	ifTrue: [''] ifFalse: [key].
		correctValue := value = 'nil' ifTrue: [''] ifFalse: [value].
		popertyDict at: correctKey put: correctValue].
	^ popertyDict.! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 3/20/2008 14:17'!
svnRevertTargets: targets

	| arrayOfTargets |
	arrayOfTargets := targets collect: [:each | self normalizePath: each].
	^self basicSvnRevertTargets: arrayOfTargets! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:25'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargets: updateArray toRevisionByNumber: revisionNumber! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:21'!
svnUpdateTargetsToHeadRevision: aCollection 

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargetsToHeadRevision: updateArray! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 20:26'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 2].].! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:08'!
basicSvnAdd: aPath 

	self executeViaOSProcessSynchronously: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'pe 2/26/2008 13:29'!
basicSvnAddProperty: key WithValue: value To: path

	| command |
	command := self buildCmdPropset: key value: value for: path.
	self executeViaOSProcessSynchronously: command.! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:35'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:37'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self executeViaOSProcessSynchronously: 'svn co -r ' , revisionNumber asString , ' ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'pe 3/6/2008 11:16'!
basicSvnCommit: collectionOfTargets withMessage: aString

	| targets |
	targets := collectionOfTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn commit' , targets , ' -m "',aString,'"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:49'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up -r', revisionNumber asString , targets! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:44'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up' , targets! !

!SVNCommandLineClient methodsFor: 'build commands' stamp: 'pe 2/26/2008 13:27'!
buildCmdPropset: key value: value for: path 
	
	^ 'svn propset ' , key , ' ' , value , ' ' , path.! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rkrk 3/16/2008 07:38'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 2].].! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'test 3/26/2008 00:13'!
normalizePath: aPath

	^'"' , aPath pathForSvn , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 14:21'!
svnGetHeadRevision: aPath

	self flag: #TODO. "Dirty hack. Extract headrevision from
	the output of the command line somehow."
	^ SVNCApiClient new svnGetHeadRevision: aPath! !

Object subclass: #SVNCommand
	instanceVariableNames: 'target requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCommand class methodsFor: 'converting' stamp: 'rkrk 4/12/2008 11:32'!
on: target for: requestor
	
	^ self new
		target: target;
		theRequestor: requestor;
		yourself.! !

!SVNCommand class methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:56'!
takesNodes

	^ true! !

!SVNCommand class methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:56'!
takesText

	^ false! !

!SVNCommand methodsFor: 'menu' stamp: 'rkrk 4/12/2008 11:19'!
addItemToMenu: aMenu

	self isActive ifFalse: [^ self].
	aMenu
		add: self label
		target: self
		action: #execute.! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
buttonLabel

	^ self label! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:49'!
cluster

	^ #SVN! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 12:35'!
createCluster
	^ OBCommandCluster label: self cluster! !

!SVNCommand methodsFor: 'execution' stamp: 'rkrk 4/6/2008 20:15'!
execute! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
group

	^ #SVN! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
isActive

	^ false! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:20'!
isEnabled

	^ true! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 13:28'!
keystroke
	^ nil
! !

!SVNCommand methodsFor: 'default' stamp: 'rkrk 4/6/2008 20:15'!
label

	^ 'No label'! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
longDescription

	"Override this and return a string or a text for the fly-by-help (tooltip)"
	^ nil! !

!SVNCommand methodsFor: 'menu' stamp: 'rkrk 4/7/2008 01:09'!
perform: aSelector orSendTo: anObject
	"needed by the menu action invocation"
	self perform: aSelector! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:25'!
target
	^ target! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:25'!
target: anObject
	target := anObject! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:28'!
theRequestor
	^ requestor! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:29'!
theRequestor: anObject
	
	requestor := anObject! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
wantsButton

	^ false! !

SVNCommand subclass: #SVNCreateProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCreateProjectCommand methodsFor: 'executing' stamp: 'cop 4/14/2008 11:33'!
execute

	SVNCreateProjectDialog call ifNotNilDo: [:svnProject |
		svnProject checkout; load.
		self theRequestor projectNodes add: (SVNProjectNode element: svnProject).
		self theRequestor updateTree].
	! !

!SVNCreateProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 22:35'!
isActive

	^ self target isNil! !

!SVNCreateProjectCommand methodsFor: 'default' stamp: 'rkrk 4/6/2008 21:36'!
label

	^ 'Create Project'! !

!SVNCreateProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
wantsButton

	^ true! !

SVNCommand subclass: #SVNElementCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNElementCommand subclass: #SVNAddToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddToCurrentProjectCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 05:27'!
execute

	"Wahhhhhhhhhhhhh!!!!!!!! Refactooooooooooor!!!!!!!!"
	| project svnClass |
	self flag: #TODO.
"	self halt."
	project := self target svnEnvironment findSvnProjectFor: self target svnElement.
	project = self target currentSvnProject
		ifTrue: [UIManager default inform:
			'SVNElement is already a member of the project ' ,  project theName. ^ self].
	(project isNil and: [self svnElement isNil])
		ifTrue: [
			(self target isKindOf: OBClassNode)
				ifTrue: [self target currentSvnProject addClass: self target theClass].
			(self target isKindOf: OBMethodNode)
				ifTrue: [
					"self halt."
					svnClass := (self target svnEnvironment findSvnClassFor: self target theNonMetaClass).
					svnClass
						ifNil: [self target currentSvnProject
								addMethod: self target reference compiledMethod]
						ifNotNil: [svnClass addMethod: (SVNMethod forExistingMethod: self target reference compiledMethod)]
					
					].
				self target currentSvnProject store.
				self theRequestor announce: (OBNodeChanged node: self target).
				^ self].
	
	(project isNil and: [self svnElement notNil])
		ifTrue: [
			"Kludge. Use double dispatch"
			(self target svnElement isKindOf: SVNMethod)
			ifTrue: [
				svnClass := self target svnEnvironment findSvnClassFor: self target theClass.
				(svnClass notNil and: [self target svnEnvironment includes: svnClass])
					ifTrue: [svnClass addMethod: self target svnElement]
					ifFalse: [self target currentSvnProject addMethod: self target svnElement]]
			ifFalse: [self target currentSvnProject addClass: self target svnElement]]
		ifFalse: [UIManager default confirm:
			'SVNElement is already a member of the project ' ,
				project theName ,
				'. Remove it and add it to the current project ' ,
				self target currentSvnProject theName , '?'].
		self target currentSvnProject store.
		self theRequestor announce: (OBNodeChanged node: self target).! !

!SVNAddToCurrentProjectCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 05:14'!
isActive

	^ self target notNil and:
		[self target currentSvnProject notNil] and:
		[(self target isKindOf: OBMethodNode) or: [self target isKindOf: OBClassNode]].! !

!SVNAddToCurrentProjectCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/12/2008 22:39'!
label

	^ 'Add to current project'! !

SVNElementCommand subclass: #SVNClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNClassCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:40'!
isActive

	^ self target notNil and: [self target hasSvnElementOfKind: SVNClass]! !

!SVNClassCommand methodsFor: 'derived accessing' stamp: 'rkrk 4/12/2008 12:45'!
svnClass

	self assert: (self svnElement isKindOf: SVNClass).
	^ self svnElement! !

SVNClassCommand subclass: #SVNDeleteClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDeleteClass methodsFor: 'execution' stamp: 'rkrk 4/12/2008 11:51'!
execute

	| svnProject |
	UIManager default inform: 'Menno, I want to be a SVNElementDeleteCommand!!!!!!'.
	svnProject := self target parent svnElement. "Oha, lots of assumptions here..."
	svnProject removeClass: self svnClass.! !

!SVNDeleteClass methodsFor: 'default' stamp: 'rkrk 4/7/2008 01:27'!
label

	^ 'Delete element'! !

SVNElementCommand subclass: #SVNCommitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCommitCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:54'!
execute
	
	SVNCommitBrowser openWith: self svnElement.! !

!SVNCommitCommand methodsFor: 'execution' stamp: 'rkrk 4/12/2008 12:07'!
label

	^ 'Commit SVNElement'! !

!SVNElementCommand methodsFor: 'testing' stamp: 'rkrk 4/14/2008 12:03'!
isActive

	^ self target notNil and:
		[self target belongsToCurrentSvnProject] and:
		[self target hasSvnElementOfKind: SVNElement]! !

!SVNElementCommand methodsFor: 'accessing' stamp: 'cop 4/14/2008 09:40'!
svnElement

	^ self target svnElement! !

SVNElementCommand subclass: #SVNProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNProjectCommand subclass: #SVNCheckoutCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCheckoutCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:22'!
execute

	self svnProject checkout! !

!SVNCheckoutCommand methodsFor: 'default' stamp: 'rkrk 4/7/2008 01:22'!
label

	^ 'Checkout project'! !

SVNProjectCommand subclass: #SVNChooseAndAddClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNChooseAndAddClassCommand methodsFor: 'execution' stamp: 'cop 4/10/2008 12:28'!
execute

	| className |
	className := SVNRequestDialog
		ask: 'Enter class name'
		template: String new
		canAcceptBlock: [:text | Smalltalk hasClassNamed: text asString.].
	className ifNil: [^ self].
	self svnProject addClass: (Smalltalk classNamed: className asString)! !

!SVNChooseAndAddClassCommand methodsFor: 'default' stamp: 'rkrk 4/7/2008 04:13'!
label

	^ 'Add class to project'! !

!SVNProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:39'!
isActive

	^ self target notNil and: [self target hasSvnElementOfKind: SVNProject]! !

!SVNProjectCommand methodsFor: 'derived accessing' stamp: 'rkrk 4/12/2008 12:44'!
svnProject

	self assert: (self svnElement isKindOf: SVNProject).
	^ self svnElement! !

SVNProjectCommand subclass: #SVNSetURLCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNSetURLCommand methodsFor: 'executing' stamp: 'pe 4/14/2008 15:17'!
execute

	| newUrl |
	newUrl := SVNRequestDialog
		ask: self label
		template: self svnProject repositoryURL asString
		canAcceptBlock: [:text | text notNil].
	newUrl ifNotNil: [self svnProject repositoryURL: newUrl asString].! !

!SVNSetURLCommand methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:24'!
label

	^ 'Edit SVNProject URL'! !

SVNProjectCommand subclass: #SVNSetWorkingCopyPathCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNSetWorkingCopyPathCommand methodsFor: 'executing' stamp: 'rkrk 4/7/2008 01:00'!
execute

	| newWCPath |
	self flag: #TODO. "SVNProjects will soon have no working copy path any longer.
	They will specify their project directory instead."
	newWCPath := SVNRequestDialog
		ask: self label
		template: self svnProject workingCopyDirectory path
		canAcceptBlock: [:text | text notNil].
	self flag: #TODO. "Setting the workingcopy path is not so easy!!
	All subentries have to be updated!!"
	(UIManager default confirm: 'This operation will not work in an expected way. Continue?')
		ifTrue:[newWCPath ifNotNil: [
				self svnProject workingCopyDirectory: (SVNDirectory on: newWCPath asString)]].! !

!SVNSetWorkingCopyPathCommand methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 00:02'!
label

	^ 'Edit working copy path'! !

SVNElementCommand subclass: #SVNRevertCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNRevertCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:55'!
execute
	
	self svnElement revert! !

!SVNRevertCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:59'!
label

	^ 'Revert'! !

SVNElementCommand subclass: #SVNUpdateCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNUpdateCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:50'!
execute
	
	self svnElement update! !

!SVNUpdateCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:59'!
label

	^ 'Update'! !

Object subclass: #SVNCommitLog
	instanceVariableNames: 'revision author date comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

SVNCommitLog class
	instanceVariableNames: 'revision author date comment'!

SVNCommitLog class
	instanceVariableNames: 'revision author date comment'!

!SVNCommitLog class methodsFor: 'instance creation' stamp: 'rkrk 4/3/2008 15:35'!
createCommitLogWithRevision: aRevision author: anAuthor date: aDate comment: aComment

	^ self new
		revision: aRevision;
		author: anAuthor;
		date: aDate;
		comment: aComment.! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
author
	^ author! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:17'!
author: anAuthor
	author := anAuthor! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:15'!
comment
	^ comment! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:17'!
comment: aComment
	comment := aComment! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
date
	^ date! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:18'!
date: aDate
	date := aDate! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
revision
	^ revision! !

!SVNCommitLog methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:18'!
revision: aRevision
	revision := aRevision! !

!SVNCommitLog methodsFor: 'printing' stamp: 'rkrk 4/3/2008 15:36'!
revisionAuthorDateString

	^ self revision asString, ' - ', self author , ' ' , self date asDateAndTime asTimeStamp asString! !

Object subclass: #SVNCurrentProjectChanged
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!SVNCurrentProjectChanged class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/11/2008 19:49'!
forProject: svnProject

	^ self new
		currentProject: svnProject;
		yourself.! !

!SVNCurrentProjectChanged methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:04'!
currentProject
	^currentProject! !

!SVNCurrentProjectChanged methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:04'!
currentProject: aSVNProject
	currentProject := aSVNProject! !

Object subclass: #SVNDirectoryEntry
	instanceVariableNames: 'theName basePath properties commitLogs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

SVNDirectoryEntry subclass: #SVNDirectory
	instanceVariableNames: 'subdirectories files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 18:05'!
= other

	^ super = other and:
		[self files = other files] and:
			[self subdirectories = other subdirectories]! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 4/2/2008 17:02'!
addFile: svnFile

	"assure that there is no file with the same name"
	"self assert: (self files noneSatisfy: [:file |
		file theName = svnFile theName and: [file ~~ svnFile]])."
	"self files removeAllSuchThat: [:file | file theName = svnFile theName]."
	| alreadyExistingFile |
	svnFile basePath: self path.
	alreadyExistingFile := self files
		detect: [:file | file theName = svnFile theName]
		ifNone: [^ self files add: svnFile].
	^ alreadyExistingFile
		properties: svnFile properties;
		content: svnFile content;
		yourself.! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 4/2/2008 17:08'!
addSubdirectory: svnDirectory

	"assure that there is no file with the same name"
	"self assert: (self subdirectories noneSatisfy: [:dir |
		dir theName = svnDirectory theName and: [dir ~~ svnDirectory]])."
	"self subdirectories detect: [:dir | dir theName = svnDirectory theName]."
	| subdirectory |
	svnDirectory basePath: self path.
	subdirectory := self subdirectories
		detect: [:dir | dir theName = svnDirectory theName]
		ifNone: [self subdirectories add: svnDirectory].
	
	subdirectory
		properties: svnDirectory properties;
		subdirectories: svnDirectory subdirectories;
		files: svnDirectory files.
			
	self flag: #TODO. "Ugly. How to inform subdirectories and files about new basepath?"
	svnDirectory subdirectories do: [:ea | svnDirectory addSubdirectory: ea].
	svnDirectory files do: [:ea | svnDirectory addFile: ea].
	
	^ subdirectory! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'rkrk 3/3/2008 21:13'!
assureExistenceInParent
	"create a directory with the name 'theName' in 'self basePath' if it does not exists and add the directory to the working copy"

	| directory client |
	directory := FileDirectory on: self path.
	directory exists ifTrue: [^ self].
	
	(directory directoryExists: self basePath) ifFalse: [^ self].
	
	directory createDirectory: self path.
	client := SVNCApiClient new.
	client svnAdd: self path.! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'test 3/5/2008 00:16'!
createFileNamed: filename 

	^ self
		createFileNamed: filename
		withContent: String new.! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 3/5/2008 01:38'!
createFileNamed: filename withContent: content

	| newFile |
	newFile := SVNFile
		named: filename
		basePath: self path
		content: content.
	self addFile: newFile.
	^ newFile! !

!SVNDirectory methodsFor: 'subdirectory manipulation' stamp: 'rt 3/14/2008 15:20'!
createSubDirectoryNamed: aString 
	
	| newDirectory |
	self flag: #TODO. "Test schreiben!!!!!!!!"
	(self subdirectories anySatisfy: [:each | each theName = aString])
		ifTrue: [^ (self subdirectories detect: [:each | each theName = aString])].
	newDirectory := self class
		named: aString
		basePath: self path.
	self addSubdirectory: newDirectory.
	^ newDirectory.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 3/4/2008 06:13'!
delete

	| fileDir dotSvnDir |
	fileDir := FileDirectory on: self basePath.
	
	self flag: #TODO.
	fileDir deleteFileNamed: '.DS_STORE'.
	dotSvnDir := SVNDirectory named: '.svn' basePath: self path.
	(FileDirectory on: dotSvnDir path) exists ifTrue:
		[dotSvnDir read.
		dotSvnDir recursivelyDo: [:svnDirectoryEntry |
			svnDirectoryEntry delete]].
	
	fileDir := FileDirectory on: self basePath.
	(fileDir directoryExists: self theName asString) ifFalse: [^ self].
	fileDir deleteDirectory: self theName.! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:51'!
directoryExists: directoryName 

	^ self subdirectories anySatisfy: [:each |
		each theName = directoryName]! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:35'!
fileExists: fileName

	^ self files anySatisfy: [:each | fileName = each theName].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files
	^ files! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files: anObject
	files := anObject! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getFileNamed: fileName 
	
	^ self files
		detect: [:each | each theName = fileName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getSubDirectoryNamed: directoryName 
	
	^ self subdirectories
		detect: [:each | each theName = directoryName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:46'!
hash

	^ (super hash bitXor: self files hash) bitXor: self subdirectories hash! !

!SVNDirectory methodsFor: 'initialization' stamp: 'rkrk 4/2/2008 12:01'!
initialize

	super initialize.
	self
		files: OrderedCollection new;
		subdirectories: OrderedCollection new;
		theName: String new! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/2/2008 15:11'!
pathsOfAllElements

	| entries |
	entries := self files copy.
	entries addAll: self subdirectories.
	^ entries collect: [:each | each path].! !

!SVNDirectory methodsFor: 'printing' stamp: 'rkrk 4/2/2008 12:13'!
printOn: aStream

	| printBlock |
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self path;
		nextPutAll: ' - Subdirectories:'.
	printBlock := [:each |
		aStream
			nextPut: Character space;
			nextPutAll: each theName].
	self subdirectories do: printBlock.
	aStream nextPutAll: ' - Files:'.
	self files do: printBlock.
	aStream nextPut: $).! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	(FileDirectory on: self path) exists
		ifFalse: [self error: 'There exists no directory with this name.'].
	super read.
	self readDirectoryEntries.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 3/5/2008 15:27'!
readDirectoriesInDir: dir

	| newSvnDirectory |
	dir directoryNames
		select: [:each | each ~= '.svn']
		thenDo: [:each |
			"each = 'SVNTestClassCreatedInAcceptanceTest' ifTrue: [self halt]."
			newSvnDirectory := SVNDirectory
				named: each
				basePath: self path.
				"self halt."
			newSvnDirectory read.
			self addSubdirectory: newSvnDirectory].! !

!SVNDirectory methodsFor: 'reading' stamp: 'test 3/1/2008 02:49'!
readDirectoryEntries

	| dir |
	dir := FileDirectory on: self path.
	self
		readFilesInDir: dir;
		readDirectoriesInDir: dir.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 4/2/2008 18:15'!
readFilesInDir: directory

	self flag: #TODO. "Use addSvnFile:???"
	directory fileNames
		collect: [:each | SVNFile named: each basePath: self path]
		thenDo: [:newFile |
			newFile read.
			self addFile: newFile].! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'rkrk 4/2/2008 15:13'!
recursivelyDo: aBlock

	| entries |
	self flag: #TODO. "Testen".
	entries := self files copy.
	entries addAll: self subdirectories.
	entries do: [:ea | ea recursivelyDo: aBlock].
	aBlock value: self.! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'cop 4/14/2008 21:02'!
recursivelyDoForFiles: aBlock
	self subdirectories do: [:ea | ea recursivelyDoForFiles: aBlock].
	self files do: [:ea| aBlock value: ea.]! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/2/2008 15:11'!
recursivelyGatherPathsOfAllElements

	| subElementsPaths |
	subElementsPaths := self subdirectories gather: [:each | each recursivelyGatherPathsOfAllElements].
	^ self pathsOfAllElements
		addAll: subElementsPaths;
		yourself.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rt 3/14/2008 15:12'!
remove

	((FileDirectory new) directoryExists: self path) ifFalse: [^ self].
	
	super remove.! !

!SVNDirectory methodsFor: 'storing' stamp: 'cop 4/14/2008 13:46'!
store

	| entriesToStore |
	self basePath ifEmpty: [ Transcript show: 'No base path set for ', self asString;
							cr.
							^self ].
	(FileDirectory on: self path) assureExistence.
	super store.
	entriesToStore := self files copy.
	entriesToStore addAll: self subdirectories.
	entriesToStore do: [:each | each store].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories
	^ subdirectories! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories: anObject
	subdirectories := anObject! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'cop 4/14/2008 22:25'!
update
	self updateTargets: (self recursivelyGatherPathsOfAllElements add: {self path}) asArray.
	self recursivelyDoForFiles: [:ea| ea readContent ]! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 3/12/2008 14:44'!
asciiValueSeparator

	^ $%! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 3/12/2008 14:55'!
illegalCharacters

	^ #($/ $\ $? $* $: $| $" $< $>)! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:02'!
named: aString

	^ self
		named: aString
		basePath: String new.! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 4/2/2008 17:57'!
named: aString basePath: pathName

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ self new
		encodeName: aString;
		basePath: pathName;
		yourself.! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'mu 3/31/2008 15:20'!
on: pathString
	
	FileDirectory
		splitName: pathString
		to: [:dirPath :localName |
			^ self named: localName basePath: dirPath].! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/9/2008 19:19'!
<= other

	^ self theName <= other theName! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 18:05'!
= other

	self species = other species ifFalse: [^ false].
	^ self theName = other theName and:
		[self basePath = other basePath] and:
			[self properties = other properties].! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rkrk 2/27/2008 02:25'!
addEntry

	| client |
	client := SVNCApiClient new.
	client svnAdd: self path! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:54'!
asciiValueSeparator

	^ self class asciiValueSeparator.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath
	^ basePath! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath: anObject 
	basePath := anObject! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:26'!
checkoutFrom: url

	self svnClientDo: [:svnClient | 
		svnClient
			svnCheckoutHeadRevisionFrom: url asString
			to: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 3/13/2008 18:03'!
commit

	self commitWithMessage: String new.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'mu 3/27/2008 17:34'!
commitLogs
	| client |
	client := SVNCApiClient new.
	self commitLogs: (client svnGetCommitLogFrom: self path).
	"commitLogs ifNil: [^OrderedCollection new]."
	^ commitLogs! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'mu 3/18/2008 17:40'!
commitLogs: anObject
	commitLogs := anObject! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:27'!
commitWithMessage: aString

	self svnClientDo: [:svnClient | 
		svnClient
			svnCommit: {self path}
			withMessage: aString.].! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'rt 3/17/2008 13:34'!
delete! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 4/6/2008 02:39'!
encodeName: aString 

	"Parse the string and construct a filename from it."
	| parts char |
	self flag: #TODO.
	"self assert: aString isEmpty not."
	aString ifEmpty: [^ aString].
	(aString first = self asciiValueSeparator and: [aString size = 1]) ifTrue: [^ aString].
	
	aString isAllDigits ifTrue: [self theName: aString. ^ self].
	
	parts := aString subStrings: self asciiValueSeparator asString.
	self theName: (parts
		inject: String new
		into: [:result :each | each isAllDigits
			ifFalse: [result , each]
			ifTrue: [char := Character value: each asNumber.
				result , char asString]]).! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:55'!
fileNameRepresantationForIllegalCharacter: character

	| sep |
	sep := self asciiValueSeparator asString.
	^  sep , character asciiValue asString , sep.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 3/5/2008 19:56'!
filename

	"print it: [self new theName: 'ab:ab'; filename]"
	^ self class illegalCharacters 
		inject: self theName copy
		into: [:convertedName :illegalCharacter |
			convertedName
				copyReplaceAll: illegalCharacter asString
				with: (self fileNameRepresantationForIllegalCharacter: illegalCharacter)].! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:58'!
hash

	^ ((self theName hash bitXor: self basePath hash) bitXor: self properties hash) bitXor: self species hash! !

!SVNDirectoryEntry methodsFor: 'initialization' stamp: 'rt 3/14/2008 15:19'!
initialize

	super initialize.
	self properties: Dictionary new.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 3/5/2008 18:03'!
path
	^ self basePath , FileDirectory slash , self filename.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'cop 4/14/2008 14:13'!
pathsOfAllElements
	^self path! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties
	^ properties! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties: anObject
	properties := anObject! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'mu 3/20/2008 14:10'!
read
	
	self	readProperties.
	self readCommitLogs.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'mu 3/20/2008 14:19'!
readCommitLogs
	| client |
	client := SVNCApiClient new.
	self commitLogs: (client svnGetCommitLogFrom: self path).! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 3/1/2008 03:04'!
readProperties

	| client |
	client := SVNCApiClient new.
	self properties: (client svnGetPropertiesFrom: self path).! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'rt 3/14/2008 15:09'!
remove

	self svnRemoveEntry! !

!SVNDirectoryEntry methodsFor: 'svn state' stamp: 'rkrk 4/7/2008 15:42'!
status
	
	^ (SVNStatusRequest target: self)
		execute;
		yourself! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'pe 4/14/2008 14:36'!
store
	self assert: (FileDirectory on: self basePath) exists.
	self
		addEntry;
		storeProperties.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'test 3/1/2008 04:14'!
storeProperties

	| client |
	client := SVNCApiClient new.
	self properties keysAndValuesDo: [:key :value |
		client svnAddProperty: key WithValue: value To: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:28'!
svnAdd

	self svnClientDo: [:svnClient |
		svnClient svnAdd: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:28'!
svnBlame

	self svnClientDo: [:svnClient |
		^ svnClient svnGetBlameLinesFrom: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:26'!
svnClientDo: aBlock

	aBlock value: SVNCApiClient new.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 03:22'!
svnInfo

	^ (SVNInfoRequest target: self)
		execute;
		yourself.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rt 3/13/2008 17:30'!
svnRemoveEntry

	| client |
	client := SVNCApiClient new.
	client svnDeleteTargetsFromWorkingCopy: {self path}.
	self flag: #TODO. "svn status ??? If entry isn't under version control call: entry delete ?'"! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName

	^ theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 18:54'!
theName: aString 

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	theName := aString asString.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'cop 4/14/2008 14:38'!
update
	self subclassResponsibility! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'cop 4/14/2008 14:37'!
updateTargets: anArray
	self svnClientDo: [:svnClient |
		svnClient svnUpdateTargetsToHeadRevision: anArray].! !

SVNDirectoryEntry subclass: #SVNFile
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNFile class methodsFor: 'instance creation' stamp: 'test 3/5/2008 15:29'!
named: aString basePath: pathName content: content

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ (self named: aString basePath: pathName)
		content: content;
		yourself.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self content = other content])! !

!SVNFile methodsFor: 'svn functions' stamp: 'cop 4/3/2008 13:19'!
blame
	^self svnBlame.! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content
	^ content! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content: anObject
	content := anObject! !

!SVNFile methodsFor: 'removing' stamp: 'rkrk 3/4/2008 05:13'!
delete

	(FileDirectory on: self basePath) deleteFileNamed: self theName.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:50'!
hash

	self flag: #TODO.
	"^ (super hash bitXor: self content hash) bitXor: self properties hash."
	
	^ super hash bitXor: self content hash! !

!SVNFile methodsFor: 'initialize-release' stamp: 'rkrk 3/13/2008 11:46'!
initialize

	super initialize.
	content := String new.! !

!SVNFile methodsFor: 'printing' stamp: 'rkrk 4/2/2008 11:27'!
printOn: aStream

	super printOn: aStream.	
	aStream
		nextPut: $(;
		nextPutAll: self path;
		nextPut: $).! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 4/3/2008 03:52'!
read
	
	(FileStream isAFileNamed: self path)
		ifFalse: [self error: 'There exists no file with this name!!'].
	self assert: ('*.mine*' match: self theName) not.
	self assert: ('.r#' match: self theName) not.
	super read.
	self	readContent.! !

!SVNFile methodsFor: 'reading' stamp: 'cop 4/14/2008 20:51'!
readContent
	FileStream 
		readOnlyFileNamed: self path
		do: [:stream | content := stream contents.]! !

!SVNFile methodsFor: 'as yet unclassified' stamp: 'rkrk 3/4/2008 05:20'!
recursivelyDo: aBlock

	self flag: #TODO. "Testen".
	aBlock value: self.! !

!SVNFile methodsFor: 'removing' stamp: 'rt 3/14/2008 16:20'!
remove

	| dir |
	dir := (FileDirectory on: self basePath).
	dir exists ifFalse: [^ self].
	(dir fileExists: self filename) ifFalse: [^ self].

	super remove! !

!SVNFile methodsFor: 'storing' stamp: 'rt 3/14/2008 15:15'!
store
	"self assert: (self theName includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	FileStream 
		forceNewFileNamed: self path
		do: [:stream | stream nextPutAll: content].
	super store.! !

!SVNFile methodsFor: 'svn functions' stamp: 'cop 4/3/2008 13:19'!
svnBlame

	| svnClient |
	svnClient := SVNCApiClient new.
	"svn blame the element"
	^svnClient svnGetBlameLinesFrom: self path.! !

!SVNFile methodsFor: 'svn functions' stamp: 'cop 4/14/2008 14:41'!
update
	self updateTargets: {self path}.
	self readContent.! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy commentStamp: '<historical>' prior: 0!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'dummy' stamp: 'rkrk 4/14/2008 22:35'!
onInstanceAndClassSide! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 3/14/2008 02:25'!
< other

	^ super < other! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/23/2008 11:54'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 4/14/2008 22:22'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 4/14/2008 22:35'!
onInstanceAndClassSide

	"Methods with this name are on instance and on class side of SVNDummy."! !

Object subclass: #SVNElement
	instanceVariableNames: 'theName parent svnDirectoryEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'theClass superclassName classVariables instanceVariables classInstanceVariables comment category subclasses versionedMethods poolDictionaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 18:28'!
forExistingClass: aClass

	^ self new
		forExistingClass: aClass;
		yourself! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 00:35'!
name: className superclassName: superClassName instanceVariables: instVars classVariables: classVars classInstanceVariables: classInstVars poolDictionaries: poolDicts comment: comment category: classCategory

	^ self new
		theName: className asString;
		superclassName: superClassName;
		instanceVariables: instVars;
		classVariables: classVars;
		classInstanceVariables: classInstVars;
		poolDictionaries: poolDicts;
		comment:  comment;
		category: classCategory;
		establishSvnFilesAndDirectories;
		yourself.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 4/15/2008 04:24'!
= other

	^ super = other "ifFalse: [^ false].
	(self superclassName = other superclassName and:
		[self instanceVariables = other instanceVariables] and:
		[self classVariables = other classVariables] and:
		[self classInstanceVariables = other classInstanceVariables] and:
		[self comment = other comment]) ifFalse: [^ false].
	^  self category = other category and:
		[self poolDictionaries = other poolDictionaries] and:
		[self versionedMethods = other versionedMethods]"! !

!SVNClass methodsFor: 'adding' stamp: 'rkrk 4/15/2008 00:31'!
addMethod: svnMethod

	| methodDirectory |
	methodDirectory := self directory
		getSubDirectoryNamed: (svnMethod isPartOfMetaclass
			ifTrue: ['class']
			ifFalse: ['instance']).
	
	methodDirectory addFile: svnMethod file.
	self versionedMethods add: svnMethod.
	self changed.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category
	^ category! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category: anObject
	category := anObject! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 4/1/2008 14:34'!
classDetailsDictionary

	^ Dictionary new
		at: self nameForSuperclassProperty 				put: self superclassName asString;
		at: self nameForCategoryProperty 				put: self category asString;
		at: self nameForPoolDictionariesProperty 		put: self poolDictionariesString;
		at: self nameForInstanceVariablesProperty 		put: self instanceVariablesString;
		at: self nameForClassVariablesProperty 			put: self classVariablesString;
		at: self nameForClassInstanceVariablesProperty 	put: self classInstanceVariablesString;
		at: self nameForCommentFile 					put: self comment;
		yourself.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables
	^ classInstanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables: anObject
	classInstanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classInstanceVariablesString

	^ self stringFromCollection: self classInstanceVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables
	^ classVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables: anObject
	classVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classVariablesString

	^ self stringFromCollection: self classVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment
	^ comment! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment: anObject
	comment := anObject! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 3/31/2008 17:54'!
commit

	self commitWithMessage: 'empty commit message'! !

!SVNClass methodsFor: 'derived accessing' stamp: 'mu 3/31/2008 13:32'!
directory

	^ self svnDirectoryEntry! !

!SVNClass methodsFor: 'derived accessing' stamp: 'mu 3/31/2008 13:32'!
directory: aSVNDirectory

	self svnDirectoryEntry: aSVNDirectory! !

!SVNClass methodsFor: 'initialize-release' stamp: 'pe 4/14/2008 15:08'!
establishSvnFilesAndDirectories
	
	self directory ifNil: [self directory: (SVNDirectory named: self theName)].	
	self directory
		createSubDirectoryNamed: 'instance';
		createSubDirectoryNamed: 'class'.
	
	self flag: #TODO. "Is this necessary... can this be expressed better? .. see #store"
	self classDetailsDictionary keysAndValuesDo: [:fileName :content |
		self directory
			createFileNamed: fileName
			withContent: content].! !

!SVNClass methodsFor: 'notification' stamp: 'rkrk 4/15/2008 02:23'!
event: anEvent

	| class eventItemClass result callCtx |
	"self halt."
	callCtx := thisContext findContextSuchThat: [:ctx |
		ctx sender isKindOf: SVNTestCase].
	Transcript
		show: 'Deprecated #event: method called.'; cr.
	callCtx ifNotNil: [
		Transcript
		show: 'Caller: - ';
		show: callCtx sender asString;
		cr]. 
	self flag: #TODO.
	self theName ifNil: [^self].
	eventItemClass := anEvent itemClass.
	class := Smalltalk classNamed: self theName.

	(eventItemClass = class or: [eventItemClass = class class]) ifFalse: [^self].

	result := self handleEvent: anEvent.
	result = anEvent ifTrue: [self forExistingClass: class.]
! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/14/2008 18:58'!
extractCategoryFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForCategoryProperty) content asSymbol! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractClassVarsFrom: aSVNDirectory
	
	^ ((aSVNDirectory getFileNamed: self nameForClassVariablesProperty) content substrings collect: [:each | each asSymbol]) asSet! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:00'!
extractInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractMetaInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForClassInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:37'!
extractPoolDictionariesFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForPoolDictionariesProperty) content substrings asOrderedCollection! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:36'!
extractSuperclassFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForSuperclassProperty) content! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 4/15/2008 01:00'!
forExistingClass: aClass

	self
		theName: aClass name asString;
		superclassName: aClass superclass name asString;
		instanceVariables: aClass instVarNames;
		classVariables: aClass classVarNames;
		classInstanceVariables: aClass class instVarNames;
		poolDictionaries: aClass poolDictionaryNames;
		comment: aClass comment;
		category: aClass category.

	self establishSvnFilesAndDirectories.

	"Can't use #union or #addAll here because dicts would be merged in a strange way??"
	aClass class methodDict do: [:each |
		self addMethod: (SVNMethod forExistingMethod: each)].	
	aClass methodDict do: [:each |
		self addMethod: (SVNMethod forExistingMethod: each)].! !

!SVNClass methodsFor: 'notification' stamp: 'rkrk 4/15/2008 02:23'!
handleEvent: anEvent

	| eventItemClass removedItem |
	"self halt."
	self flag: #TODO.
	anEvent isRemoved ifFalse: [^ anEvent].
	
	anEvent itemKind = #method ifFalse: [^ anEvent].
	eventItemClass := anEvent itemClass asString.

	(removedItem := (self versionedMethods detect: [:each |
		(each methodSelector asSymbol = anEvent itemSelector)
			and: [each nameOfClass = eventItemClass]]
				ifNone: [nil])).
	removedItem ifNotNil: [self versionedMethods remove: (removedItem remove)]! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 13:29'!
hash

	^ self theName hash! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 4/15/2008 01:01'!
initialize

	super initialize.
	self
		versionedMethods: {};
		subclasses: {};
		"createOwnDirectory;"
		notifyAboutSystemModifications: false. self flag: #TODO "Not good"! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables
	^ instanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables: anObject
	instanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 23:59'!
instanceVariablesString

	^ self stringFromCollection: self instanceVariables.! !

!SVNClass methodsFor: 'testing' stamp: 'rkrk 4/15/2008 03:54'!
isIncludedInEnvironment: svnEnvironment

	self halt.
	^ (svnEnvironment findSvnClassFor: self) notNil! !

!SVNClass methodsFor: 'testing' stamp: 'rkrk 4/15/2008 04:25'!
isIncludedInProject: svnProject


	^ svnProject versionedClasses includes: self! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 4/15/2008 02:53'!
load
	
	"self notifyAboutSystemModifications: false."
	
	self poolDictionaries do: [:each | Smalltalk at: each asSymbol ifAbsentPut: Dictionary new].
	
	(Smalltalk classNamed: self theName asSymbol)
		ifNotNil: [self reloadClass]
		ifNil: [self loadAsNewClass].
			
	self versionedMethods do: [:each | each load].
	self removeUnversionedMethods.
	self subclasses do: [:each | each load].
	
	"self notifyAboutSystemModifications: true."! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 3/31/2008 23:37'!
loadAsNewClass

	| superclass |
	self assert: self theClass isNil.	
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	superclass
		subclass: self theName asSymbol
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self poolDictionariesString
		category: self category.
	self theClass classSide instanceVariableNames: self classInstanceVariablesString.
	self theClass comment: self comment.
! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 4/1/2008 18:12'!
nameForCategoryProperty

	^ 'category'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:16'!
nameForClassInstanceVariablesProperty
	^ 'classInstanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForClassVariablesProperty
	^ 'classVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 12:03'!
nameForCommentFile

	^ 'comment'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForInstanceVariablesProperty
	^ 'instanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 3/9/2008 16:45'!
nameForPoolDictionariesProperty
	^'poolDictionaries'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:05'!
nameForSuperclassProperty
	^'superclass'! !

!SVNClass methodsFor: 'notification' stamp: 'rkrk 4/15/2008 02:51'!
notifyAboutSystemModifications: aBoolean

	| notifier |
	self flag: #TODO. "What about #category, #protocol?"
	aBoolean ifTrue: [self halt].
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				using: #event:.
			notifier
				notify: self
				ofSystemChangesOfItem: #method
				using: #event:].! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries

	^poolDictionaries! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries: anObject

	poolDictionaries := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rt 3/9/2008 16:46'!
poolDictionariesString

	^ self stringFromCollection: self poolDictionaries.! !

!SVNClass methodsFor: 'printing' stamp: 'rkrk 2/23/2008 23:52'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rt 3/26/2008 23:42'!
reloadClass

	| class newVars |		
	class := Smalltalk classNamed: self theName asSymbol.
	self assert: class notNil.
	
	"superclass"
	class superclass: (Smalltalk classNamed: self superclassName).
	
	"instVars"
	newVars := self instanceVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class instVarNames.
	newVars do: [:newInstVar |
		class addInstVarName: newInstVar].
	
	"classVars"
	newVars := self classVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class classVarNames.
	newVars do: [:newClassVar |
		class addClassVarName: newClassVar].
	
	"pools"
	newVars := self poolDictionaries asOrderedCollection copy.
	newVars removeAllFoundIn: class poolDictionaryNames.
	newVars do: [:newPoolDictionary |
		class addSharedPool: (Smalltalk at: newPoolDictionary asSymbol)].
	
	"classInstVars"
	newVars := self classInstanceVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class class instVarNames.
	newVars do: [:newClassInstVar |
		class class addInstVarName: newClassInstVar].

	"category"
	class category: self category.
	
	"comment"
	class comment: self comment.! !

!SVNClass methodsFor: 'removing' stamp: 'rkrk 4/1/2008 02:55'!
removeSVNMethod: svnMethod

	svnMethod remove.
	self versionedMethods remove: svnMethod.! !

!SVNClass methodsFor: 'removing' stamp: 'rt 3/25/2008 19:34'!
removeUnversionedMethods

	| class methodsToRemove metaClass |
	self flag: #TODO. "just for testLoadingAExistingClassWithoutAMethodShouldRemoveTheMethod"
	self flag: #TODO. "if we need this put it to reloadClass"
	
	class := (Smalltalk classNamed: self theName asSymbol).
	methodsToRemove := class methodDict keys.
	methodsToRemove removeAll: ((self versionedMethods
		select: [:instanceMethod | instanceMethod isPartOfMetaclass not])
			collect: [:versionedMethod | versionedMethod methodSelector asSymbol]).
	methodsToRemove do: [:removeMeMethod | class removeSelectorSilently: removeMeMethod asSymbol].
	
	metaClass := class class.
	methodsToRemove := metaClass methodDict keys.
	methodsToRemove removeAll: ((self versionedMethods
		select: [:classMethod | classMethod isPartOfMetaclass])
			collect: [:versionedMethod | versionedMethod methodSelector asSymbol]).
	methodsToRemove do: [:removeMeMethod | metaClass removeSelectorSilently: removeMeMethod asSymbol].! !

!SVNClass methodsFor: 'restoring' stamp: 'rt 3/12/2008 12:31'!
restoreClassDetailsFrom: aSVNDirectory 

	self
		superclassName: (self extractSuperclassFrom: aSVNDirectory) ;
		instanceVariables: (self extractInstVarsFrom: aSVNDirectory) ;
		classVariables: (self extractClassVarsFrom: aSVNDirectory) ;
		classInstanceVariables: (self extractMetaInstVarsFrom: aSVNDirectory);
		poolDictionaries: (self extractPoolDictionariesFrom: aSVNDirectory);
		category: (self extractCategoryFrom: aSVNDirectory)! !

!SVNClass methodsFor: 'restoring' stamp: 'rt 3/14/2008 18:59'!
restoreFrom: aSVNDirectory 

	self
		theName: aSVNDirectory theName;
		directory: aSVNDirectory;
		restoreClassDetailsFrom: aSVNDirectory;
		comment: (aSVNDirectory getFileNamed: self nameForCommentFile) content.

	self versionedMethods: {} asSet.
	aSVNDirectory subdirectories do: [:each | self restoreMethodsFrom: each].! !

!SVNClass methodsFor: 'restoring' stamp: 'cop 4/14/2008 22:01'!
restoreMethodsFrom: aSVNDirectory 

	| restoredMethods |
	restoredMethods := aSVNDirectory files collect: [:each |
		SVNMethod restoreFrom: each].
	self versionedMethods: (self versionedMethods union: restoredMethods).! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 4/1/2008 18:48'!
store

	self versionedMethods do: [:each | each store].
	self classDetailsDictionary keysAndValuesDo: [:fileName :content |
		self directory
			createFileNamed: fileName
			withContent: content].! !

!SVNClass methodsFor: 'convenience' stamp: 'rkrk 2/23/2008 23:59'!
stringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:16'!
subclasses

	^subclasses! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:14'!
subclasses: anObject

	subclasses := anObject asSet! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName
	^ superclassName! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName: anObject
	superclassName := anObject! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 3/31/2008 23:36'!
theClass

	^ Smalltalk classNamed: self theName! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 01:13'!
versionedMethods
	
	^ versionedMethods! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/8/2008 22:08'!
versionedMethods: anObject

	versionedMethods := anObject asSet! !

!SVNElement class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:49'!
restoreFrom: aSVNDirectoryEntry
	
	^ self new
		restoreFrom: aSVNDirectoryEntry;
		yourself.! !

!SVNElement methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:40'!
= other

	self species = other species ifFalse: [^ false].
	^ self theName = other theName
! !

!SVNElement methodsFor: 'svn commands' stamp: 'rkrk 4/15/2008 05:30'!
commitWithMessage: aString

	self store.
	self svnDirectoryEntry commitWithMessage:aString.
	
	self flag: #TODO.! !

!SVNElement methodsFor: 'convenience' stamp: 'mu 2/7/2008 13:54'!
contentsOfFileNamed: pathToFile

	^ (FileStream readOnlyFileNamed: pathToFile) contents.! !

!SVNElement methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:00'!
establishSvnFilesAndDirectories

	self subclassResponsibility.! !

!SVNElement methodsFor: 'comparing' stamp: 'rkrk 3/31/2008 23:35'!
hash

	^ self theName hash! !

!SVNElement methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:44'!
initialize

	super initialize.
	self theName: String new.! !

!SVNElement methodsFor: 'testing' stamp: 'rkrk 4/14/2008 04:04'!
isIncludedInEnvironment: svnEnvironment

	^ false! !

!SVNElement methodsFor: 'testing' stamp: 'rkrk 4/14/2008 11:57'!
isIncludedInProject: svnProject


	^ false! !

!SVNElement methodsFor: 'removing' stamp: 'rkrk 3/31/2008 23:35'!
remove

	(self svnDirectoryEntry) ifNil: [^self].
	self svnDirectoryEntry remove! !

!SVNElement methodsFor: 'svn state' stamp: 'rkrk 4/7/2008 15:41'!
status

	^ svnDirectoryEntry status! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry

	^ svnDirectoryEntry! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry: aSVNDirectoryEntry

	svnDirectoryEntry := aSVNDirectoryEntry! !

!SVNElement methodsFor: 'svn commands' stamp: 'pe 4/14/2008 11:41'!
svnInfo

	^ (SVNInfoRequest target: self svnDirectoryEntry) execute.! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 00:36'!
theName

	self assert: theName isString.
	^ theName asString! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 20:43'!
theName: anObject
	theName := anObject asString! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 4/14/2008 20:15'!
update
	self svnDirectoryEntry update.
	self load.! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'nameOfClass category source timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:50'!
forExistingMethod: aCompiledMethod 
	
	^ self new
		forExistingMethod: aCompiledMethod;
		establishSvnFilesAndDirectories;
		yourself! !

!SVNMethod methodsFor: 'comparing' stamp: 'pe 4/14/2008 14:14'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodSelector = otherMethod methodSelector and: 
		[self nameOfClass = otherMethod nameOfClass]! !

!SVNMethod methodsFor: 'svn commands' stamp: 'cop 3/18/2008 17:46'!
blame
	^ self svnDirectoryEntry blame.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category
	^ category! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category: anObject
	category := anObject! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:54'!
establishSvnFilesAndDirectories

	"create"
	self file: (SVNFile
		named: self theName
		basePath: '').
	"synch. Put synch in own method? Two way?"
	self file content: self source.
	self file properties
		at: self nameForClassProperty put: self nameOfClass;
		at: self nameForCategoryProperty put: self category;
		at: self nameForTimeStampProperty put: self timeStamp.! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:00'!
extractCategoryFrom: svnFile

	^ svnFile properties at: self nameForCategoryProperty! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
extractClassFrom: svnFile

	^ svnFile properties at: self nameForClassProperty! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 01:58'!
extractSourceCodeFrom: svnFile

	^ svnFile content! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
extractTimeStampFrom: svnFile

	^ svnFile properties at: self nameForTimeStampProperty! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rt 3/14/2008 14:18'!
file

	^ self svnDirectoryEntry! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rt 3/14/2008 14:18'!
file: aSVNFile

	self svnDirectoryEntry: aSVNFile! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:51'!
forExistingMethod: aCompiledMethod

	self methodDetailsFrom: aCompiledMethod.! !

!SVNMethod methodsFor: 'comparing' stamp: 'pe 4/14/2008 14:15'!
hash

	^ self methodSelector hash bitXor: self nameOfClass hash.! !

!SVNMethod methodsFor: 'testing' stamp: 'rkrk 4/15/2008 04:51'!
isIncludedInProject: svnProject


	^ svnProject allVersionedMethods includes: self! !

!SVNMethod methodsFor: 'testing' stamp: 'rkrk 4/1/2008 04:14'!
isPartOfMetaclass

	self flag: #TODO.
	^ (Smalltalk hasClassNamed: self nameOfClass)
		ifTrue: [(Smalltalk classNamed: self nameOfClass) isMeta]
		ifFalse: [self nameOfClass endsWith: ' class'].! !

!SVNMethod methodsFor: 'modifying the system' stamp: 'cop 4/14/2008 22:00'!
load
	| class relatedSystemEntry |
	"(Re)Load the properties"
	self restore.
	
	"find the correct class"
	relatedSystemEntry := Smalltalk at: self nameOfClass substrings first asSymbol.
	
	class := self isPartOfMetaclass
		ifTrue: [relatedSystemEntry class]
		ifFalse: [relatedSystemEntry].

	class
		compile: self source
		classified: self category
		withStamp: self timeStamp
		notifying: nil.! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 02:13'!
methodDetailsFrom: aCompiledMethod

	| methodReference |
	methodReference := aCompiledMethod methodReference.
	self
		methodSelector: methodReference methodSymbol;
		nameOfClass: methodReference actualClass name;
		category: methodReference category;
		source: methodReference source;
		timeStamp: methodReference timeStamp.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector

	^ self theName! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector: aString

	self theName: aString! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:00'!
nameForCategoryProperty
	^ 'category'! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
nameForClassProperty
	^ 'class'! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
nameForTimeStampProperty
	^ 'timestamp'! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass
	^ nameOfClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass: anObject
	nameOfClass := anObject! !

!SVNMethod methodsFor: 'printing' stamp: 'rkrk 2/24/2008 02:29'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self nameOfClass;
		nextPutAll: '>>';
		nextPutAll: self methodSelector;
		nextPut: $).! !

!SVNMethod methodsFor: 'restoring' stamp: 'cop 4/14/2008 21:00'!
restore
	self
		methodSelector: self file theName asString;
		category: (self extractCategoryFrom: self file);
		source: (self extractSourceCodeFrom: self file);
		nameOfClass: (self extractClassFrom: self file);
		timeStamp: (self extractTimeStampFrom: self file).! !

!SVNMethod methodsFor: 'restoring' stamp: 'cop 4/14/2008 20:59'!
restoreFrom: aSVNFile 
	self file: aSVNFile.
	self restore.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source
	^ source! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source: anObject
	source := anObject! !

!SVNMethod methodsFor: 'storing' stamp: 'rkrk 4/1/2008 02:26'!
store
	
	self file content: self source.
	self file properties
		at: self nameForClassProperty put: self nameOfClass;
		at: self nameForCategoryProperty put: self category;
		at: self nameForTimeStampProperty put: self timeStamp.! !

!SVNMethod methodsFor: 'functionality' stamp: 'rkrk 4/1/2008 01:21'!
styledBlameText

	self flag: #TODO. "Doeas this belong here?"
	^ SVNBlameStyler createTextFromBlameLines: self blame.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp
	^ timeStamp! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp: anObject
	timeStamp := anObject! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods workingCopyDirectory repositoryURL repository projectDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject class methodsFor: 'instance creation' stamp: 'rt 4/13/2008 19:33'!
checkoutProject: aName fromRepository: svnRepository toWorkingCopy: aSVNDirectory 

	| projectDir |
	projectDir := aSVNDirectory createSubDirectoryNamed: aName.
	svnRepository createProject: aName.
	self assert: (svnRepository projectExists: aName).
	
	^ self new
		svnRepository: svnRepository;
		directory: projectDir;
		theName: aName;
		checkout;
		yourself.! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rt 4/13/2008 18:56'!
checkoutProject: aName fromURL: url inWorkingCopy: aSVNDirectory 
	
	| repository |
	repository := SVNRepository on: url.
	repository ifNil: [^ self error: 'Repository does not exists.'].
	^ self checkoutProject: aName fromRepository: repository toWorkingCopy: aSVNDirectory! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:44'!
named: aString 
	
	^ self new
		theName: aString;
		establishSvnFilesAndDirectories;
		yourself.! !

!SVNProject methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:50'!
= other

	super = other ifFalse: [^ false].
	^ self versionedClasses = other versionedClasses and:
		[self versionedMethods = other versionedMethods].! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/1/2008 16:53'!
addCategory: categoryString

	(Smalltalk organization listAtCategoryNamed: categoryString)
		collect: [:classSymbol | Smalltalk at: classSymbol] 
		thenDo: [:class | self addSVNClass: (SVNClass forExistingClass: class)].! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/7/2008 04:05'!
addClass: aClass

	self addSVNClass: (SVNClass forExistingClass: aClass)! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/15/2008 06:33'!
addMethod: aMethod 
	
	| svnMethod |
	self flag: #TODO.
	"SVNClass uses svnMethod..."
	self projectDirectory ifNil: [self error: 'No working copy path specified.'].
	svnMethod := SVNMethod forExistingMethod: aMethod.
	self projectDirectory addFile: svnMethod file.
	^ self versionedMethods add: svnMethod! !

!SVNProject methodsFor: 'adding' stamp: 'pe 4/14/2008 15:10'!
addSVNClass: svnClass

	self projectDirectory ifNil: [self error: 'No working copy path specified.'].
	
	self versionedClasses copy
		select: [:ea | ea theName asString = svnClass theName asString]
		thenDo: [:alreadyExistingClass | self versionedClasses remove: alreadyExistingClass].
	self projectDirectory addSubdirectory: svnClass directory.
	self versionedClasses add: svnClass.
	self store.
	self changed.! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/7/2008 04:07'!
allElements

	| result |
	result := {self. self versionedMethods} asOrderedCollection.
	result addAll: self versionedClasses.
	^ result.! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/15/2008 00:31'!
allVersionedMethods
	"This temporary collection is needed !!!!!!"
	| aCol |
	aCol := self versionedMethods copy.
	^ self versionedClasses
		inject: aCol
		into: [:allMethods :class | allMethods addAll: class versionedMethods; yourself].! !

!SVNProject methodsFor: 'svn functions' stamp: 'rt 4/13/2008 19:35'!
checkout

	self projectDirectory checkoutFrom: self repositoryURL , FileDirectory slash , self theName.
	self projectDirectory read.
	self restoreFrom: self projectDirectory.! !

!SVNProject methodsFor: 'svn functions' stamp: 'pe 4/14/2008 14:24'!
commit
	self commitWithMessage: 'empty commit message'.! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/17/2008 10:44'!
deleteClass: aClass

	(Smalltalk classNamed: aClass name asString) removeFromSystem.
	"event:"
	^aClass! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/17/2008 12:20'!
deleteMethod: aMethod

	(Smalltalk classNamed: aMethod sourceClass name) removeSelector: aMethod sourceSelector.
	"event:"
	^aMethod! !

!SVNProject methodsFor: 'derived accessing' stamp: 'cop 4/14/2008 11:18'!
directory

	self svnDirectoryEntry ifNil: [self svnDirectoryEntry: (SVNDirectory on: '')].
	^ self svnDirectoryEntry! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/1/2008 16:41'!
directory: svnDirectory

	self svnDirectoryEntry: svnDirectory! !

!SVNProject methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:01'!
establishSvnFilesAndDirectories

	self directory: (SVNDirectory named: self theName).! !

!SVNProject methodsFor: 'notifying' stamp: 'rkrk 4/15/2008 01:02'!
event: anEvent

	| method |
	self halt.
	(anEvent isRemoved and:
	[anEvent itemKind = #class])
		ifTrue: [(self versionedClasses includes: (SVNClass forExistingClass: anEvent itemClass))
				ifTrue: [self removeClass: anEvent itemClass]].

	(anEvent isRemoved and:
	[anEvent itemKind = #method])
		ifTrue: [method := self versionedMethods
							detect: [:each |
								(each methodSelector = anEvent itemSelector) and:
								[each nameOfClass = anEvent itemClass name]]
							ifNone: [nil].
				method ifNotNil: [self removeSVNMethod: method]]! !

!SVNProject methodsFor: 'testing' stamp: 'rkrk 4/14/2008 11:57'!
includes: svnElement

	^ svnElement isIncludedInProject: self.! !

!SVNProject methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 01:01'!
initialize

	super initialize.
	self
		versionedClasses: Set new;
		versionedMethods: Set new;
		repositoryURL: nil;
		notifyAboutSystemModifications: false.! !

!SVNProject methodsFor: 'modifying the system' stamp: 'cop 4/14/2008 21:10'!
load
	SVNLoader
		loadSVNClasses: self versionedClasses copy
		andSVNMethods: self versionedMethods copy! !

!SVNProject methodsFor: 'notifying' stamp: 'rt 3/17/2008 10:41'!
notifyAboutSystemModifications: aBoolean

	| notifier |
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				using: #event:.
			notifier
				notify: self
				ofSystemChangesOfItem: #method
				using: #event:].! !

!SVNProject methodsFor: 'printing' stamp: 'rkrk 3/3/2008 20:30'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rt 4/13/2008 18:35'!
projectDirectory

"	^ self workingCopyDirectory createSubDirectoryNamed: self theName."
	^ self directory! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/13/2008 13:27'!
removeClass: aClass

	| svnClass |
	svnClass := SVNClass forExistingClass: aClass.
	self removeSVNClass: svnClass.
	^aClass! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/17/2008 11:15'!
removeMethod: aMethod

	| svnMethod |
	svnMethod := SVNMethod forExistingMethod: aMethod.
	self removeSVNMethod: svnMethod.
	^aMethod! !

!SVNProject methodsFor: 'removing' stamp: 'rkrk 4/14/2008 20:48'!
removeSVNClass: aSVNClass

	self projectDirectory subdirectories removeAllSuchThat: [:dir |
		dir theName = aSVNClass theName].
	aSVNClass remove. " Remove from filesystem"
	self versionedClasses remove: aSVNClass remove.
	^ aSVNClass! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/17/2008 11:22'!
removeSVNMethod: aSVNMethod

	| includedMethod |
	includedMethod := self versionedMethods
							detect: [:each |
								(each methodSelector = aSVNMethod methodSelector and:
								[each nameOfClass = aSVNMethod nameOfClass])]
							ifNone: [^ self].
	self projectDirectory files remove: includedMethod file.
	self versionedMethods remove: (includedMethod remove).
	^includedMethod! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 21:49'!
repositoryURL
	
	self svnRepository ifNil: [^''].
	^ self svnRepository url! !

!SVNProject methodsFor: 'accessing' stamp: 'cop 4/14/2008 11:33'!
repositoryURL: anUrl

	anUrl ifNil: [^ self].
	(SVNRepository repositoryExistsOn: anUrl) ifFalse: [^ self error: 'Repository does not exists.'].
	self svnRepository: (SVNRepository on: anUrl).
	self svnRepository createProject: self theName.! !

!SVNProject methodsFor: 'restoring' stamp: 'rt 4/13/2008 19:37'!
restoreFrom: aSVNDirectory 
	
	self flag: #TODO. "Piece of mapping is here"
	self directory: aSVNDirectory.
	self theName: aSVNDirectory theName.
	aSVNDirectory subdirectories do: [:each |
		self addSVNClass: (SVNClass restoreFrom: each)].
	self flag: #TODO. "Load methods of project"! !

!SVNProject methodsFor: 'serialization' stamp: 'rkrk 4/15/2008 05:03'!
store

	self versionedMethods do: [:each | each store.].
	self versionedClasses do: [:each | each store].

	"Now write files and directories"
	self projectDirectory store.! !

!SVNProject methodsFor: 'serialization' stamp: 'test 4/2/2008 10:46'!
storeIn: svnDirectory 

	self flag: #TODO. "Remove workingCopy directory"
	self versionedMethods do: [:each |
		each storeIn: self projectDirectory].
	self versionedClasses do: [:each |
		each store].
	"TODO: pass projectDirectory to all my elements"
	"self projectDirectory store"! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 17:47'!
svnRepository

	^ repository! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 17:46'!
svnRepository: aSVNRepository

	repository := aSVNRepository! !

!SVNProject methodsFor: 'accessing' stamp: 'cop 4/14/2008 11:14'!
theName: aString
	super theName: aString.
	self directory theName: aString.! !

!SVNProject methodsFor: 'modifying the system' stamp: 'rkrk 2/25/2008 01:48'!
unload
	self flag: #TODO.! !

!SVNProject methodsFor: 'accessing' stamp: 'mu 3/31/2008 13:19'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 4/1/2008 15:57'!
versionedClasses: anObject
	versionedClasses := anObject! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 3/8/2008 17:55'!
versionedMethods
	
	^ versionedMethods! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 4/1/2008 15:58'!
versionedMethods: anObject
	versionedMethods := anObject! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 21:13'!
workingCopyDirectory

	^ self error: 'does not supported any longer'! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 21:13'!
workingCopyDirectory: anObject

	^ self error: 'does not supported any longer'! !

Object subclass: #SVNEnvironment
	instanceVariableNames: 'svnProjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNEnvironment class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 01:57'!
forAllProjects

	^ self forSvnProjects: SVNProject allInstances asOrderedCollection.! !

!SVNEnvironment class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 01:57'!
forSvnProjects: collection

	^ self new
		svnProjects: collection;
		yourself.! !

!SVNEnvironment methodsFor: 'adding' stamp: 'rkrk 4/14/2008 21:38'!
addSvnProject: svnProject

	self svnProjects add: svnProject.! !

!SVNEnvironment methodsFor: 'derived accessing' stamp: 'rkrk 4/15/2008 02:01'!
allSvnClasses

	^ self svnProjects gather: [:ea | ea versionedClasses].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/15/2008 02:02'!
findSvnClassFor: aClass

	^ self allSvnClasses
		detect: [:ea | ea theName = aClass name]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/14/2008 22:53'!
findSvnMethodForMethod: compiledMethod

	^ self findSvnMethodForMethodRef: compiledMethod methodReference.! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/15/2008 00:44'!
findSvnMethodForMethodRef: methodRef

	| allMethods |
	self flag: #TODO.
	allMethods := self svnProjects gather: [:ea | ea allVersionedMethods].
	^ allMethods
		detect: [:ea |
			ea nameOfClass asString = methodRef actualClass asString and:
				[ea theName = methodRef methodSymbol asString] and:
				[ea isPartOfMetaclass = methodRef classIsMeta]]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/15/2008 04:31'!
findSvnProjectFor: svnElement

	"Kludge. Use double dispatch"
	self flag: #TODO.
	^ (svnElement isKindOf: SVNMethod)
		ifTrue: [
			self svnProjects
				detect: [:ea | ea allVersionedMethods includes: svnElement]
				ifNone: [nil]]
		ifFalse: [
			self svnProjects
				detect: [:ea | ea versionedClasses includes: svnElement]
				ifNone: [nil]].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/15/2008 02:03'!
findSvnProjectOrSvnClassForSvnMethod: method

	| result |
	result := self svnProjects
		detect: [:ea | ea versionedMethods includes: method]
		ifNone: [nil].
	result ifNotNil: [^ result].
	^ self allSvnClasses
		detect: [:ea | ea versionedMethods includes: method]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'testing' stamp: 'rkrk 4/14/2008 22:14'!
includes: anObject

	^ anObject includedInSvnEnvironment: self.! !

!SVNEnvironment methodsFor: 'adding' stamp: 'rkrk 4/14/2008 21:40'!
initialize

	super initialize.
	self svnProjects: Set new.! !

!SVNEnvironment methodsFor: 'system change notification' stamp: 'rkrk 4/15/2008 04:05'!
methodChanged: anEvent

	| method |
	method := self findSvnMethodForMethod: anEvent oldItem.
	method ifNil: [^ self].
	method forExistingMethod: anEvent item.
	(self findSvnProjectFor: method)
		ifNotNilDo: [:project | project store].
	"self halt."! !

!SVNEnvironment methodsFor: 'system change notification' stamp: 'rkrk 4/15/2008 02:07'!
methodRemoved: anEvent

	| method container |
	method := self findSvnMethodForMethod: anEvent item.
	method ifNil: [^ self].
	container := self findSvnProjectOrSvnClassForSvnMethod: method.
	container removeSVNMethod: method.
	method remove.! !

!SVNEnvironment methodsFor: 'system change notification' stamp: 'rkrk 4/15/2008 01:45'!
notifyAboutSystemChanges: aBoolean

	| notifier |
	self flag: #TODO. "What about #category, #protocol?"
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
"			notifier
				notify: self
				ofSystemChangesOfItem: #class
				using: #event:."	
			"Subscribe methods"
			#(#Modified #Recategorized #Reorganized #Renamed #Commented) do: [:ea |
				notifier
					notify: self
					ofSystemChangesOfItem: #method
					change: ea
					using: #methodChanged:.].
				notifier
					notify: self
					ofSystemChangesOfItem: #method
					change: #Removed
					using: #methodRemoved:.].! !

!SVNEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 21:39'!
svnProjects
	^ svnProjects! !

!SVNEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 21:39'!
svnProjects: anObject
	svnProjects := anObject! !

SVNEnvironment subclass: #SVNSystemBrowserEnvironment
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

SVNSystemBrowserEnvironment class
	instanceVariableNames: 'svnSystemBrowserRegistry'!

SVNSystemBrowserEnvironment class
	instanceVariableNames: 'svnSystemBrowserRegistry'!

!SVNSystemBrowserEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 23:43'!
currentProject
	^ currentProject! !

!SVNSystemBrowserEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 23:43'!
currentProject: anObject
	currentProject := anObject! !

!SVNSystemBrowserEnvironment methodsFor: 'updating' stamp: 'rkrk 4/14/2008 03:54'!
currentSvnProjectChanged: aSVNCurrentProjectChangedAnn

	self currentProject: aSVNCurrentProjectChangedAnn currentProject! !

!SVNSystemBrowserEnvironment methodsFor: 'updating' stamp: 'rkrk 4/14/2008 03:54'!
subscribeWithAnnouncer: anOBAnnouncer

	anOBAnnouncer
		observe: SVNCurrentProjectChanged
		send: #currentSvnProjectChanged:
		to: self.! !

Object subclass: #SVNLoader
	instanceVariableNames: 'requiredClasses classesToLoad unknownRequiredClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:27'!
loadSVNClasses: aSet
"superclasses"
	^self loadSVNClasses: aSet andSVNMethods: (Set new)! !

!SVNLoader class methodsFor: 'loading' stamp: 'rkrk 4/1/2008 12:12'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet

	self flag: #TODO. "implement unload..., reload (unload->load)"
	^ self new
		loadSVNClasses: aSVNClassSet
		andSVNMethods: aSVNMethodSet;
		yourself.! !

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:26'!
loadSVNMethods: aSet
"Classes"
	^self loadSVNClasses: (Set new) andSVNMethods: aSet! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/8/2008 16:44'!
addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet 

	| newDependencies |
	self classesToLoad addAll: (aSVNClassSet collect: [:each | each theName]).
	newDependencies := aSVNClassSet collect: [:each | each superclassName asString].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/10/2008 13:12'!
addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet 

	| newDependencies |
	newDependencies := aSVNMethodSet collect: [:each | each nameOfClass substrings first].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 12:01'!
classesToLoad
	^classesToLoad! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 23:05'!
findOriginInSystemFor: aSVNClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet

	| ownSuperclassName svnSuperClass |
	ownSuperclassName := aSVNClass superclassName.
	ownSuperclassName = aString ifTrue: [^nil].
	(aSet includes: ownSuperclassName) ifFalse: [^ownSuperclassName].
			
	svnSuperClass := (aSVNClassSet select: [:aClass | aClass theName = ownSuperclassName]) someElement.
	
	^self findOriginInSystemFor: svnSuperClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet.! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/7/2008 23:05'!
hasCycle: aSVNClassSet.
	"Answer if there is a cycle in the set of svnClasses.
	Needs that addToRequiredClassesAllDependenciesInSVNClasses: had running."

	aSVNClassSet do: [:eachClass |
			(self
				findOriginInSystemFor: eachClass
				superclassCanNotBe: eachClass theName
				superclassMustBeInSystemOr: aSVNClassSet
				consider: (self requiredClasses intersection: (self classesToLoad))) ifNil: [^true]].
	^false! !

!SVNLoader methodsFor: 'initialization' stamp: 'rt 3/7/2008 12:09'!
initialize
	super initialize.
	requiredClasses := Set new.
	classesToLoad := Set new.
	unknownRequiredClasses := Set new! !

!SVNLoader methodsFor: 'loading' stamp: 'rt 3/10/2008 13:14'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet 

	self addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	self addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet.
	
	self flag: #TODO. "abort, if some required classes are unknown or there are cycles"
	self unknownRequiredClasses ifNotEmpty: [^self].
	(self hasCycle: aSVNClassSet) ifTrue: [^self].
	
	self loadSVNClassesSorted: aSVNClassSet.
	aSVNMethodSet do: [:each | each load]! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/10/2008 13:14'!
loadSVNClassesSorted: aSVNClassSet

	| sortedClasses |
	sortedClasses := self sortSVNClasses: aSVNClassSet consider: (self requiredClasses intersection: self classesToLoad).
	
	sortedClasses do: [:each | each load]! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 00:37'!
requiredClasses
	^requiredClasses! !

!SVNLoader methodsFor: 'sorting' stamp: 'rt 3/7/2008 22:29'!
sortSVNClasses: aSVNClassSet consider: aSet

	| allSubclasses subclasses |
	aSet ifEmpty: [^aSVNClassSet].
	allSubclasses := Set new.
	aSVNClassSet do: [:each |
		(aSet includes: each theName)
			ifTrue: [subclasses := aSVNClassSet select: [:subClass |
												(subClass superclassName = each theName)].
					each subclasses addAll: subclasses.
					allSubclasses addAll: subclasses]].
	
	aSVNClassSet removeAll: allSubclasses.
	^aSVNClassSet! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/8/2008 16:49'!
unknownRequiredClasses
	"all required classes, which are not in classesToLoad and unknown in the system"
	| unknownClasses realyUnknownClasses class |
	unknownClasses := self requiredClasses copy.
	unknownClasses removeAllFoundIn: self classesToLoad.
	realyUnknownClasses := Set new.
	unknownClasses do: [:each | 
		class := Smalltalk classNamed: each.
		(class isNil or: [class isObsolete]) ifTrue: [realyUnknownClasses add: each]].
	^realyUnknownClasses
	! !

Object subclass: #SVNNode
	instanceVariableNames: 'svnElement parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

SVNNode subclass: #SVNClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNClassNode methodsFor: 'functionality' stamp: 'rkrk 4/12/2008 11:42'!
getChildren

	^ {SVNInstanceSideOfClassNode element: self svnElement parent: self.
	SVNClassSideOfClassNode element: self svnElement parent: self.
	SVNCommentNode element: self svnElement parent: self}.! !

SVNNode subclass: #SVNClassSideOfClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'rkrk 4/15/2008 05:24'!
getChildren

	self doOnlyOnce: [self halt.].
	^ self svnElement versionedMethods
		select: [:each | each isPartOfMetaclass]
		thenCollect: [:each | SVNMethodNode element: each parent: self].! !

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'rkrk 4/7/2008 04:17'!
getLabel

	^ 'class'! !

SVNNode subclass: #SVNCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNCommentNode methodsFor: 'functionality' stamp: 'rkrk 4/6/2008 03:44'!
getLabel

	^ 'comment'! !

SVNNode subclass: #SVNInstanceSideOfClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'cop 4/14/2008 12:29'!
getChildren
	^ self svnElement versionedMethods
		select: [:each | each isPartOfMetaclass not]
		thenCollect: [:each | SVNMethodNode element: each parent: self].! !

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:52'!
getLabel
	^'instance'! !

SVNNode subclass: #SVNMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNNode class methodsFor: 'instance creation' stamp: 'rkrk 4/12/2008 11:43'!
element: aSVNElement
	
	^self new
		svnElement: aSVNElement;
		yourself.! !

!SVNNode class methodsFor: 'instance creation' stamp: 'rkrk 4/12/2008 11:44'!
element: aSVNElement parent: aSVNNode
	
	^ (self  element: aSVNElement)
		parent: aSVNNode;
		yourself.! !

!SVNNode methodsFor: 'testing' stamp: 'rkrk 4/14/2008 12:13'!
belongsToCurrentSvnProject

	"Kludge. Needed becaus of compatibility for OBSystemBrowser"
	^ true! !

!SVNNode methodsFor: 'functionality' stamp: 'rkrk 4/7/2008 04:18'!
getChildren

	^ OrderedCollection new! !

!SVNNode methodsFor: 'functionality' stamp: 'rkrk 4/12/2008 11:43'!
getLabel

	^ self svnElement theName! !

!SVNNode methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:35'!
hasSvnElementOfKind: aClass

	^ self svnElement isKindOf: aClass! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 04:18'!
parent

	^ parent! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 04:18'!
parent: aSVNNode

	parent := aSVNNode! !

!SVNNode methodsFor: 'message handling' stamp: 'rkrk 4/6/2008 03:41'!
perform: selector orSendTo: otherTarget

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:44'!
svnElement

	^ svnElement! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:44'!
svnElement: aSVNElement

	svnElement := aSVNElement! !

SVNNode subclass: #SVNProjectMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNProjectMethodNode methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 06:52'!
getChildren

	^ self svnElement versionedMethods
		collect: [:each | SVNMethodNode element: each parent: self].! !

!SVNProjectMethodNode methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 06:52'!
getLabel

	^ 'methods'! !

SVNNode subclass: #SVNProjectNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNProjectNode methodsFor: 'functionality' stamp: 'rkrk 4/15/2008 06:51'!
getChildren

	| children |
	children := self svnElement versionedClasses
		collect: [:each | SVNClassNode element: each parent: self].
	self svnElement versionedMethods ifNotEmpty: [
		children add: (SVNProjectMethodNode element: self svnElement parent: self)].
	^ children! !

Object subclass: #SVNRepository
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNRepository class methodsFor: 'instance creation' stamp: 'rt 4/9/2008 00:28'!
on: anURL

	(self repositoryExistsOn: anURL) ifFalse: [^nil].
	^self new
		setUrl: anURL;
		yourself! !

!SVNRepository class methodsFor: 'primitives' stamp: 'rt 4/8/2008 13:02'!
primitiveSvnExistsRepositoryOnUrl: anUrl
	<primitive: 'svnExistsRepositoryOnUrl' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository class methodsFor: 'primitives' stamp: 'rt 4/8/2008 12:41'!
primitiveSvnRequireAuthenticationAtRepositoryOnUrl: anUrl
	<primitive: 'svnRequireAuthenticationAtRepositoryOnUrl' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository class methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:01'!
repositoryExistsOn: anUrl

	^ self primitiveSvnExistsRepositoryOnUrl: anUrl pathForSvn! !

!SVNRepository class methodsFor: 'evaluating' stamp: 'rt 4/8/2008 12:58'!
requireAuthenticationAtRepositoryOnUrl: anUrl

	^ self primitiveSvnRequireAuthenticationAtRepositoryOnUrl: anUrl pathForSvn! !

!SVNRepository methodsFor: 'project creating' stamp: 'rt 4/8/2008 13:25'!
createProject: aName

	(self projectExists: aName)
		ifFalse: [self primitiveCreateProject: aName onUrl: self url pathForSvn].
	^ aName! !

!SVNRepository methodsFor: 'primitives' stamp: 'rt 4/8/2008 13:24'!
primitiveCreateProject: aName onUrl: anUrl

	<primitive: 'svnCreateProjectOnRepository' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNRepository methodsFor: 'primitives' stamp: 'rt 4/8/2008 13:22'!
primitiveProject: aName existsOnRepository: anUrl

	<primitive: 'svnProjectExistsOn' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository methodsFor: 'project creating' stamp: 'rt 4/8/2008 13:22'!
projectExists: aName

	^ self primitiveProject: aName existsOnRepository: self url pathForSvn! !

!SVNRepository methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:12'!
repositoryExists

	^ self class repositoryExistsOn: self url! !

!SVNRepository methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:13'!
requiresAuthentication

	^ self class requireAuthenticationAtRepositoryOnUrl: self url! !

!SVNRepository methodsFor: 'accessing' stamp: 'rt 4/8/2008 12:41'!
setUrl: anUrl
	url := anUrl! !

!SVNRepository methodsFor: 'accessing' stamp: 'rt 3/30/2008 23:45'!
url
	^url! !

Object subclass: #SVNRequest
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

SVNRequest subclass: #SVNInfoRequest
	instanceVariableNames: 'author revision lastChangedRevision date repositoryRootUrl repositoryUUID schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 04:33'!
arrayForPrimitive

	"Pass this array down and fill in the elements the result of svn info"
	^ {
		self stringForRepositoryRootUrl.
		self elementForRevision.			"Current revision"
		self stringForRepositoryUUID.
		self elementForRevision.			"Last changed revision"
		self stringForDate.
		self stringForAuthor.
		self stringForSchedule
	}! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:42'!
elementForRevision

	^ SVNRevision unspecified! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForAuthor

	^ String new: 125! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForDate

	"apr_ctime returns a string of size 25"
	^ String new: 25! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForRepositoryRootUrl

	^ String new: 255! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:20'!
stringForRepositoryUUID

	^ String new: 36! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForSchedule

	^ String new: 8! !

!SVNInfoRequest class methodsFor: 'instance creation' stamp: 'mu 3/31/2008 15:14'!
target: svnDirectoryEntry

	^ self new
		target: svnDirectoryEntry;
		yourself.! !

!SVNInfoRequest methodsFor: 'primitive' stamp: 'rkrk 3/23/2008 02:51'!
arrayForPrimitive

	"Some objects are mapped to more than one object for their
	representation in the primitive. E.g. a SVNRevision is mapped
	to: <KindString>. NumberOrNil"
	^ (self class arrayForPrimitive
		inject: OrderedCollection new
		into: [:preparedCol :each |
			preparedCol addAll: each forSvnPrimitive.
			preparedCol]) asArray.! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
author
	^ author! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
author: anObject
	author := anObject! !

!SVNInfoRequest methodsFor: 'primitive' stamp: 'rkrk 3/24/2008 11:24'!
basicSvnGetInfoFrom: targetPath revisionKind: revKind revisionNumber: revNumber storeInArray: array

	<primitive: 'svnInfoForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNInfoRequest methodsFor: 'service' stamp: 'rkrk 3/23/2008 03:35'!
convertToDateFromCTimeString: aString

	self flag: #TODO. "Implement the thing"
	^ DateAndTime current! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
date
	^ date! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
date: anObject
	date := anObject! !

!SVNInfoRequest methodsFor: 'execution' stamp: 'test 3/26/2008 00:15'!
execute

	| result arrayForPrimitive |
	
	arrayForPrimitive := self arrayForPrimitive.
	self assert: arrayForPrimitive size = 9.
	
	result := self
		basicSvnGetInfoFrom: self target path pathForSvn
		revisionKind: 0 revisionNumber: 0
		storeInArray: arrayForPrimitive.

	self assert: arrayForPrimitive = result.
	
	self processResult: result.! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
lastChangedRevision
	^ lastChangedRevision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
lastChangedRevision: anObject
	lastChangedRevision := anObject! !

!SVNInfoRequest methodsFor: 'string converting' stamp: 'rkrk 3/23/2008 02:05'!
null

	^ Character value: 0! !

!SVNInfoRequest methodsFor: 'string converting' stamp: 'rkrk 3/23/2008 02:05'!
prepareStringForPrimitive: string

	"self assert: (string includes: self null) not."
	string at: string size put: self null.
	^ string convertToSystemString.! !

!SVNInfoRequest methodsFor: 'string converting' stamp: 'rkrk 3/23/2008 02:05'!
prepareStringForSqueak: string

	^ string asDefaultDecodedString copyUpTo: (Character value: 0).	! !

!SVNInfoRequest methodsFor: 'execution' stamp: 'rkrk 4/3/2008 16:19'!
processResult: resultArray

	| preparedArray |
	self flag: #TODO. "Implicit mapping. Where should the indices be stored?"
	preparedArray := resultArray collect: [:each | each isString
		ifTrue: [self prepareStringForSqueak: each]
		ifFalse: [each]].
	self repositoryRootUrl: (preparedArray at: 1).
	self revision: (SVNRevision
		fromKind: (preparedArray at: 2)
		number: (preparedArray at: 3)).
	self repositoryUUID: (preparedArray at: 4).
	self lastChangedRevision: (SVNRevision
		fromKind: (preparedArray at: 5)
		number: (preparedArray at: 6)).
	self date: (self convertToDateFromCTimeString: (preparedArray at: 7)).
	self author: (preparedArray at: 8).
	self schedule: (preparedArray at: 9).! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryRootUrl
	^ repositoryRootUrl! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryRootUrl: anObject
	repositoryRootUrl := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryUUID
	^ repositoryUUID! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryUUID: anObject
	repositoryUUID := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
revision
	^ revision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
revision: anObject
	revision := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:36'!
schedule
	^ schedule! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:36'!
schedule: anObject
	schedule := anObject! !

!SVNRequest class methodsFor: 'instance creation' stamp: 'rkrk 4/3/2008 16:43'!
target: svnDirectoryElement

	^ self new
		target: svnDirectoryElement;
		yourself.! !

!SVNRequest methodsFor: 'execution' stamp: 'cop 4/10/2008 08:14'!
execute
	^self subclassResponsibility! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 17:08'!
target
	^ target! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 17:08'!
target: anObject
	target := anObject! !

SVNRequest subclass: #SVNStatusRequest
	instanceVariableNames: 'statusKind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNStatusRequest class methodsFor: 'svn constants' stamp: 'rkrk 4/12/2008 14:07'!
statusKindDictionary

"enum svn_wc_status_kind:"

	^ Dictionary new
		at: nil 	put: #unversioned;
		at: 1 	put: #none;			"does not exist"
		at: 2 	put: #unversioned;	"is not a versioned thing in this wc"
		at: 3 	put: #normal;		"exists, but uninteresting"
		at: 4 	put: #added;			"is scheduled for addition"
		at: 5 	put: #missing;		"under v.c., but is missing"
		at: 6 	put: #deleted;		"scheduled for deletion"
		at: 7 	put: #replaced;		"was deleted and then re-added"
		at: 8 	put: #modified;		"text or props have been modified"
		at: 9 	put: #merged;		"local mods received repos mods"
		at: 10 	put: #conflicted;	"local mods received conflicting repos mods"
		at: 11 	put: #ignored;		"is unversioned but configured to be ignored"
		at: 12 	put: #obstructed;	"an unversioned resource is in the way of the versioned resource"
		at: 13 	put: #external;		"an unversioned path populated by an svn:externals property"
		at: 14 	put: #incomplete;	"a directory doesn't contain a complete entries list"
		yourself.! !

!SVNStatusRequest methodsFor: 'primitive' stamp: 'rkrk 4/12/2008 14:04'!
arrayForPrimitive

	"Put only an enum value (int) into the array.
	It is created in the primitive, so pass nil."
	^ {nil}.! !

!SVNStatusRequest methodsFor: 'execution' stamp: 'rkrk 4/3/2008 17:05'!
execute

	| result arrayForPrimitive |
	
	arrayForPrimitive := self arrayForPrimitive.
	self assert: arrayForPrimitive size = 1.
	
	result := self
		primSvnStatus: self target path pathForSvn
		revisionKind: nil revisionNumber: nil
		storeInArray: arrayForPrimitive.
	
	self processResult: result.! !

!SVNStatusRequest methodsFor: 'testing' stamp: 'rkrk 4/7/2008 15:27'!
isConflicted

	^ self statusKind = #conflicted! !

!SVNStatusRequest methodsFor: 'primitive' stamp: 'rkrk 4/3/2008 16:41'!
primSvnStatus: target revisionKind: revKind revisionNumber: revNum storeInArray: arr

	<primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNStatusRequest methodsFor: 'execution' stamp: 'rkrk 4/3/2008 17:15'!
processResult: resultArray

	self statusKind: (self class statusKindDictionary at: (resultArray at: 1)).! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 16:58'!
statusKind
	^ statusKind! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 16:58'!
statusKind: anObject
	statusKind := anObject! !

Object subclass: #SVNRevision
	instanceVariableNames: 'number kind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:39'!
base
	".svn/entries current revision"

	^ self
		fromKindSymbol: #base
		number: nil.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 12:05'!
fromKind: enumKindNumber number: number

	"Not for public use"
	^ self basicNew
		initialize;
		kind: enumKindNumber;
		number: number;
		yourself.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 12:06'!
fromKindSymbol: symbol number: number

	"Not for public use"
	^ self
		fromKind: (self revisionKindDictionary at: symbol)
		number: number.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/25/2008 04:13'!
halloWelt

	self teilnehmerListe do: [: teilnehmer |
		Transcript
			show: 'Hallo ';
			show: teilnehmer;
			show: ' - Willkommen zum Etoys Workshop';
			cr.]! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:40'!
head
	".svn/entries current revision"

	^ self
		fromKindSymbol: #head
		number: nil.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/23/2008 01:02'!
new

	self error: 'No new!! Use specific revisions!!'! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:40'!
number: aNumber

	^ self
		fromKindSymbol: #number
		number: aNumber.! !

!SVNRevision class methodsFor: 'svn constants' stamp: 'rkrk 3/24/2008 11:48'!
revisionKindDictionary

	"enum svn_opt_revision_kind
		0 svn_opt_revision_unspecified - No revision information given.
		1 svn_opt_revision_number- revision given as number
		2 svn_opt_revision_date- revision given as date
		3 svn_opt_revision_committed- rev of most recent change
		4 svn_opt_revision_previous- (rev of most recent change) - 1
		5 svn_opt_revision_base- .svn/entries current revision
		6 svn_opt_revision_working - current, plus local mods
		7 svn_opt_revision_head- repository youngest"
	^ Dictionary new
		add: #unspecified 	-> 0;
		add: #number 		-> 1;
		add: #date 			-> 2;
		add: #committed 	-> 3;
		add: #previous 		-> 4;
		add: #base 			-> 5;
		add: #working 		-> 6;
		add: #head 			-> 7;
		yourself.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:40'!
unspecified
	
	^ self
		fromKindSymbol: #unspecified
		number: nil.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:41'!
working
	"current, plus local mods"

	^ self
		fromKindSymbol: #working
		number: nil.! !

!SVNRevision methodsFor: 'comparing' stamp: 'rkrk 3/24/2008 11:52'!
= other

	super = other.
	^ self number
		ifNil: [self kind = other kind]
		ifNotNil: [self number = other number].! !

!SVNRevision methodsFor: 'converting' stamp: 'rkrk 3/24/2008 11:51'!
forSvnPrimitive

	self flag: #TODO.
	^ {self kind. self number} asOrderedCollection.! !

!SVNRevision methodsFor: 'testing' stamp: 'rkrk 3/24/2008 11:52'!
hash

	^ self number
		ifNil: [self kind hash]
		ifNotNil: [self number hash].! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:44'!
kind
	^ kind! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:44'!
kind: anObject
	kind := anObject! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:45'!
kindSymbol
	^ self class revisionKindDictionary keyAtValue: self kind! !

!SVNRevision methodsFor: 'accessing' stamp: 'test 3/23/2008 02:43'!
number

	^ number! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 00:59'!
number: anObject
	number := anObject! !

!SVNRevision methodsFor: 'printing' stamp: 'rkrk 3/25/2008 23:55'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self kindSymbol asString;
		nextPutAll: ' - ';
		nextPutAll: self number asString;
		nextPut: $).! !

Object subclass: #SVNTestDirectory
	instanceVariableNames: 'directory isDirty number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectory subclass: #SVNAwareTestDirectory
	instanceVariableNames: 'workingCopyDirectory workingCopyDirectory2 repositoryDirectory'
	classVariableNames: 'UseTestEnvPlg'
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/14/2008 00:08'!
testEnvPlgInUse

	UseTestEnvPlg ifNil: [^ false].
	^ UseTestEnvPlg! !

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/13/2008 23:58'!
useOSProcess: bool

	UseTestEnvPlg := bool not! !

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/13/2008 23:58'!
useTestEnvPlg: bool

	UseTestEnvPlg := bool! !

!SVNAwareTestDirectory methodsFor: 'consistency' stamp: 'rkrk 4/3/2008 03:09'!
checkConsistency
	
	| workingCopyIsDirty workingCopy2IsDirty |
	workingCopyIsDirty := (self workingCopyDirectory exists and:
					[self workingCopyDirectory entries size = 1]) not.
	"SVNAwareTestDirectories which were created before the addition of
	the second working copy have no workingCopyDirectory2. Declare them
	as dirty. this can be removed after everyone has fresh test directories"
	workingCopy2IsDirty := self workingCopyDirectory2 isNil.
	self directory: self directory.
	"Really test if wc2 is dirty"
	workingCopy2IsDirty ifFalse:
		[workingCopy2IsDirty := self workingCopyDirectory2 exists].
	
	self isDirty: (workingCopyIsDirty or: [workingCopy2IsDirty]).! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 03:09'!
create

	super create.
	self
		createRepository;
		createWorkingCopy.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rt 4/14/2008 00:13'!
createRepository
	
	self assert: (FileDirectory on: self repositoryPath) exists not.
	
	self class testEnvPlgInUse
		ifTrue: [TestEnvAcs svnCreateRepositoryOn: self repositoryPath]
		ifFalse: [self executeViaOSProcessSynchronously: 'svnadmin create "' , self repositoryPath ,'"'.]
	! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 01:35'!
createSecondWorkingCopy

	self isDirty: true.
	self createWorkingCopyInPath: self workingCopyDirectory2 pathName.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 01:26'!
createWorkingCopy

	self createWorkingCopyInPath: self workingCopyDirectory pathName.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rt 4/14/2008 00:13'!
createWorkingCopyInPath: path

	self assert: self repositoryDirectory exists.
	self assert: (FileDirectory on: path) exists not.
	
	self class testEnvPlgInUse
		ifTrue: [TestEnvAcs svnCheckoutHeadRevisionFrom: self repositoryURLPath to: path]
		ifFalse: [self executeViaOSProcessSynchronously:
		'svn co ' , self repositoryURLPath , ' "' , path , '"'.]
	! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
directory: aFileDirectory
	super directory: aFileDirectory.
	
	self
		workingCopyDirectory: (aFileDirectory directoryNamed: self nameForWorkingCopy);
		workingCopyDirectory2: (aFileDirectory directoryNamed: self nameForWorkingCopy2);
		repositoryDirectory: (aFileDirectory directoryNamed: self nameForRepository)! !

!SVNAwareTestDirectory methodsFor: 'OSProcess' stamp: 'cop 4/7/2008 12:56'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 1000].].! !

!SVNAwareTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	^ true! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForRepository

	^ 'repository'! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForWorkingCopy

	^ 'workingCopy'! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 4/3/2008 01:24'!
nameForWorkingCopy2

	^ 'workingCopy2'! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:02'!
pathForTests

	^ self workingCopyPath! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory

	^ repositoryDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory: aFileDirectory

	repositoryDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:31'!
repositoryPath

	^ self repositoryDirectory pathName! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:49'!
repositoryURLPath

	^ self repositoryDirectory asUrl asString! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:11'!
workingCopyDirectory

	^ workingCopyDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
workingCopyDirectory2
	^ workingCopyDirectory2! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
workingCopyDirectory2: anObject
	workingCopyDirectory2 := anObject! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:08'!
workingCopyDirectory: aFileDirectory

	workingCopyDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:03'!
workingCopyPath

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self workingCopyDirectory pathName! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:46'!
workingCopyPath2

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self workingCopyDirectory2 pathName! !

!SVNTestDirectory class methodsFor: 'instance creation' stamp: 'rkrk 3/14/2008 20:39'!
theName: aName basePath: basePath

	^ self new
		directory: (FileDirectory on: basePath , FileDirectory slash , aName);
		yourself.! !

!SVNTestDirectory methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:17'!
checkConsistency
	
	self isDirty: (self directory exists and: [self directory entries size = 0]) not.
! !

!SVNTestDirectory methodsFor: 'clearing' stamp: 'rkrk 3/16/2008 01:24'!
clear

	self directory deleteRecursivelyPlatformIndependent! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:21'!
create

	self directory exists ifTrue: [self reCreate. ^ self].
	self directory assureExistence.
	self isDirty: false.! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory
	^ directory! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory: anObject
	directory := anObject! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'test 3/16/2008 06:25'!
initialize

	super initialize.
	self isDirty: true.
	number := 1000 atRandom.! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 21:58'!
isDirty

	^ isDirty! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:00'!
isDirty: anObject
	isDirty := anObject! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	"I cannot create repositories and stuff"
	^ false! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 21:59'!
pathForTests

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self directory pathName! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:26'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self isDirty ifTrue: [''] ifFalse: ['not ']);
		nextPutAll: 'dirty';
		nextPutAll: ' ' , number asString;
		nextPut: $).! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:25'!
reCreate

	self
		clear;
		create! !

Object subclass: #SVNTestDirectoryManager
	instanceVariableNames: 'currentDirectory basicTestDirectories svnAwareTestDirectories basePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

!SVNTestDirectoryManager class methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:10'!
checkConsistency

	self getInstance checkConsistency.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:09'!
createObservingMorph

	"SVNTestDirectoryManager createObservingMorph"
	observingMorph := SVNObservingMorph new.
	observingMorph
		openInWorld;
		start.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 03:05'!
getInstance

	"[SVNTestDirectoryManager getInstance]
	[SVNTestDirectoryManager instance: nil]"
	^ self instance
		ifNil: [instance := self basicNew initialize]
		ifNotNil: [self instance]! !

!SVNTestDirectoryManager class methodsFor: 'class initialization' stamp: 'rkrk 3/16/2008 17:10'!
initialize

	"self initialize"
	super initialize.
	World 
		when: #aboutToEnterWorld
		send: #checkConsistency to: self.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:57'!
instance

	^ instance! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:58'!
instance: instanceOfSelf

	instance := instanceOfSelf! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:10'!
killObservingMorph

	"SVNTestDirectoryManager killObservingMorph"
	observingMorph
		stop;
		delete.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 01:45'!
new

	self error: 'Singleton. Call getInstance'.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 07:02'!
reCreate

	"SVNTestDirectoryManager reCreate"
	[self getInstance reCreateTestDirectories. self beep] fork.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:19'!
uninstall

	self getInstance clear.
	self instance: nil.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/12/2008 21:49'!
basePath
	basePath
		ifNil: [^ self basePath: FileDirectory default fullName , FileDirectory slash , 'svnTests'].
	^ basePath! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 00:25'!
basePath: anObject
	basePath := anObject! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/18/2008 23:55'!
basicReCreateDirectories: directories howMany: number
"Recreate all or only the given number of directories.
Ignore if number > directories size"

	| dirtyDirs |
	dirtyDirs := directories select: [:ea | ea isDirty].
	dirtyDirs size > number ifTrue: [dirtyDirs := dirtyDirs first: number].
	dirtyDirs
		do: [:each | each reCreate]
		displayingProgress: 'Recreating dirty test directories'.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
basicTestDirectories
	^ basicTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'test 3/16/2008 06:03'!
basicTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	"self assert: (anObject isKindOf: Array) not."
	basicTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:28'!
checkConsistency

	self testDirectories
		do: [:ea | ea checkConsistency]
		displayingProgress: 'SVNTestDirectoryManager conistency check'.! !

!SVNTestDirectoryManager methodsFor: 'removing' stamp: 'rkrk 3/16/2008 01:27'!
clear

	self testDirectories do: [:ea | ea clear].
	(FileDirectory on: self basePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:29'!
create: number fromClass: SVNDirectoryClass named: partOfName considerExisting: directories
"Create only as many new directories as needed. Reuse old ones"

	| newDirectories |
	^ directories size >= number
		ifTrue: [self reuse: number of: directories]
		ifFalse: [
			newDirectories := (directories size to: number - 1) collect: [:i |
				SVNDirectoryClass
					theName: partOfName , i asString
					basePath: self basePath].
				directories addAll: newDirectories asOrderedCollection.
				directories].! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:39'!
createBasicTestDirectories: number

	self basicTestDirectories: (self
		create: number
		fromClass: SVNTestDirectory
		named: 'SVNTestDirectory_'
		considerExisting: self basicTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/19/2008 00:00'!
createBasicTestDirs: numberForBasic svnAwareTestDirs: numberForSvnAware
"This method should be called by a user for setting up the state
og the manager"

	self assert: self basePath notNil.
	self
		createBasicTestDirectories: numberForBasic;
		createSvnAwareTestDirectories: numberForSvnAware.
	self reCreateTestDirectories.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:38'!
createSvnAwareTestDirectories: number

	self svnAwareTestDirectories: (self
		create: number
		fromClass: SVNAwareTestDirectory
		named: 'SVNAwareTestDirectory_'
		considerExisting: self svnAwareTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory
	^ currentDirectory! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory: anObject
	currentDirectory := anObject! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 02:05'!
findCleanSvnAwareTestDirectory

	self assert: self svnAwareTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware and: [directory isDirty not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 02:06'!
findCleanTestDirectory

	self assert: self basicTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware not and: [directory isDirty not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 03:04'!
findTestDirectoryWhichSatisfies: conditionBlock

	^ self testDirectories
		detect: conditionBlock
		ifNone: [self reCreatePercent: 10.
			self testDirectories detect: conditionBlock].! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:57'!
initialize

	super initialize.
	self
		basicTestDirectories: OrderedCollection new;
		svnAwareTestDirectories: OrderedCollection new.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanBasicTestDirectories

	^ self basicTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanSvnAwareTestDirectories

	^ self svnAwareTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 00:36'!
pathForTests

	self
		assert: self currentDirectory notNil
		description: 'The calling test has not registered for directory support'.
	^ self currentDirectory pathForTests! !

!SVNTestDirectoryManager methodsFor: 'helper' stamp: 'rkrk 3/16/2008 05:18'!
percent: percent of: total

	| result |
	result := (total * (percent / 100)) asInteger.
	result = 0 ifTrue: [^ 1]. "should at least be one"
	^ result! !

!SVNTestDirectoryManager methodsFor: 'printing' stamp: 'rkrk 3/16/2008 03:58'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: 'svn aware: ';
		nextPutAll: self svnAwareTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanSvnAwareTestDirectories asString;
		nextPutAll: ' basic: ';
		nextPutAll: self basicTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanBasicTestDirectories asString;
		nextPut: $).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/16/2008 02:47'!
reCreatePercent: percent

	self
		basicReCreateDirectories: self basicTestDirectories
	 	howMany: (self	percent: percent of: self basicTestDirectories size).
	self
		basicReCreateDirectories: self svnAwareTestDirectories
	 	howMany: (self	percent: percent of: self svnAwareTestDirectories size).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/16/2008 02:41'!
reCreateTestDirectories

	self reCreatePercent: 100.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForSvnAwareTestDirectory
	
	self currentDirectory: self findCleanSvnAwareTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 4/3/2008 01:48'!
registerForSvnAwareTestDirectoryWithTwoWorkingCopies

	self registerForSvnAwareTestDirectory.
	self currentDirectory createSecondWorkingCopy.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForTestDirectory
	
	self currentDirectory: self findCleanTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
repositoryURLPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:15'!
reuse: number of: directories

	| directoriesNotNeeded |
	directoriesNotNeeded := (directories last: directories size - number).
	directoriesNotNeeded do: [:ea | ea clear].
	^ (directories first: number) asOrderedCollection! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
svnAwareTestDirectories
	^ svnAwareTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 06:00'!
svnAwareTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	self assert: (anObject isKindOf: Array) not.
	svnAwareTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 02:01'!
testDirectories

	^ self basicTestDirectories union: self svnAwareTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 02:38'!
unregister

	self flag: #TODO. "self currentDirectory: nil"
	self currentDirectory: self findCleanTestDirectory.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
workingCopyPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory workingCopyPath.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:45'!
workingCopyPath2

	self assert: (self currentDirectory notNil
		and: [self currentDirectory isSvnAware]
		and: [self currentDirectory workingCopyDirectory2 exists]).
	^ self currentDirectory workingCopyPath2.! !

Object subclass: #SVNTool
	instanceVariableNames: 'builder window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNTool subclass: #SVNCommitBrowser
	instanceVariableNames: 'svnElement comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCommitBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/6/2008 02:21'!
openWith: svnElement

	^ self new
		svnElement: svnElement;
		open;
		yourself.
! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:22'!
buildCommentField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #comment;
		setText: #setComment:;
		frame: (0 @ 0 corner: 1 @ 0.3);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:23'!
buildCommitButton
	
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self commitButtonLabel;
		action: #commit;
		color: #grayColor;
		frame: (0.4 @ 0.9 corner: 0.6 @ 1);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:23'!
buildCommitSelectionTree

	^ (self builder pluggableTreeSpec new)
		frame: (0 @ 0.3 corner: 1 @ 0.9);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:25'!
buildWidgets

	^ {self buildCommentField.
	self buildCommitSelectionTree.
	self buildCommitButton}! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:18'!
comment

	^ comment ifNil: ['Enter a comment'].! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:18'!
comment: aString

	comment := aString.! !

!SVNCommitBrowser methodsFor: 'commiting' stamp: 'rkrk 4/6/2008 01:37'!
commit

	self svnElement commitWithMessage: self comment.
	SVNCommitMessage openWith: self comment.
	self close.! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/5/2008 23:19'!
commitButtonLabel

	^ 'Commit'! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 00:27'!
extent

	^ 400 @ 300! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 00:27'!
label

	^ 'SqueakSVN Commit Browser'! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:07'!
setComment: aText

	self comment: aText asString.
	^ true.! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:17'!
svnElement
	^ svnElement! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:17'!
svnElement: anObject
	svnElement := anObject! !

SVNTool subclass: #SVNCommitMessage
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCommitMessage class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/6/2008 02:22'!
openWith: aString

	^ self new
		comment: aString;
		open;
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:49'!
buildLogMessageField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #logMessage;
		frame: (0 @ 0 corner: 1 @ 0.85);
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:49'!
buildOKButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: #okButtonLabel;
		action: #close;
		color: #grayColor;
		frame: (0.4 @ 0.85 corner: 0.6 @ 1);
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:41'!
buildWidgets

	^ {self buildLogMessageField.
	self buildOKButton}.! !

!SVNCommitMessage methodsFor: 'accessing' stamp: 'mu 3/13/2008 14:26'!
comment
	^ comment! !

!SVNCommitMessage methodsFor: 'accessing' stamp: 'mu 3/13/2008 14:26'!
comment: aString
	comment := aString! !

!SVNCommitMessage methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:45'!
extent

	^ 300@200! !

!SVNCommitMessage methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:45'!
label

	^ 'Commit successful'! !

!SVNCommitMessage methodsFor: 'log message creation' stamp: 'rkrk 4/6/2008 01:46'!
logMessage

	| logMessage |
	logMessage := 
		('Comment:' asText) allBold,
		String tab,
		self comment,
		String cr,
		String cr,
		('Timestamp:' asText) allBold,
		String tab,
		"nicht schn, da nicht die Zeit von der Version sondern aktuelle Zeit"
		TimeStamp current asString.
	^ logMessage! !

!SVNCommitMessage methodsFor: 'default' stamp: 'mu 3/13/2008 14:32'!
okButtonLabel
	^ 'Ok'! !

SVNTool subclass: #SVNCreateRepositoryTool
	instanceVariableNames: 'repositoryName repositoryUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 20:32'!
initialize

	"self initialize"
	self registerInOpenMenu.
! !

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 16:35'!
open

	^ self new
		open;
		yourself.
! !

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 20:31'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNCreateRepositoryTool'. {self. #open}}.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 16:36'!
buildGenerateRepositoryButton
	
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self generateRepositoryButtonLabel;
		action: #generate;
		color: #grayColor;
		frame: (0.2 @ 0.8 corner: 0.8 @ 1);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 16:30'!
buildRepositoryNameField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #repositoryName;
		setText: #setRepositoryName:;
		frame: (0 @ 0 corner: 1 @ 0.3);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 20:23'!
buildRepositoryPathField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #repositoryUrl;
		frame: (0 @ 0.3 corner: 1 @ 0.8);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 16:29'!
buildWidgets

	^ {self buildRepositoryNameField.
	self buildRepositoryPathField.
	self buildGenerateRepositoryButton}! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:42'!
defaultRepositoryNameInfo

	^ 'Please type in a name for the repository.'! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:36'!
extent

	^ 400 @ 200! !

!SVNCreateRepositoryTool methodsFor: 'generating' stamp: 'rkrk 4/17/2008 08:36'!
generate

	| repositoryDir |
	self repositoryName = self defaultRepositoryNameInfo ifTrue: [
		UIManager default inform: 'Please specify a local repository name'. ^ self].
	repositoryDir := (FileDirectory default directoryNamed: self repositoryName).
	SVNCommandLineClient executeViaOSProcessSynchronously: 'svnadmin create ' , repositoryDir pathName.
	self assert: repositoryDir exists.
	self repositoryUrl: repositoryDir asUrl asString.
	self changed: #repositoryUrl.! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:31'!
generateRepositoryButtonLabel

	^ 'Generate Repository'! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:31'!
label

	^ 'SqueakSVN Create Repository Tool'! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 16:42'!
repositoryName
	^ repositoryName ifNil: [self defaultRepositoryNameInfo]! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 16:35'!
repositoryName: anObject
	repositoryName := anObject! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:23'!
repositoryUrl
	^ repositoryUrl! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:23'!
repositoryUrl: anObject
	repositoryUrl := anObject! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:10'!
setRepositoryName: aText

	(aText asString includes: Character space) ifTrue: [^ false].
	self repositoryName: aText asString.
	^ true.! !

SVNTool subclass: #SVNModalTool
	instanceVariableNames: 'done response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNModalTool subclass: #SVNCreateProjectDialog
	instanceVariableNames: 'svnProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCreateProjectDialog class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/7/2008 04:22'!
call

	^ self new
		svnProject: (SVNProject named: '');
		open;
		call.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'mu 4/7/2008 13:42'!
buildCreateProjectButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: self projectButtonLabel;
		action: #finished;
		color: #greenColor;
		state: #canAccept;
		frame: (0.3 @ 0.8 corner: 0.7 @ 1);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:23'!
buildProjectNameField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectName;
		setText: #setProjectName:;
		frame: (0 @ 0 corner: 1 @ 0.266);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:23'!
buildUrlField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectUrl;
		setText: #setProjectUrl:;
		frame: (0 @ 0.266 corner: 1 @ 0.533);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:59'!
buildWidgets

	^ {self buildProjectNameField.
	self buildUrlField.
	self buildWorkingCopyPathField.
	self buildCreateProjectButton}.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:24'!
buildWorkingCopyPathField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectWorkingCopyPath;
		setText: #setProjectWorkingCopyPath:;
		frame: (0 @ 0.533 corner: 1 @ 0.8);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'testing' stamp: 'cop 4/14/2008 09:34'!
canAccept
	^ self projectName ~= self projectButtonLabel and:
		[self projectUrl ~= self defaultURL] and:
		[self projectWorkingCopyPath ~= self defaultWCPath].! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
cancelButtonLabel

	^ 'Cancel'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultProjectName

	^ 'Insert the project name here.'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultURL

	^ 'Insert the repository URL here'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultWCPath

	^ 'Insert the working copy path here'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:55'!
extent

	^ 300 @ 180! !

!SVNCreateProjectDialog methodsFor: 'accepting' stamp: 'cop 4/14/2008 09:36'!
finished

	self canAccept ifFalse: [^ self].
	self answer: self svnProject.
	self closeIfOpen.! !

!SVNCreateProjectDialog methodsFor: 'converting' stamp: 'rkrk 4/6/2008 02:42'!
getFullPathFor: aString

	aString asURI isAbsolute ifTrue: [^ aString].
	^ FileDirectory fullPathForURI: aString! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:55'!
label

	^ 'Create a SVNProject'.! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 02:02'!
projectButtonLabel

	^ 'Create project'! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/6/2008 02:55'!
projectName

	^ self svnProject theName
		ifEmpty: [self defaultProjectName]
		ifNotEmptyDo: [:name | name].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/14/2008 12:12'!
projectUrl

	^ self svnProject repositoryURL
		ifNil: [self defaultURL]
		ifNotNilDo: [:url |
			url
				ifEmpty: [self defaultURL]
				ifNotEmpty: [url asString]].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/14/2008 12:14'!
projectWorkingCopyPath

	^ self svnProject directory basePath
		ifNil: [self defaultWCPath]
		ifNotNilDo: [:dir | 
			dir
				ifEmpty: [self defaultWCPath]
				ifNotEmpty: [dir asString]].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/6/2008 02:45'!
setProjectName: stringOrText

	self svnProject theName: stringOrText asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/6/2008 02:28'!
setProjectUrl: stringOrText
	
	self svnProject repositoryURL:  stringOrText asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rt 4/13/2008 20:25'!
setProjectWorkingCopyPath: stringOrText

	| path |
	path := self getFullPathFor: stringOrText asString.
	self svnProject directory basePath: path.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:18'!
svnProject
	^ svnProject! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:18'!
svnProject: anObject
	svnProject := anObject! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:30'!
answer: object

	response := object.
	self endModalState.! !

!SVNModalTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 21:18'!
buildMainWindow
	
	^ super buildMainWindow
		closeAction: #endModalState;
		yourself.! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 22:20'!
call
	
	"Pattern taken from FillInTheBlankMorph"
	"Answers nil if canceled"
	| world |
	world := World.
	done := false.
	[done] whileFalse: [world doOneCycle].
	self closeIfOpen.
	world doOneCycle.
	^ response! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:24'!
closeIfOpen

	"Dirty hack. If the close (X) button is clicked then #close is called two times.
	The second time the widget is already closed, so the delete call results in an error."
	[self close] on: MessageNotUnderstood do: [].! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:30'!
endModalState

	done := true.! !

SVNModalTool subclass: #SVNRequestDialog
	instanceVariableNames: 'label text canAccepBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNRequestDialog class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/7/2008 03:55'!
ask: questionString template: templateString canAcceptBlock: aBlock

	^ self new
		canAccepBlock: aBlock;
		label: questionString;
		text: templateString;
		open;
		call.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:49'!
buildOKButton
	
	^ self builder pluggableButtonSpec new
		model: self;
		label: self okButtonLabel;
		action: #confirm;
		color: #greenColor;
		state: #canAccept;
		frame: (0.3 @ 0.6 corner: 0.7 @ 1);
		yourself.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:49'!
buildTextField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #text;
		setText: #text:;
		frame: (0 @ 0 corner: 1 @ 0.6);
		yourself.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 22:04'!
buildWidgets
	
	^ {self buildTextField.
	self buildOKButton}.! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:15'!
canAccepBlock
	^ canAccepBlock! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:15'!
canAccepBlock: anObject
	canAccepBlock := anObject! !

!SVNRequestDialog methodsFor: 'testing' stamp: 'rkrk 4/6/2008 22:10'!
canAccept

	^ self canAccepBlock value: self text.! !

!SVNRequestDialog methodsFor: 'confirming' stamp: 'rkrk 4/6/2008 22:22'!
confirm

	self canAccept ifFalse: [^ self].
	self answer: self text.! !

!SVNRequestDialog methodsFor: 'default' stamp: 'rkrk 4/7/2008 03:50'!
extent

	^ 220@100! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:10'!
label

	^ label! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:14'!
label: aString

	label := aString! !

!SVNRequestDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 22:11'!
okButtonLabel

	^ 'Confirm'! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:14'!
text
	^ text! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:54'!
text: anObject

	text := anObject.
	^ self canAccept! !

SVNTool subclass: #SVNProjectBrowser
	instanceVariableNames: 'projectNodes selectedNode selectedCommitLogString commitLogs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNProjectBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:35'!
initialize

	"self initialize"
	self registerInOpenMenu.! !

!SVNProjectBrowser class methodsFor: 'instance creation' stamp: 'cop 2/26/2008 13:51'!
open
	^self openOn: (SVNProject allInstances asOrderedCollection )! !

!SVNProjectBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/7/2008 04:10'!
openOn: aCollection

	^ self new
		listOfProjectNodes: aCollection;
		beDependentFromProjects: aCollection;
		open;
		yourself.! !

!SVNProjectBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:35'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNProjectBrowser'. {self. #open}}.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/7/2008 04:11'!
beDependentFromProjects: svnProjects

	svnProjects do: [:project |
		project allElements do: [:each |
			each addDependent: self]].! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/7/2008 02:00'!
buildButtonsFromCommands
"This methods creates commands from #commandClasses. For each command a button
is created and inserted at the bottom of the browser"
	| buttonHeight commands numberOfButtons buttonWidth buttonX buttonSpec |
	self flag: #TODO. "Refactor"
	buttonHeight := 0.9.
	commands := self commands select: [:ea | ea wantsButton].
	numberOfButtons := commands size.
	buttonWidth := 1 / numberOfButtons.
	buttonX := 0.
	^ commands collect: [:ea |
		buttonSpec := self builder pluggableButtonSpec new
			model: ea;
			label: ea label;
			action: #execute;
			frame: (buttonX@buttonHeight corner: (buttonX + buttonWidth)@1);
			yourself.
		buttonX := buttonX + buttonWidth.
		buttonSpec].
	! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 03:18'!
buildLogMessageText

	^ self builder pluggableTextSpec new
		model: self;
		getText: #displayLogMessage;
		frame: (0.5 @  0.5 corner: 1 @ 0.9);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:21'!
buildRevisionList

	^ self builder pluggableListSpec new
		model: self;
		list: #listRevisionsForSelectedElement;
		getSelected: #selectedCommitLogString;
		setSelected: #setSelectedCommitLogString:;
		getIndex: #revisionListIndex;
		setIndex: #revisionListIndex:;
		frame: (0.5 @ 0 corner: 1 @ 0.5);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 04:16'!
buildSvnElementTree

	^ self builder pluggableTreeSpec new
		model: self;
		roots: #projectNodes;
		hasChildren: #nodeHasChildren:;
		getChildren: #getChildrenOfNode:;
		label: #labelOfNode:;
		menu: #menuOn:;
		getSelectedPath: #getPathToSelectedNode;
		icon: #getIcon:;
		setSelected: #setSelectedNode:;
		frame: (0 @ 0 corner: 0.5 @ 0.9);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 21:48'!
buildWidgets

	| result |
	result := {self buildSvnElementTree.
	self buildRevisionList.
	self buildLogMessageText} asOrderedCollection.
	result addAll: self buildButtonsFromCommands.
	^ result! !

!SVNProjectBrowser methodsFor: 'commands' stamp: 'rkrk 4/10/2008 16:45'!
commandClasses

	^ {SVNCreateProjectCommand.

SVNCommitCommand. SVNUpdateCommand. SVNRevertCommand. 

SVNChooseAndAddClassCommand. SVNSetURLCommand. SVNSetWorkingCopyPathCommand. SVNCheckoutCommand.

SVNDeleteClass.}! !

!SVNProjectBrowser methodsFor: 'commands' stamp: 'rkrk 4/12/2008 11:32'!
commands
	
	^ self commandClasses collect: [:ea |
		ea
			on: self selectedNode
			for: self].! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:17'!
commitLogs

	commitLogs ifNil: [^ OrderedCollection new].
	^ commitLogs
! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'mu 3/26/2008 12:42'!
commitLogs: aCollection
	commitLogs := aCollection.
! !

!SVNProjectBrowser methodsFor: 'revision list window' stamp: 'pe 4/14/2008 15:29'!
determineCurrentCommitLog

	"The revisionList only saves strings not full objects.
	This is a workaround..."
	^ self commitLogs
		detect: [:ea | ea revisionAuthorDateString = self selectedCommitLogString asString]
		ifNone: [nil].! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'pe 4/14/2008 15:30'!
displayLogMessage

	| logMessageHeader logMessage |
	logMessageHeader := self displayLogMessageHeader.
	logMessage := self getCommentFor: self determineCurrentCommitLog.
	^ logMessageHeader , logMessage! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'rkrk 4/7/2008 02:23'!
displayLogMessageHeader

	^ 'Log-Message:' asText allBold,
		String cr.
! !

!SVNProjectBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 03:13'!
extent

	^ 600 @ 500! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:39'!
getChildrenOfNode: aNode

	^ aNode getChildren! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'mu 3/26/2008 12:53'!
getCommentFor: aCommitLog

	aCommitLog ifNil: [^ 'Select a versioned class or method'].
	^ aCommitLog comment.! !

!SVNProjectBrowser methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 05:34'!
getIcon: node

	^ OBMorphicIcons iconNamed: node svnElement status statusKind! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
getPathToSelectedNode

	| aCollection aNode |
	aNode := self selectedNode.
	aCollection := OrderedCollection new.
	[aNode notNil] whileTrue: [
		aCollection addLast: aNode.
		aNode := aNode parent].
	^ aCollection! !

!SVNProjectBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 03:13'!
label

	^ 'SqueakSVN Project Browser'! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
labelOfNode: aNode 

	^ aNode getLabel! !

!SVNProjectBrowser methodsFor: 'derived accessing' stamp: 'rkrk 4/7/2008 04:09'!
listOfProjectNodes: svnProjects

	self projectNodes: (svnProjects collect: [:each |
		SVNProjectNode element: each]).
! !

!SVNProjectBrowser methodsFor: 'revision list window' stamp: 'pe 4/14/2008 13:50'!
listRevisionsForSelectedElement

	| svnElement |
	self selectedNode ifNil: [^ #('No SVNElement selected')].
	svnElement := self selectedNode svnElement svnDirectoryEntry.
	svnElement ifNil: [^ #('Select a versioned Class or a vesioned method')]. 
	self commitLogs: svnElement commitLogs.
	self commitLogs ifEmpty: [^ #('No Commit-Logs available')].
	^ self commitLogs collect: [ :each | 
		(self selectedNode svnElement svnInfo revision number = each revision)
		ifTrue:[each revisionAuthorDateString asText allBold]
		ifFalse:[each revisionAuthorDateString]]! !

!SVNProjectBrowser methodsFor: 'menus' stamp: 'rkrk 4/12/2008 11:19'!
menuOn: aMenu 
	
	self commands do: [:ea | ea addItemToMenu: aMenu].
	^ aMenu! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
nodeHasChildren: aNode

	^ (self getChildrenOfNode: aNode) notEmpty! !

!SVNProjectBrowser methodsFor: 'message handling' stamp: 'cop 2/26/2008 12:41'!
perform: selector orSendTo: otherTarget
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 03:40'!
projectNodes
	^ projectNodes! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 03:48'!
projectNodes: anObject
	projectNodes := anObject asOrderedCollection! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:20'!
selectedCommitLogString

	^ selectedCommitLogString! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:21'!
selectedCommitLogString: aString

	selectedCommitLogString := aString.! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'mu 3/18/2008 17:51'!
selectedNode
	^ selectedNode! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 02:27'!
selectedNode: aNode 

	selectedNode := aNode! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'pe 4/14/2008 15:34'!
setSelectedCommitLogString: obj

	"callback for revision list"
	self selectedCommitLogString: obj.
	self updateLogMessageWindow.! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'pe 4/14/2008 15:34'!
setSelectedNode: aNode 

	"callback for elmentTree"
	self selectedNode: aNode.
	self updateRevisionList.
	self setSelectedCommitLogString: ''.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/7/2008 04:03'!
update: anObject

	self updateTree! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/7/2008 03:19'!
updateLogMessageWindow

	self changed: #displayLogMessage.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'pe 4/14/2008 15:32'!
updateRevisionList

	"call the revision list's '#list: selector"
	self changed: #listRevisionsForSelectedElement.
	self updateLogMessageWindow.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rt 3/27/2008 18:01'!
updateTree

	self changed: #projectNodes.
	self changed: #getPathToSelectedNode.! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
blueColor
	^ Color blue lighter lighter  ! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 20:41'!
buildMainWindow

	^ self builder pluggableWindowSpec new
		model: self;
		extent: self extent;
		label: self label;
		children: self buildWidgets;
		yourself.! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:34'!
buildWidgets

	^ #()! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 20:41'!
buildWith: aBuilder
"This method is expected by the ToolBuilder. It creates the main widget specification.
Subclasses of SVNTool should create their sub widgets in the #buildWidgets"

	self builder: aBuilder.
	self	window: (self builder build: (self buildMainWindow)).
	^ self window! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:20'!
builder

	^ builder ifNil: [builder := ToolBuilder default].! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:36'!
builder: anObject
	builder := anObject! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 4/6/2008 00:59'!
close

	self builder close: self window.! !

!SVNTool methodsFor: 'default' stamp: 'rkrk 4/6/2008 21:59'!
extent

	^ 300 @ 300! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
grayColor
	^ Color gray  ! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
greenColor

	^ Color green! !

!SVNTool methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:19'!
label

	^ 'I have no label'! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 4/6/2008 02:20'!
open

	self builder open: self.! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
redColor

	^ Color red! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:37'!
window
	^ window! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:37'!
window: anObject
	window := anObject! !

Object subclass: #SVNUser
	instanceVariableNames: 'user password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNUser class methodsFor: 'instance creating' stamp: 'rt 3/30/2008 20:55'!
user: aString password: aSecString

	^self new
		user: aString password: aSecString! !

!SVNUser methodsFor: 'comparing' stamp: 'rt 3/30/2008 20:58'!
= obj
	^self species = obj species
		and: [self user = obj user]
		and: [self password = obj password]! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:53'!
password
	^ password! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
password: aSecString
	password := aSecString.! !

!SVNUser methodsFor: 'printing' stamp: 'rt 4/8/2008 14:54'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	aStream nextPutAll: '''', self user , ''', ''' , self password , ''''.
	aStream nextPut: $).! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:53'!
user
	^ user! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
user: aString
	user := aString.! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
user: aString password: aSecString
	self user: aString.
	self password: aSecString.! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 15:37'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'test 3/20/2008 04:00'!
callStringTest02

	<primitive: 'stringTest02' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 22:38'!
onlyATest

	<primitive: 'onlyATest' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:27'!
primSvnGetHeadRevision: target

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/20/2008 13:09'!
primSvnInfo: target

	<primitive: 'svnAlternativeGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/3/2008 14:56'!
primSvnStatus: target revisionKind: revKind revisionNumber: revNum storeInArray: arr

	<primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

Object subclass: #TestAnn
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!TestAnn class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 01:05'!
with: aNode

	^ self new
		node: aNode;
		yourself.! !

!TestAnn methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 01:06'!
node
	^ node! !

!TestAnn methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 01:06'!
node: anObject
	node := anObject! !

Object subclass: #TestEnvAcs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!TestEnvAcs commentStamp: 'rt 4/14/2008 00:18' prior: 0!
A TestEnvAcs is an accessor to the TestEnvPlg. You can use the TestEnvPlg to create and checkout a subversion repository.!

!TestEnvAcs class methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 00:36'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop

	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'TestEnvPlg'>
	^ self primitiveFailed! !

!TestEnvAcs class methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 15:41'!
svnCreateRepositoryOn: path

	<primitive: 'svnAdminCreateRepositoryOn' module: 'TestEnvPlg'>
	^ self primitiveFailed! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
added
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'mu 3/31/2008 15:28'!
conflicted

	"do it: [self new conflicted asMorph openInHand]"
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3789677025 4294967295 4292993505 4294967295 3789684735 4292993535 4294967295 4292993535 4293001215 4294967295 4294959615 3791650815 3789677025 4294959585 3791650815 3789677025 3789677025 3791650815 3789677025 3789677025 3791650815 3789677055 4294959585 4293001215 4294967295 4294959615 4292993535 4294967295 4292993535 4294959585 3789677025 3789684735 4294967295 3789677025 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:42'!
doesNotUnderstand: selector

	^ self unknown! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:00'!
errorIcon

	"do it: [self new errorIcon asMorph openInHand]"
	^((ColorForm
	extent: 11@18
	depth: 8
	fromArray: #( 6974136 1785358954 1785358848 6994104 3099113656 3099093504 6994104 3099113656 3099113472 1785379000 3099113656 3099093504 1785379000 3093981802 1785358848 1785379000 3099113656 1785358848 1785379000 3099113656 3093981696 1785379000 3099113656 1785358848 1785379000 3093981802 1785358848 1785379000 3093981802 1785358848 1785379000 3099113656 1785358848 1785379000 3099113656 3093981696 1785379000 3099113656 1785358848 1785379000 3093981802 1785358848 1790490808 3093981802 1785358848 1785379000 1785358954 1785358848)
	offset: 697@527)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
modified
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3941264106 4294967295 4294961898 3942645738 3941269503 4293585642 4294967295 3941264127 4293585642 4294967295 3941264127 3941264106 4294967295 3941264106 3941264106 4294967295 3941264106 3941264106 3942645738 3941264106 3941264106 3941264106 3941264106 4293585642 3942645738 3941264127 4293585642 4294967295 3941264127 4294961898 3942645738 3941269503 4294967295 3941264106 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'cop 4/8/2008 19:21'!
normal
	^ (ColorForm 
		extent: 12 @ 12
		depth: 8
		fromArray: #(
				4294967295
				2038004089
				4294967295
				4286151033
				2038004089
				2038038527
				4286151033
				2038004089
				2038004223
				4286151033
				2038004089
				2046786047
				2038004089
				2038004223
				4286151033
				2038004089
				2038038527
				2038004089
				2046820217
				4294967161
				2038004089
				2046820351
				4294932857
				2038004089
				4286185471
				4286151033
				2038004223
				4286151167
				2038004089
				2038004223
				4294932857
				2038004089
				2038038527
				4294967295
				2038004089
				4294967295
			)
		offset: 0 @ 0) colorsFromArray: #(
			#()
			#(0.0 0.0 0.0 )
			#(1.0 1.0 1.0 )
			#(0.5 0.5 0.5 )
			#(1.0 0.0 0.0 )
			#(0.0 1.0 0.0 )
			#(0.0 0.0 1.0 )
			#(0.0 1.0 1.0 )
			#(1.0 1.0 0.0 )
			#(1.0 0.0 1.0 )
			#(0.125 0.125 0.125 )
			#(0.25 0.25 0.25 )
			#(0.375 0.375 0.375 )
			#(0.625 0.625 0.625 )
			#(0.75 0.75 0.75 )
			#(0.875 0.875 0.875 )
			#(0.031 0.031 0.031 )
			#(0.063 0.063 0.063 )
			#(0.094 0.094 0.094 )
			#(0.156 0.156 0.156 )
			#(0.188 0.188 0.188 )
			#(0.219 0.219 0.219 )
			#(0.282 0.282 0.282 )
			#(0.313 0.313 0.313 )
			#(0.344 0.344 0.344 )
			#(0.407 0.407 0.407 )
			#(0.438 0.438 0.438 )
			#(0.469 0.469 0.469 )
			#(0.531 0.531 0.531 )
			#(0.562 0.562 0.562 )
			#(0.593 0.593 0.593 )
			#(0.656 0.656 0.656 )
			#(0.687 0.687 0.687 )
			#(0.718 0.718 0.718 )
			#(0.781 0.781 0.781 )
			#(0.812 0.812 0.812 )
			#(0.844 0.844 0.844 )
			#(0.906 0.906 0.906 )
			#(0.937 0.937 0.937 )
			#(0.969 0.969 0.969 )
			#(0.0 0.0 0.0 )
			#(0.0 0.199 0.0 )
			#(0.0 0.4 0.0 )
			#(0.0 0.599 0.0 )
			#(0.0 0.8 0.0 )
			#(0.0 1.0 0.0 )
			#(0.0 0.0 0.199 )
			#(0.0 0.199 0.199 )
			#(0.0 0.4 0.199 )
			#(0.0 0.599 0.199 )
			#(0.0 0.8 0.199 )
			#(0.0 1.0 0.199 )
			#(0.0 0.0 0.4 )
			#(0.0 0.199 0.4 )
			#(0.0 0.4 0.4 )
			#(0.0 0.599 0.4 )
			#(0.0 0.8 0.4 )
			#(0.0 1.0 0.4 )
			#(0.0 0.0 0.599 )
			#(0.0 0.199 0.599 )
			#(0.0 0.4 0.599 )
			#(0.0 0.599 0.599 )
			#(0.0 0.8 0.599 )
			#(0.0 1.0 0.599 )
			#(0.0 0.0 0.8 )
			#(0.0 0.199 0.8 )
			#(0.0 0.4 0.8 )
			#(0.0 0.599 0.8 )
			#(0.0 0.8 0.8 )
			#(0.0 1.0 0.8 )
			#(0.0 0.0 1.0 )
			#(0.0 0.199 1.0 )
			#(0.0 0.4 1.0 )
			#(0.0 0.599 1.0 )
			#(0.0 0.8 1.0 )
			#(0.0 1.0 1.0 )
			#(0.199 0.0 0.0 )
			#(0.199 0.199 0.0 )
			#(0.199 0.4 0.0 )
			#(0.199 0.599 0.0 )
			#(0.199 0.8 0.0 )
			#(0.199 1.0 0.0 )
			#(0.199 0.0 0.199 )
			#(0.199 0.199 0.199 )
			#(0.199 0.4 0.199 )
			#(0.199 0.599 0.199 )
			#(0.199 0.8 0.199 )
			#(0.199 1.0 0.199 )
			#(0.199 0.0 0.4 )
			#(0.199 0.199 0.4 )
			#(0.199 0.4 0.4 )
			#(0.199 0.599 0.4 )
			#(0.199 0.8 0.4 )
			#(0.199 1.0 0.4 )
			#(0.199 0.0 0.599 )
			#(0.199 0.199 0.599 )
			#(0.199 0.4 0.599 )
			#(0.199 0.599 0.599 )
			#(0.199 0.8 0.599 )
			#(0.199 1.0 0.599 )
			#(0.199 0.0 0.8 )
			#(0.199 0.199 0.8 )
			#(0.199 0.4 0.8 )
			#(0.199 0.599 0.8 )
			#(0.199 0.8 0.8 )
			#(0.199 1.0 0.8 )
			#(0.199 0.0 1.0 )
			#(0.199 0.199 1.0 )
			#(0.199 0.4 1.0 )
			#(0.199 0.599 1.0 )
			#(0.199 0.8 1.0 )
			#(0.199 1.0 1.0 )
			#(0.4 0.0 0.0 )
			#(0.4 0.199 0.0 )
			#(0.4 0.4 0.0 )
			#(0.4 0.599 0.0 )
			#(0.4 0.8 0.0 )
			#(0.4 1.0 0.0 )
			#(0.4 0.0 0.199 )
			#(0.4 0.199 0.199 )
			#(0.4 0.4 0.199 )
			#(0.4 0.599 0.199 )
			#(0.4 0.8 0.199 )
			#(0.4 1.0 0.199 )
			#(0.4 0.0 0.4 )
			#(0.4 0.199 0.4 )
			#(0.4 0.4 0.4 )
			#(0.4 0.599 0.4 )
			#(0.4 0.8 0.4 )
			#(0.4 1.0 0.4 )
			#(0.4 0.0 0.599 )
			#(0.4 0.199 0.599 )
			#(0.4 0.4 0.599 )
			#(0.4 0.599 0.599 )
			#(0.4 0.8 0.599 )
			#(0.4 1.0 0.599 )
			#(0.4 0.0 0.8 )
			#(0.4 0.199 0.8 )
			#(0.4 0.4 0.8 )
			#(0.4 0.599 0.8 )
			#(0.4 0.8 0.8 )
			#(0.4 1.0 0.8 )
			#(0.4 0.0 1.0 )
			#(0.4 0.199 1.0 )
			#(0.4 0.4 1.0 )
			#(0.4 0.599 1.0 )
			#(0.4 0.8 1.0 )
			#(0.4 1.0 1.0 )
			#(0.599 0.0 0.0 )
			#(0.599 0.199 0.0 )
			#(0.599 0.4 0.0 )
			#(0.599 0.599 0.0 )
			#(0.599 0.8 0.0 )
			#(0.599 1.0 0.0 )
			#(0.599 0.0 0.199 )
			#(0.599 0.199 0.199 )
			#(0.599 0.4 0.199 )
			#(0.599 0.599 0.199 )
			#(0.599 0.8 0.199 )
			#(0.599 1.0 0.199 )
			#(0.599 0.0 0.4 )
			#(0.599 0.199 0.4 )
			#(0.599 0.4 0.4 )
			#(0.599 0.599 0.4 )
			#(0.599 0.8 0.4 )
			#(0.599 1.0 0.4 )
			#(0.599 0.0 0.599 )
			#(0.599 0.199 0.599 )
			#(0.599 0.4 0.599 )
			#(0.599 0.599 0.599 )
			#(0.599 0.8 0.599 )
			#(0.599 1.0 0.599 )
			#(0.599 0.0 0.8 )
			#(0.599 0.199 0.8 )
			#(0.599 0.4 0.8 )
			#(0.599 0.599 0.8 )
			#(0.599 0.8 0.8 )
			#(0.599 1.0 0.8 )
			#(0.599 0.0 1.0 )
			#(0.599 0.199 1.0 )
			#(0.599 0.4 1.0 )
			#(0.599 0.599 1.0 )
			#(0.599 0.8 1.0 )
			#(0.599 1.0 1.0 )
			#(0.8 0.0 0.0 )
			#(0.8 0.199 0.0 )
			#(0.8 0.4 0.0 )
			#(0.8 0.599 0.0 )
			#(0.8 0.8 0.0 )
			#(0.8 1.0 0.0 )
			#(0.8 0.0 0.199 )
			#(0.8 0.199 0.199 )
			#(0.8 0.4 0.199 )
			#(0.8 0.599 0.199 )
			#(0.8 0.8 0.199 )
			#(0.8 1.0 0.199 )
			#(0.8 0.0 0.4 )
			#(0.8 0.199 0.4 )
			#(0.8 0.4 0.4 )
			#(0.8 0.599 0.4 )
			#(0.8 0.8 0.4 )
			#(0.8 1.0 0.4 )
			#(0.8 0.0 0.599 )
			#(0.8 0.199 0.599 )
			#(0.8 0.4 0.599 )
			#(0.8 0.599 0.599 )
			#(0.8 0.8 0.599 )
			#(0.8 1.0 0.599 )
			#(0.8 0.0 0.8 )
			#(0.8 0.199 0.8 )
			#(0.8 0.4 0.8 )
			#(0.8 0.599 0.8 )
			#(0.8 0.8 0.8 )
			#(0.8 1.0 0.8 )
			#(0.8 0.0 1.0 )
			#(0.8 0.199 1.0 )
			#(0.8 0.4 1.0 )
			#(0.8 0.599 1.0 )
			#(0.8 0.8 1.0 )
			#(0.8 1.0 1.0 )
			#(1.0 0.0 0.0 )
			#(1.0 0.199 0.0 )
			#(1.0 0.4 0.0 )
			#(1.0 0.599 0.0 )
			#(1.0 0.8 0.0 )
			#(1.0 1.0 0.0 )
			#(1.0 0.0 0.199 )
			#(1.0 0.199 0.199 )
			#(1.0 0.4 0.199 )
			#(1.0 0.599 0.199 )
			#(1.0 0.8 0.199 )
			#(1.0 1.0 0.199 )
			#(1.0 0.0 0.4 )
			#(1.0 0.199 0.4 )
			#(1.0 0.4 0.4 )
			#(1.0 0.599 0.4 )
			#(1.0 0.8 0.4 )
			#(1.0 1.0 0.4 )
			#(1.0 0.0 0.599 )
			#(1.0 0.199 0.599 )
			#(1.0 0.4 0.599 )
			#(1.0 0.599 0.599 )
			#(1.0 0.8 0.599 )
			#(1.0 1.0 0.599 )
			#(1.0 0.0 0.8 )
			#(1.0 0.199 0.8 )
			#(1.0 0.4 0.8 )
			#(1.0 0.599 0.8 )
			#(1.0 0.8 0.8 )
			#(1.0 1.0 0.8 )
			#(1.0 0.0 1.0 )
			#(1.0 0.199 1.0 )
			#(1.0 0.4 1.0 )
			#(1.0 0.599 1.0 )
			#(1.0 0.8 1.0 )
			#(1.0 1.0 1.0 )
		)! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:42'!
unknown

	^  self unversioned! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:41'!
unversioned

	^  (Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 0 0 4294967295 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 0 0 0 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 0 0 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 0 0 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 0 0 0 0)
	offset: 819@706)! !

!OBClassNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:25'!
belongsToCurrentSvnProject

	self doOnlyOnce: [self halt].
	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNClass forExistingClass: self theClass).! !

!OBClassNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:20'!
svnElement

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment findSvnClassFor: self theClass.! !

OBFilter subclass: #OBSVNStatusIconClassFilter
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNStatusIconClassFilter methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:57'!
currentProject
	^currentProject! !

!OBSVNStatusIconClassFilter methodsFor: 'accessing' stamp: 'cop 4/9/2008 16:14'!
currentProject: aSVNProject
	currentProject := aSVNProject! !

!OBSVNStatusIconClassFilter methodsFor: 'filtering' stamp: 'rkrk 4/14/2008 02:43'!
icon: aSymbol forNode: aNode 

	self currentProject ifNil: [^ #blank].
	^ (self svnElementFrom: aNode)
		ifNil: [#blank]
		ifNotNilDo: [:svnElement | svnElement status statusKind].! !

!OBSVNStatusIconClassFilter methodsFor: 'updating' stamp: 'cop 4/9/2008 11:11'!
selectedProjectChanged: anAnn
	self currentProject: anAnn currentProject! !

!OBSVNStatusIconClassFilter methodsFor: 'updating' stamp: 'cop 4/9/2008 16:30'!
subscribeAt: aBrowser
	aBrowser announcer
		observe: SVNCurrentProjectChanged
		send: #selectedProjectChanged:
		to: self! !

!OBSVNStatusIconClassFilter methodsFor: 'filtering' stamp: 'rkrk 4/12/2008 22:05'!
svnElementFrom: aNode

	^ self currentProject versionedClasses
		detect: [:ea | ea theName = aNode name]
		ifNone: [nil].! !

OBSVNStatusIconClassFilter subclass: #OBSVNStatusIconMethodFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNStatusIconMethodFilter methodsFor: 'filtering' stamp: 'rkrk 4/12/2008 13:21'!
svnElementFrom: aNode

	^ self currentProject allVersionedMethods
		detect: [:ea | ea theName = aNode selector asString]
		ifNone: [nil].! !

OBFilter subclass: #SVNOBEnvironmentFilter
	instanceVariableNames: 'svnEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNOBEnvironmentFilter class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 03:52'!
with: svnEnvironment

	^ self new
		svnEnvironment: svnEnvironment;
		yourself.! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 11:03'!
displayString: aString forParent: pNode child: cNode

	self metaNode allChildrenForNode: pNode.
	^ aString asText! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 03:44'!
initialize

	super initialize.
	self svnEnvironment: SVNSystemBrowserEnvironment forAllProjects.! !

!SVNOBEnvironmentFilter methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 03:44'!
svnEnvironment
	^ svnEnvironment! !

!SVNOBEnvironmentFilter methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 03:44'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 02:28'!
wantsButton

	^ true! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 12:02'!
belongsToCurrentSvnProject

	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNMethod forExistingMethod: self reference compiledMethod).! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:51'!
svnElement

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment findSvnMethodForMethodRef: self reference.! !

OBSystemBrowser subclass: #OBSVNSystemBrowser
	instanceVariableNames: 'svnEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 4/9/2008 13:47'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel
	^ (OBSVNMetagraphBuilder
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 3/6/2008 13:26'!
definitionPanel
	^ OBSVNDefinitionPanel new! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:33'!
initialize

	"self initialize"
	self registerInOpenMenu.! !

!OBSVNSystemBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/14/2008 02:30'!
metaNode: metaNode root: rootNode selection: selectedNode panels: panels

	^ (super metaNode: metaNode root: rootNode selection: selectedNode panels: panels)
		registerSVNFilters;
		yourself.! !

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 4/8/2008 19:39'!
panels
	^ super panels asOrderedCollection
		addFirst: SVNOBProjectSelectionPanel new;
		yourself! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:34'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNSystemBrowser'. {self. #open}}.! !

!OBSVNSystemBrowser methodsFor: 'opening' stamp: 'rkrk 4/15/2008 04:01'!
close

	super close.
	svnEnvironment notifyAboutSystemChanges: false.! !

!OBSVNSystemBrowser methodsFor: 'commands' stamp: 'cop 3/6/2008 12:09'!
cmdMultiView
	^ OBSVNCmdMultiView! !

!OBSVNSystemBrowser methodsFor: 'commands' stamp: 'rkrk 4/12/2008 12:04'!
cmdSVNAdd

	^ {"OBSVNCmdAddElement"}! !

!OBSVNSystemBrowser methodsFor: 'commands' stamp: 'rkrk 4/13/2008 01:15'!
cmdSvn

	^ {SVNCommitCommand. SVNUpdateCommand. SVNRevertCommand. SVNDeleteClass.

SVNAddToCurrentProjectCommand}! !

!OBSVNSystemBrowser methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 21:52'!
definitionPanel
	^ self class definitionPanel! !

!OBSVNSystemBrowser methodsFor: 'demo hack' stamp: 'rkrk 4/15/2008 06:44'!
newNode: ann

	| class aNode |
	aNode := ann node.
	svnEnvironment currentProject ifNil: [^ self].
	(aNode isKindOf: OBMethodNode)
		ifTrue: [
			class := svnEnvironment findSvnClassFor: aNode theClass.
			(class isNil or: [(svnEnvironment currentProject includes: class) not])
				ifTrue: [svnEnvironment currentProject addMethod: aNode reference compiledMethod]
				ifFalse: [class addMethod: (SVNMethod forExistingMethod: aNode reference compiledMethod)].
			svnEnvironment currentProject store.
			self announce: (OBNodeChanged node: aNode).
			^ self].
	(aNode isKindOf: OBClassNode) ifFalse: [^ self].
	class := svnEnvironment findSvnClassFor: aNode theClass.
	class ifNotNil: [^ self].
	svnEnvironment currentProject addClass: aNode theClass.
	svnEnvironment currentProject store.
	self announce: (OBNodeChanged node: aNode).! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 4/11/2008 19:41'!
registerSVNFilters

	self subscribeEdgesRecursivly: self navigationPanel root metaNode edges! !

!OBSVNSystemBrowser methodsFor: 'initializing' stamp: 'rkrk 4/15/2008 04:22'!
setMetaNode: aMetaNode node: aNode
	| filter |
	svnEnvironment := SVNSystemBrowserEnvironment forAllProjects.
	svnEnvironment notifyAboutSystemChanges: true.
	svnEnvironment subscribeWithAnnouncer: self announcer.
	filter := SVNOBEnvironmentFilter with: svnEnvironment.
	aMetaNode svnWithAllChildrenDo: [ :each |
		each addFilter: filter].
	super setMetaNode: aMetaNode node: aNode! !

!OBSVNSystemBrowser methodsFor: 'demo hack' stamp: 'rkrk 4/15/2008 06:28'!
subscribe

	super subscribe.
	(self announcer)
		observe: OBNodeCreated
		send: #newNode:
		to: self! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'cop 4/9/2008 16:37'!
subscribeEdges: aCol
	aCol do: [:each| (each class canPerform: #subscribeAt:)
		ifTrue: [each subscribeAt: self ] ]! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 4/11/2008 19:42'!
subscribeEdgesRecursivly: aCol

	aCol do: [:each |
		self subscribeEdgesRecursivly: each metaNode edges.
		self subscribeEdges: each metaNode filters].! !

PluggableMultiColumnListMorph subclass: #OBSVNBlameMorphWithTable
	instanceVariableNames: 'blame getTextSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/3/2008 13:07'!
blame
	^blame! !

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/3/2008 13:07'!
blame: aBool
	blame := aBool! !

!OBSVNBlameMorphWithTable methodsFor: 'functionality' stamp: 'cop 4/3/2008 14:10'!
checkForBlame
	(model getDefinition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^false]
				ifTrue: [^model definition blame ]! !

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/7/2008 10:59'!
getTextSelector
	^getTextSelector! !

!OBSVNBlameMorphWithTable methodsFor: 'functionality' stamp: 'cop 4/7/2008 10:55'!
tableChangedHandling
	self checkForBlame  ifTrue: [ self listChanged.
								  self show. ]! !

!OBSVNBlameMorphWithTable methodsFor: 'accessing' stamp: 'cop 4/7/2008 10:59'!
textSelector: aSymbol
	getTextSelector := aSymbol! !

!OBSVNBlameMorphWithTable methodsFor: 'updating' stamp: 'cop 4/7/2008 11:06'!
update: aSymbol
	aSymbol == getTextSelector 
	ifTrue: 
		[^self hide].
	aSymbol == getListSelector 
	ifTrue: 
		[^self tableChangedHandling].
	super update: aSymbol.! !

OBTextPanel subclass: #SVNOBProjectSelectionPanel
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/11/2008 19:48'!
accept: aText notifying: anObject 

	self currentProject: (SVNProject allInstances
		detect:[:each | each theName = aText asString]
		ifNone: [nil]).! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/11/2008 19:49'!
announceCurrrentProjectChanged

	self
		announce: (SVNCurrentProjectChanged forProject: self currentProject);
		announce: OBRefreshRequired new.! !

!SVNOBProjectSelectionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 17:27'!
buildOn: aBuilder 
	^ aBuilder textfield: self with: []! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'cop 4/8/2008 18:02'!
currentProject
	^currentProject! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/11/2008 19:50'!
currentProject: aSVNProject

	currentProject := aSVNProject.
	self changed: #text.
	self announceCurrrentProjectChanged! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'cop 4/14/2008 09:07'!
menu: aMenu shifted: aBoolean selection: aTextSelection 
	aMenu 
		add: self noProjectText
		selector: #currentProject:
		argument: nil.
	SVNProject allInstances isEmpty ifFalse: [aMenu addLine].
	SVNProject allInstances do: [:each|
		aMenu
		add: each theName
		selector: #currentProject:
		argument: each ].
	^aMenu
	! !

!SVNOBProjectSelectionPanel methodsFor: 'text' stamp: 'cop 4/10/2008 12:00'!
noProjectText
	^'No SVNProject selected'! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'cop 4/8/2008 17:42'!
selection
	^ 1 to: 0! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'cop 4/10/2008 11:58'!
text
	^(currentProject ifNil: [^self noProjectText]) theName! !

!SVNOBProjectSelectionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 19:44'!
vResizing
	^ #shrinkWrap! !

OBCommand subclass: #OBSVNCmdAddElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 4/10/2008 16:54'!
cluster
	^ #SVN! !

!OBSVNCmdAddElement methodsFor: 'execution' stamp: 'mu 4/3/2008 16:43'!
execute
	
	| projectName project |
	projectName := OBTextRequest
				prompt: 'Please type in the name of an existing SVNProject' 
				template: ''.
				
	"self halt."
	project := SVNProject allInstances
		detect: [:each | each theName = projectName]
		ifNone: [^ self].

	self flag: #TODO. "quick hack for now"
	(target isKindOf: OBClassNode) ifTrue: [project addClass: target theClass].
	(target isKindOf: OBClassCategoryNode) ifTrue: [project addCategory: target name asString].! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:10'!
group
	^ #SVN! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:19'!
icon
	^ #smallOkIcon! !

!OBSVNCmdAddElement methodsFor: 'testing' stamp: 'rkrk 4/12/2008 12:03'!
isActive

	^ ((target isKindOf: OBMethodNode) 
			or: [target isKindOf: OBClassNode] 
			or: [target isKindOf: OBClassCategoryNode])
		and: [requestor isSelected: target]! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:13'!
label
	^ 'add to SVNProject...'! !

!FileDirectory methodsFor: '*SqueakSVN' stamp: 'rkrk 3/16/2008 06:33'!
deleteRecursivelyPlatformIndependent

	| p |
	"You will need the recursiveDelete.bat in a path which OSProcess can reach."
	self exists ifFalse: [^ self].
	SmalltalkImage current platformName =  'Win32'
		ifTrue: [p := ExternalOSProcess command:
			'recursiveDelete.bat ' , self pathName.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 5) wait]].
	self exists ifTrue: [self recursiveDelete].! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:17'!
svnWithAllChildrenDo: aBlock

	"Copied from OBRefactory"
	self withAllChildrenDo: aBlock seen: IdentitySet new! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:17'!
svnWithAllChildrenDo: aBlock seen: aSet

	"Copied from OBRefactory"
	(aSet includes: self) ifTrue: [ ^ self ].
	aSet add: self.
	aBlock value: self.
	self edges do: [ :each | each metaNode withAllChildrenDo: aBlock seen: aSet ]! !
SVNTestDirectoryManager initialize!
SVNCreateRepositoryTool initialize!
SVNProjectBrowser initialize!
OBSVNSystemBrowser initialize!
